public final class Mapper088 extends Mapper {


    private int regs[] = new int[1];
	
    /////////////////////////////////////////////////////////////////////
    // Mapper 88
	// hSXsbg		iRn̈ꕔ
    public Mapper088(NESCore nes) {
        super(nes);
    }

    public final void Reset() {

        // Init ExSound
        //parent_NES->apu->SelectExSound(2);

        // set CPU bank pointers
        set_CPU_banks(0, 1, num_8k_ROM_banks - 2, num_8k_ROM_banks - 1);

        // set PPU bank pointers
        if(num_1k_VROM_banks >= 8)
		{
			set_PPU_banks(0,1,2,3,4,5,6,7);
		}
    }
    public final void MemoryWrite(int addr, int data)
	{
	  switch(addr)
	  {
	    case 0x8000:
	      {
	        regs[0] = data;
			if(nes.crc == 0xc1b6b2a6)	// Devil Man (J)
			{
				if( (data&0x40)!=0 ) set_mirroring(1,1,1,1);
				else	        set_mirroring(0,0,0,0);
			}
	      }
	      break;

	    case 0x8001:
	      {
	        switch(regs[0] & 0x07)
	        {
	          case 0x00:
	            {
	              set_PPU_bank0(data & 0xFE);
	              set_PPU_bank1((data & 0xFE)+1);
	            }
	            break;

	          case 0x01:
	            {
	              set_PPU_bank2(data & 0xFE);
	              set_PPU_bank3((data & 0xFE)+1);
	            }
	            break;

	          case 0x02:
	            {
	              set_PPU_bank4(data+0x40);
	            }
	            break;

	          case 0x03:
	            {
	              set_PPU_bank5(data+0x40);
	            }
	            break;

	          case 0x04:
	            {
	              set_PPU_bank6(data+0x40);
	            }
	            break;

	          case 0x05:
	            {
	              set_PPU_bank7(data+0x40);
	            }
	            break;

	          case 0x06:
	            {
	              set_CPU_bank4(data);
	            }
	            break;

	          case 0x07:
	            {
	              set_CPU_bank5(data);
	            }
	            break;
	        }
	      }
	      break;

	    case 0xC000:
	      {
	        if(data!=0)
	        {
	          set_mirroring(1,1,1,1);
	        }
	        else
	        {
	          set_mirroring(0,0,0,0);
	        }
	      }
	      break;
	  }
	}
}
