public final class Mapper095 extends Mapper {
	
    public Mapper095(NESCore nes) {
        super(nes);
    }
    
	  private int regs[] = new int[1];
	  int prg0,prg1;
	  int chr01,chr23,chr4,chr5,chr6,chr7;

    /////////////////////////////////////////////////////////////////////
    // Mapper 95 Ȃ
    // hSoX^[
    
	  public final int chr_swap() { return regs[0] & 0x80; }
	  public final int prg_swap() { return regs[0] & 0x40; }

	  void MMC3_set_CPU_banks()
	  {
	    if(prg_swap()!=0)
	    {
	      set_CPU_banks(num_8k_ROM_banks-2,prg1,prg0,num_8k_ROM_banks-1);
	    }
	    else
	    {
	      set_CPU_banks(prg0,prg1,num_8k_ROM_banks-2,num_8k_ROM_banks-1);
	    }
	  }

	  void MMC3_set_PPU_banks()
	  {
	    if(num_1k_VROM_banks!=0)
	    {
	      if(chr_swap()!=0)
	      {
	        set_PPU_banks(chr4,chr5,chr6,chr7,chr01,chr01+1,chr23,chr23+1);
	      }
	      else
	      {
	        set_PPU_banks(chr01,chr01+1,chr23,chr23+1,chr4,chr5,chr6,chr7);
	      }
	    }
	  }    
    
    public final void Reset() {
	  regs[0] = 0x00;

	  // set CPU bank pointers
	  prg0 = 0;
	  prg1 = 1;
	  MMC3_set_CPU_banks();

	  // set VROM banks
	  if(num_1k_VROM_banks!=0)
	  {
	    chr01 = 0;
	    chr23 = 2;
	    chr4  = 4;
	    chr5  = 5;
	    chr6  = 6;
	    chr7  = 7;
	    MMC3_set_PPU_banks();
	  }
	  else
	  {
	    chr01 = chr23 = chr4 = chr5 = chr6 = chr7 = 0;
	  }
    }

	public final void MemoryWrite(int addr, int data) {
	  switch(addr & 0xE001)
	  {
	    case 0x8000:
	      {
	        regs[0] = data;
	        MMC3_set_PPU_banks();
	        MMC3_set_CPU_banks();
	      }
	      break;

	    case 0x8001:
	      {
	        int bank_num;

	        if(regs[0] <= 0x05)
	        {
	          if((data & 0x20)!=0)
	          {
	            set_mirroring(1,1,1,1);
	          }
	          else
	          {
	            set_mirroring(0,0,0,0);
	          }
	          data &= 0x1F;
	        }

	        bank_num = data;

	        switch(regs[0] & 0x07)
	        {
	          case 0x00:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                bank_num &= 0xfe;
	                chr01 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x01:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                bank_num &= 0xfe;
	                chr23 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x02:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                chr4 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x03:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                chr5 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x04:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                chr6 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x05:
	            {
	              if(num_1k_VROM_banks!=0)
	              {
	                chr7 = bank_num;
	                MMC3_set_PPU_banks();
	              }
	            }
	            break;

	          case 0x06:
	            {
	              prg0 = bank_num;
	              MMC3_set_CPU_banks();
	            }
	            break;

	          case 0x07:
	            {
	              prg1 = bank_num;
	              MMC3_set_CPU_banks();
	            }
	            break;
	        }
	      }
	      break;
	  }
	}

}
