import java.io.*;

import com.nttdocomo.ui.Graphics;

public final class NESCore_NP2 extends NESCore {
    /*************************************
        萔錾
    *************************************/
    public static final int REQUEST_START      = 0;
    public static final int REQUEST_RESET      = 1;
    public static final int REQUEST_STOP       = 2;
    public static final int REQUEST_LOAD       = 3;
    public static final int REQUEST_SAVE       = 4;
    public static final int REQUEST_CHDISK     = 5;
    public static final int REQUEST_WRDISK     = 6;
    public static final int REQUEST_SLEEP      = 7;
    
    public static final int UNKNOWN_RENDER     = 0;
    public static final int POST_ALL_RENDER    = 1; // XLC̖ߎsC_O
    public static final int PRE_ALL_RENDER     = 2; // _O̎sCXLC̖ߎs
    public static final int POST_RENDER        = 3; // \ԕ̖ߎsC_O
    public static final int PRE_RENDER         = 4; // _OsC\ԕ̖ߎs
    public static final int TILE_RENDER        = 5; // ^Cx[X_O
    
    public static final int MIRROR_HORIZ       = 0;
    public static final int MIRROR_VERT        = 1;
    public static final int MIRROR_FOUR_SCREEN = 2;

    public static final byte IRQ_FRAMEIRQ      = 0x01;
    public static final byte IRQ_DPCM          = 0x02;
    public static final byte IRQ_MAPPER        = 0x04;
    public static final byte IRQ_MAPPER2       = 0x08;
    public static final byte IRQ_TRIGGER       = 0x10;
    public static final byte IRQ_TRIGGER2      = 0x20;
    public static final byte IRQ_NMI           = 0x40;
    
    /*************************************
        o[ϐ
    *************************************/
    /* NX */
    //private final NESCanvas gui;
    //private NESApu audio;
    //public Mapper mapper;    
    //private final PSGi psgi;
    /* CPU WX^ */
    //private int A;
    //private int X;
    //private int Y;
    //private int S;
    //private int PC;
    //private int P_BI;
    //private int P_C;
    //private int P_ZN;
    //private int P_V;
    /* CPU  */
    //private int int_pending;
    //private int cyc_pending;
    /* [ */
    //public byte[][] cpu_map;
    //private byte[][] ROM;
    //public byte[] RAM;
    //public byte[] SRAM;
    //public int SRAM_SIZE;
    //public byte[][] DISK;
    //public byte[] BIOS;
    /* PPU [*/
    //private byte[][] ppu_map;
    //private int[] spr_ram;
    //private int[] pal_ram;
    //private byte[][] VROM;
    //public byte[][] VRAM;
    //private byte[] DUMMY_VROM;
    /* PPU LbV */
    //private int[][] VROM_CACHE;
    //private int[][] VRAM_CACHE;
    //private int[] DUMMY_VROM_CACHE;
    //private byte[][] CACHE_HIT;
    //private int[][] patpix;
    //private byte[][] patdirty;
    /* PPU WX^ */
    //private int PPU_R0;
    //public int PPU_R1;
    //private int PPU_R2;
    /* PPU  */
    private boolean blank_line;
    //private int loopy_t;
    //private int loopy_v;
    //private int loopy_x;
    /* PPU  */
    //private int bg_pattern_table_addr;
    //private int spr_pattern_table_addr;
    //private int spr_ram_rw_ptr;
    //private int ppu_addr_inc;
    //private boolean toggle_2005_2006;
    //private int read_2007_buffer;
    //private int frame_irq_enabled;
    /* pbg */
    //private final int[] nes_palette;
    //private int[] cur_palette;
    //private int[] zeroPalette_array;
    /* ROM  */
    //public int mapper_no;
    //public int num_16k_ROM_banks;
    //public int num_8k_VROM_banks;
    //public int num_DISK_banks;
    //public int mirroring;
    //public int crc;
    //private boolean vram_write_protect;
    //public boolean latch_mapper;
    //public boolean exgfx_mapper;
    //public boolean exclk_mapper;
    //private boolean disk_system;
    //private final int[] crc_table;
    /* CPU TCN */
    private int CYCLE_PER_LINE;
    private int DEFAULT_RENDER_METHOD;
    //private int cyc_normal;
    private int render_method;
    /* NESCore  */
    //private int request;
    //private int param;
    /* NESCore  */
    //public boolean exist;

    public NESCore_NP2(NESCanvas _gui, PSGi _psgi) {
        gui = _gui;
        psgi = _psgi;
        crc_table = new int[256];
        for (int n = 0; n < 256; n++) {
            int c = n;
            for (int k = 8; --k >= 0;) {
                if ((c & 1) != 0)
                    c = 0xedb88320 ^ (c >>> 1);
                else
                    c = c >>> 1;
            }
            crc_table[n] = c;
        }

        switch (gui.getApuNum()) {
            case 1 :
                audio = new NESApu1(this, gui, psgi);
                break;
            case 2 :
                audio = new NESApu2(this, gui, psgi);
                break;
            case 3 :
                audio = new NESApu_NP2(this, gui, psgi);
                break;
            default :
                break;
        }

        nes_palette =
                new int[] {
                    0xff787878,
                    0xff2000b0,
                    0xff2800b8,
                    0xff6010a0,
                    0xff982078,
                    0xffb01030,
                    0xffa03000,
                    0xff784000,
                    0xff485800,
                    0xff386800,
                    0xff386c00,
                    0xff306040,
                    0xff305080,
                    0xff000000,
                    0xff000000,
                    0xff000000,
                    0xffb0b0b0,
                    0xff4060f8,
                    0xff4040ff,
                    0xff9040f0,
                    0xffd840c0,
                    0xffd84060,
                    0xffe05000,
                    0xffc07000,
                    0xff888800,
                    0xff50a000,
                    0xff48a810,
                    0xff48a068,
                    0xff4090c0,
                    0xff000000,
                    0xff000000,
                    0xff000000,
                    0xffe8e8e8,
                    0xff60a0ff,
                    0xff5080ff,
                    0xffa070ff,
                    0xfff060ff,
                    -40784,
                    -34768,
                    -24576,
                    0xffe8d020,
                    0xff98e800,
                    0xff70f040,
                    0xff70e090,
                    0xff60d0e0,
                    0xff787878,
                    0xff000000,
                    0xff000000,
                    -1,
                    0xff90d0ff,
                    0xffa0b8ff,
                    0xffc0b0ff,
                    0xffe0b0ff,
                    -18200,
                    -14152,
                    -10080,
                    -3952,
                    0xffc8f080,
                    0xffa0f0a0,
                    0xffa0ffc8,
                    0xffa0fff0,
                    0xffa0a0a0,
                    0xff000000,
                    0xff000000,
                    };
    }

    public final void init() {
        cpu_map = new byte[8][];
        ROM = null;
        RAM = new byte[0x0800];
        SRAM = new byte[0x2000];
        SRAM_SIZE = 0x2000;
        DISK = null;
        BIOS = null;
        ppu_map = new byte[12][];
        spr_ram = new int[256];
        pal_ram = new int[32];
        VROM = null;
        VRAM = new byte[12][0x0400];
        DUMMY_VROM = null;
        VROM_CACHE = null;
        VRAM_CACHE = new int[8][512];
        DUMMY_VROM_CACHE = null;
        CACHE_HIT = new byte[9][65];
        patpix = new int[8][];
        patdirty = new byte[8][];
        cur_palette = new int[64];
        zeroPalette_array = new int[280];
        fb = new int[256 * 256];
    }

    public final int load_rom(InputStream is, boolean from_sp) throws IOException {
        /* ROM/VROM */
        ROM = null;
        DISK = null;
        BIOS = null;
        SRAM = new byte[0x2000];
        SRAM_SIZE = 0x2000;
        VROM = null;
        VROM_CACHE = null;
        DUMMY_VROM = null;
        DUMMY_VROM_CACHE = null;
        
        /* ROM񏉊 */
        mapper_no = 0;
        num_16k_ROM_banks = 0;
        num_8k_VROM_banks = 0;
        num_DISK_banks = 0;
        mirroring = MIRROR_HORIZ;
        crc = 0;
        vram_write_protect = false;
        latch_mapper = false;
        exgfx_mapper = false;
        exclk_mapper = false;
        disk_system  = false;
        CYCLE_PER_LINE = 1364;
        DEFAULT_RENDER_METHOD = PRE_ALL_RENDER;
        
        /* wb_ */
        int b0, b1, b2, b3, b6, b7;
        b6 = b7 = 0;
        b0 = is.read();
        b1 = is.read();
        b2 = is.read();
        b3 = is.read();
        if (b0 == 'N' && b1 == 'E' && b2 == 'S' && b3 == 0x1A) {
            num_16k_ROM_banks = is.read();
            num_8k_VROM_banks = is.read();
            b6 = is.read();
            b7 = is.read();
            mirroring =
                (b6 & 1) != 0
                ? MIRROR_VERT
                : (b6 & 8) != 0
                ? MIRROR_FOUR_SCREEN
                : MIRROR_HORIZ;
            mapper_no = ((b6 >> 4) & 0x0F) | (b7 & 0xF0);
            CYCLE_PER_LINE = 1364;
            DEFAULT_RENDER_METHOD = PRE_ALL_RENDER;
            for (int i = 0; i < 8; i++) {
                if (is.read() != 0) {
                    mapper_no &= 0x0F;
                }
            }
            if ((b6 & 4) != 0) {
                return -2;
            }
            ROM = load_blocks(is, num_16k_ROM_banks << 1, 0x2000);
            int c = ~crc;
            for (int i = 0; i < num_16k_ROM_banks << 1; i++) {
                for (int j = 0; j < 0x2000; j++) {
                    c = crc_table[(c ^ ROM[i][j]) & 0xff] ^ (c >>> 8);
                }
            }
            crc = ~c;
            correct_rom(crc);
            if (mapper_no == 5) {
                SRAM = new byte[0x10000];
                SRAM_SIZE = 0x10000;
            } else if( crc == 0xb8747abf) { // Pro Yakyuu Special
                SRAM = new byte[0x4000];
                SRAM_SIZE = 0x4000;
            }
            disk_system = false;
            if (mapper_no == 0x14) {
                return -3;
            }
        } else if(b0 == 'F' && b1 == 'D' && b2 == 'S' && b3 == 0x1A) {
            num_DISK_banks = is.read();
            mapper_no = 0x14;
            CYCLE_PER_LINE = 1364;
            DEFAULT_RENDER_METHOD = PRE_ALL_RENDER;
            for(int i = 5; i < 0x10; i++) is.read();
            DISK = load_disk_blocks(is, num_DISK_banks);
            BIOS = load_bios(from_sp);
            if(BIOS == null) return -4;
            disk_system = true;
            SRAM = new byte[0x10000 * num_DISK_banks];
            SRAM_SIZE = 0x10000 * num_DISK_banks;
        } else {
            return -1;
        }
        if ((mapper = Mapper.createMapper(mapper_no, this)) == null) {
            return -3;
        }
        if (num_8k_VROM_banks > 0) {
            VROM = load_blocks(is, num_8k_VROM_banks << 3, 0x0400);
            vram_write_protect = (crc != 0xadb47286);
            VROM_CACHE = new int[num_8k_VROM_banks << 3][512];
            for (int i = 0; i < (num_8k_VROM_banks << 3); i++) {
                for (int j = 0; j < 64; j++) {
                    for (int k = 0; k < 8; k++) {
                        int lo = VROM[i][(j << 4) + k    ] & 0xFF;
                        int hi = VROM[i][(j << 4) + k + 8] & 0xFF;
                        int pat;
                        pat = ((lo & 0x01) << 28) | ((hi & 0x01) << 29)
                            | ((lo & 0x02) << 23) | ((hi & 0x02) << 24)
                            | ((lo & 0x04) << 18) | ((hi & 0x04) << 19)
                            | ((lo & 0x08) << 13) | ((hi & 0x08) << 14)
                            | ((lo & 0x10) <<  8) | ((hi & 0x10) <<  9)
                            | ((lo & 0x20) <<  3) | ((hi & 0x20) <<  4)
                            | ((lo & 0x40) >>  2) | ((hi & 0x40) >>  1)
                            | ((lo & 0x80) >>  7) | ((hi & 0x80) >>  6);
                        VROM_CACHE[i][(j << 3) + k]=
                            pat | (((pat + 0x77777777) ^ 0x44444444) & 0xCCCCCCCC);
                    }
                }
            }
        }
        
        /* INIT or LOAD SRAM */
        int c = load_sram();
        if(c != 0)
            for (int i = 0; i < SRAM_SIZE; i++) SRAM[i] = (byte) 0xFF;
        
        // SAVE ROM@SP
        if(sp_mode && !from_sp) {
            if(!disk_system) {
                gui.writeSPROM(num_16k_ROM_banks, num_8k_VROM_banks, b6, b7, ROM, VROM);
            } else {
                gui.writeSPFD(num_DISK_banks, DISK);
                gui.writeSPBIOS(BIOS);
            }
        }

        /* SET DUMMY CHARCTER ROM */
        if (mapper_no == 185) {
            DUMMY_VROM = new byte[0x400];
            DUMMY_VROM_CACHE = new int[512];
            for(int i = 0; i < 0x400; i++)
                DUMMY_VROM[i] = (byte)0xFF;
            for (int i = 0; i < 512; i++)
                DUMMY_VROM_CACHE[i] = (int)0xFFFFFFFF;
        }
        return 0;
    }

    private final void correct_rom(int crc) {
        switch(crc){
        case 0x5c707ac4: //MOTHER
            DEFAULT_RENDER_METHOD = TILE_RENDER;
            break;
        case 0x57970078: //F-1 Race
            ROM[1][0x1FE1] = (byte)0xFF;
            ROM[1][0x1FE6] = (byte)0x00;
            break;
        }
    }
    
    private final void save_disk_image(OutputStream os) throws IOException {
        os.write('F');
        os.write('D');
        os.write('S');
        os.write(0x1A);
        os.write(num_DISK_banks);
        for (int i = 5; i < 0x10; i++) os.write(0x00);
        if (num_DISK_banks > 0) {
            for (int i = 0; i < num_DISK_banks; i++) {
                os.write(DISK[i], 0, 65500);
            }
        }
    }

    public final int reset() {
        /* RESET MEMORY */
        for (int i = 0; i < 8; i++)
            cpu_map[i] = null;
        for (int i = 0; i < 0x0800; i++)
            RAM[i] = 0x00;
        cpu_map[0] = RAM;
        cpu_map[3] = SRAM;
        
        /* RESET PPU */
        for (int i = 0; i < 12; i++)
            for(int j = 0; j < 0x400; j++)
                VRAM[i][j] = (byte)0x00;
        for (int i = 0; i < 65; i++) {
            for(int j = 0; j < 8; j++)
                CACHE_HIT[j][i] = 0; 
            CACHE_HIT[8][i] = 1;
        }
        for (int i = 0; i < 8; i++) {
            ppu_map[i] = VRAM[i];
            patpix[i] = VRAM_CACHE[i];
            patdirty[i] = CACHE_HIT[i];
        }
        set_mirroring(mirroring);
        PPU_R0 = 0;
        PPU_R1 = 0;
        PPU_R2 = 0;
        bg_pattern_table_addr = 0;
        spr_pattern_table_addr = 0;
        ppu_addr_inc = 0;
        toggle_2005_2006 = false;
        loopy_v = 0;
        loopy_t = 0;
        loopy_x = 0;
        spr_ram_rw_ptr = 0;
        read_2007_buffer = 0;
        frame_irq_enabled = 0xFF;
        for (int i = 0; i < 256; i++)
            spr_ram[i] = 0;
        for (int i = 0; i < 32; i++)
            pal_ram[i] = 0;
        
        /* RESET MMC */
        try{
            mapper.Reset();
        } catch (Exception e) {
            return -1;
        }
        
        /* RESET CPU */
        A = X = Y = 0;
        S = 0xFF;
        //P  = 0x26;
        P_BI = 0x24;
        P_C  = 0;
        P_V  = 0;
        P_ZN = -1;
        PC = read_mem(0xFFFC) | (read_mem(0xFFFD) << 8);
        int_pending = 0;
        cyc_pending = -72;
        
        /* RESET PALETTE */
        for (int i = 0; i <  64; i++) {
            if( i == 0 )
                cur_palette[0] = nes_palette[i] & 0x00FFFFFF;
            else
                cur_palette[i] = nes_palette[i];
        }
        for (int i = 0; i < 280; i++) zeroPalette_array[i] = cur_palette[0];
        
        /* RESET CPU CYCLES */
        cyc_normal    = CYCLE_PER_LINE + gui.adjust_dozencycle;
        render_method = DEFAULT_RENDER_METHOD;
        if(gui.change_method != UNKNOWN_RENDER)
            render_method = gui.change_method;
        
        /* RESET APU */
        switch (gui.getApuNum()) {
            case 1 :
                audio = new NESApu1(this, gui, psgi);
                break;
            case 2 :
                audio = new NESApu2(this, gui, psgi);
                break;
            case 3 :
                audio = new NESApu_NP2(this, gui, psgi);
                break;
            default :
                break;
        }
        audio.apu_setmode(gui.soundMode);
        audio.apu_setting();
        audio.apu_reset();

        return 0;
    }

    public final void run() {
        final byte[] sprite_hit = new byte[16];
        exist = true;
        for (;;) {
            super.run();
            switch (request) {
                case 2 :
                    request = 0;
                    exist = false;
                    return;
                case 7 :
                    continue;
                default :
                    break;
            }
            request = 0;
            try {
                if ((PPU_R1 & 0x18) != 0)
                    loopy_v = loopy_t;
                boolean render_frame = gui.startFrame();
                blank_line = false;
                for (int i = 0; i < 240; i++) {
                    if (render_frame) {
                        final int[] line_buf = new int[280];
                        /*** CPU CYCLE ***/
                        if (render_method != TILE_RENDER) {
                            emulate_cpu_cycles(cyc_normal);
                        } else {
                            emulate_cpu_cycles(80);
                        }
                        /*** H SYNC ***/
                        mapper.HSync(i);
                        /*** CPU CYCLE ***/
                        if(render_method == TILE_RENDER) 
                            emulate_cpu_cycles(176);
                        /*** SCAN START LINE ***/
                        if ((PPU_R1 & 0x18) != 0)
                            loopy_v = (loopy_v & 0xFBE0) | (loopy_t & 0x041F);
                        /*** CPU CYCLE ***/
                        if(render_method == TILE_RENDER) 
                            emulate_cpu_cycles(84);
                        /*** SCAN LINE ***/
                        if ((PPU_R1 & 8) != 0) {
                            final int bg_pattern_table_addr = this.bg_pattern_table_addr;
                            final int loopy_v = this.loopy_v;
                            final byte[][] patdirty = this.patdirty;
                            final int[][] patpix = this.patpix;
                            final boolean latch_mapper = this.latch_mapper;
                            final boolean exgfx_mapper = this.exgfx_mapper;
                            int tileX = (loopy_v & 0x001F);
                            final int tileY = (loopy_v & 0x03E0) >> 5;
                            int name_table_no = ((loopy_v & 0x0C00) >> 10) + 8;
                            byte[] name_table = ppu_map[name_table_no];
                            int nameAddr = loopy_v & 0x03FF;
                            int attribAddr = 0x03C0 + ((tileY >> 2) << 3) + (tileX >> 2);
                            final int pos_y = (tileY & 2) << 1;
                            int attribBits =
                                (((name_table[attribAddr] & 0xFF) << 2) >> (pos_y | (tileX & 2))) & 0xC;
                            int p = 8 - loopy_x;
                            final int subtile_y = (loopy_v & 0x7000) >> 12;
                            for (int j = 0; j < 33; j++) {
                                if (render_method == TILE_RENDER & j != 0)
                                    emulate_cpu_cycles(32);
                                if (exgfx_mapper) {
                                    int mmc5_pal = mapper.PPU_Latch_RenderScreen(1, nameAddr & 0x03FF);
                                    if( mmc5_pal != 0) {
                                        attribBits = mmc5_pal;
                                    }
                                }
                                final int patternAddr =
                                    bg_pattern_table_addr
                                    + ((name_table[nameAddr] & 0xFF) << 4)
                                    + subtile_y;
                                final int patno = (patternAddr >> 4) & 0x1FF;
                                int patno_hi = patno >> 6;
                                int patno_lo = ((patno & 0x3F) << 3);
                                if (patdirty[patno_hi][patno & 0x3F] == 0) {
                                    int patno_lo2 = (patno_lo << 1);
                                    for (int v = 0; v < 8; v++) {
                                        int lo = (ppu_map[patno_hi][patno_lo2 + v    ] & 0xFF);
                                        int hi = (ppu_map[patno_hi][patno_lo2 + v + 8] & 0xFF);
                                        int pat;
                                        pat = ((lo & 0x01) << 28) | ((hi & 0x01) << 29)
                                            | ((lo & 0x02) << 23) | ((hi & 0x02) << 24)
                                            | ((lo & 0x04) << 18) | ((hi & 0x04) << 19)
                                            | ((lo & 0x08) << 13) | ((hi & 0x08) << 14)
                                            | ((lo & 0x10) <<  8) | ((hi & 0x10) <<  9)
                                            | ((lo & 0x20) <<  3) | ((hi & 0x20) <<  4)
                                            | ((lo & 0x40) >>  2) | ((hi & 0x40) >>  1)
                                            | ((lo & 0x80) >>  7) | ((hi & 0x80) >>  6);
                                        patpix[patno_hi][patno_lo | v] =
                                            pat | (((pat + 0x77777777) ^ 0x44444444) & 0xCCCCCCCC);
                                    }
                                    patdirty[patno_hi][patno & 0x3F] = 1;
                                }
                                final int pat = patpix[patno_hi][patno_lo | subtile_y];
                                if (latch_mapper) {
                                    if ((((patternAddr) & 0x0FF0) == 0x0FD0) || (((patternAddr) & 0x0FF0) == 0x0FE0)) {
                                        mapper.PPU_Latch_FDFE(patternAddr);
                                    }
                                }
                                attribBits |= 3;
                                line_buf[p    ] = cur_palette[attribBits & (pat      )];
                                line_buf[p + 1] = cur_palette[attribBits & (pat >>  4)];
                                line_buf[p + 2] = cur_palette[attribBits & (pat >>  8)];
                                line_buf[p + 3] = cur_palette[attribBits & (pat >> 12)];
                                line_buf[p + 4] = cur_palette[attribBits & (pat >> 16)];
                                line_buf[p + 5] = cur_palette[attribBits & (pat >> 20)];
                                line_buf[p + 6] = cur_palette[attribBits & (pat >> 24)];
                                line_buf[p + 7] = cur_palette[attribBits & (pat >> 28)];
                                p += 8;
                                tileX++;
                                nameAddr++;
                                if ((tileX & 0x0001) == 0) {
                                    if ((tileX & 0x0003) == 0) {
                                        if ((tileX & 0x001F) == 0) {
                                            nameAddr = nameAddr - 0x0020;
                                            attribAddr = attribAddr - 0x0008;
                                            name_table = ppu_map[name_table_no ^ 1];
                                            tileX -= 0x0020;
                                        }
                                        attribAddr++;
                                    }
                                    attribBits =
                                        (((name_table[attribAddr] & 0xFF) << 2) >> (pos_y | (tileX & 2)))
                                        & 0xC;
                                }
                            }
                        } else {
                            System.arraycopy(zeroPalette_array, 0, line_buf, 0, 280);
                            if (render_method == TILE_RENDER)
                                emulate_cpu_cycles(1024);                                
                        }
                        if ((PPU_R1 & 0x10) != 0) {
                            int PPU_R2 = this.PPU_R2;
                            final int[] spr_ram = this.spr_ram;
                            final boolean latch_mapper = this.latch_mapper;
                            //final boolean exgfx_mapper = this.exgfx_mapper;
                            final byte[][] patdirty = this.patdirty;
                            final int[][] patpix = this.patpix;
                            int spritesInScanLine = 0;
                            final int sprHeight = ((PPU_R0 & 0x20) != 0) ? 16 : 8;
                            if (mapper_no != 9) {
                                if (exgfx_mapper) {
                                    mapper.PPU_Latch_RenderScreen(0, 0);
                                }
                                for (int si = 63; si >= 0; si--) {
                                    final int s = (si << 2);
                                    final int lineOfSprite = i - (spr_ram[s] + 1);
                                    if (lineOfSprite < 0 || lineOfSprite >= sprHeight)
                                        continue;
                                    spritesInScanLine++;
                                    int tileIndex = spr_ram[s + 1];
                                    final int sprAttribs = spr_ram[s + 2];
                                    final int sprVFlip = (sprAttribs & 0x80);
                                    final int sprHFlip = (sprAttribs & 0x40);
                                    final int sprBGPriority = (sprAttribs & 0x20);
                                    int y = lineOfSprite;
                                    int p = spr_ram[s + 3] + 8;
                                    if (sprVFlip != 0)
                                        y = (sprHeight - 1) - y;
                                    if (latch_mapper) {
                                        if ((((tileIndex) & 0x00FF) == 0x00FD) || (((tileIndex) & 0x00FF) == 0x00FE)) {
                                            mapper.PPU_Latch_FDFE(tileIndex << 4);
                                        }
                                    }
                                    if (sprHeight == 16) {
                                        if ((tileIndex & 0x01) != 0) {
                                            tileIndex += 0x100;
                                            if (y < 8)
                                                tileIndex--;
                                        } else {
                                            if (y >= 8)
                                                tileIndex++;
                                        }
                                    } else {
                                        tileIndex += spr_pattern_table_addr >> 4;
                                    }
                                    int patno_hi = tileIndex >> 6;
                                    int patno_lo = ((tileIndex & 0x3F) << 3);
                                    if (patdirty[patno_hi][tileIndex & 0x3F] == 0) {
                                        int patno_lo2 = (patno_lo << 1);
                                        for (int v = 0; v < 8; v++) {
                                            int lo = (ppu_map[patno_hi][patno_lo2 + v    ] & 0xFF);
                                            int hi = (ppu_map[patno_hi][patno_lo2 + v + 8] & 0xFF);
                                            int pat;
                                            pat = ((lo & 0x01) << 28) | ((hi & 0x01) << 29)
                                                | ((lo & 0x02) << 23) | ((hi & 0x02) << 24)
                                                | ((lo & 0x04) << 18) | ((hi & 0x04) << 19)
                                                | ((lo & 0x08) << 13) | ((hi & 0x08) << 14)
                                                | ((lo & 0x10) <<  8) | ((hi & 0x10) <<  9)
                                                | ((lo & 0x20) <<  3) | ((hi & 0x20) <<  4)
                                                | ((lo & 0x40) >>  2) | ((hi & 0x40) >>  1)
                                                | ((lo & 0x80) >>  7) | ((hi & 0x80) >>  6);
                                            patpix[patno_hi][patno_lo | v] =
                                                pat | (((pat + 0x77777777) ^ 0x44444444) & 0xCCCCCCCC);
                                        }
                                        patdirty[patno_hi][tileIndex & 0x3F] = 1;
                                    }
                                    final int pat = patpix[patno_hi][patno_lo | (y & 7)];
                                    final int colhi = ((sprAttribs & 3) << 2) | 0x10;
                                    if (si == 0) {
                                        sprite_hit[lineOfSprite] = 0;
                                        if (pat != 0) {
                                            final int zero_palette = this.zeroPalette_array[0];
                                            for (int k = 0; k < 8; k++)
                                                if (line_buf[p + k] != zero_palette) {
                                                    PPU_R2 |= 0x40;
                                                    sprite_hit[lineOfSprite] = 1;
                                                    break;
                                                }
                                        }
                                    }
                                    {
                                        int c;
                                        if (sprBGPriority != 0) {
                                            final int zero_palette = this.zeroPalette_array[0];
                                            if (sprHFlip != 0) {
                                                if (line_buf[p    ] == zero_palette && (c = (pat >> 28) & 3) != 0)
                                                    line_buf[p    ] = cur_palette[colhi | c];
                                                if (line_buf[p + 1] == zero_palette && (c = (pat >> 24) & 3) != 0)
                                                    line_buf[p + 1] = cur_palette[colhi | c];
                                                if (line_buf[p + 2] == zero_palette && (c = (pat >> 20) & 3) != 0)
                                                    line_buf[p + 2] = cur_palette[colhi | c];
                                                if (line_buf[p + 3] == zero_palette && (c = (pat >> 16) & 3) != 0)
                                                    line_buf[p + 3] = cur_palette[colhi | c];
                                                if (line_buf[p + 4] == zero_palette && (c = (pat >> 12) & 3) != 0)
                                                    line_buf[p + 4] = cur_palette[colhi | c];
                                                if (line_buf[p + 5] == zero_palette && (c = (pat >>  8) & 3) != 0)
                                                    line_buf[p + 5] = cur_palette[colhi | c];
                                                if (line_buf[p + 6] == zero_palette && (c = (pat >>  4) & 3) != 0)
                                                    line_buf[p + 6] = cur_palette[colhi | c];
                                                if (line_buf[p + 7] == zero_palette && (c = pat & 3) != 0)
                                                    line_buf[p + 7] = cur_palette[colhi | c];
                                            } else {
                                                if (line_buf[p    ] == zero_palette && (c = pat & 3) != 0)
                                                    line_buf[p    ] = cur_palette[colhi | c];
                                                if (line_buf[p + 1] == zero_palette && (c = (pat >>  4) & 3) != 0)
                                                    line_buf[p + 1] = cur_palette[colhi | c];
                                                if (line_buf[p + 2] == zero_palette && (c = (pat >>  8) & 3) != 0)
                                                    line_buf[p + 2] = cur_palette[colhi | c];
                                                if (line_buf[p + 3] == zero_palette && (c = (pat >> 12) & 3) != 0)
                                                    line_buf[p + 3] = cur_palette[colhi | c];
                                                if (line_buf[p + 4] == zero_palette && (c = (pat >> 16) & 3) != 0)
                                                    line_buf[p + 4] = cur_palette[colhi | c];
                                                if (line_buf[p + 5] == zero_palette && (c = (pat >> 20) & 3) != 0)
                                                    line_buf[p + 5] = cur_palette[colhi | c];
                                                if (line_buf[p + 6] == zero_palette && (c = (pat >> 24) & 3) != 0)
                                                    line_buf[p + 6] = cur_palette[colhi | c];
                                                if (line_buf[p + 7] == zero_palette && (c = (pat >> 28) & 3) != 0)
                                                    line_buf[p + 7] = cur_palette[colhi | c];
                                            }
                                        } else if (sprHFlip != 0) {
                                            if ((c = (pat >> 28) & 3) != 0)
                                                line_buf[p    ] = cur_palette[colhi | c];
                                            if ((c = (pat >> 24) & 3) != 0)
                                                line_buf[p + 1] = cur_palette[colhi | c];
                                            if ((c = (pat >> 20) & 3) != 0)
                                                line_buf[p + 2] = cur_palette[colhi | c];
                                            if ((c = (pat >> 16) & 3) != 0)
                                                line_buf[p + 3] = cur_palette[colhi | c];
                                            if ((c = (pat >> 12) & 3) != 0)
                                                line_buf[p + 4] = cur_palette[colhi | c];
                                            if ((c = (pat >> 8) & 3) != 0)
                                                line_buf[p + 5] = cur_palette[colhi | c];
                                            if ((c = (pat >> 4) & 3) != 0)
                                                line_buf[p + 6] = cur_palette[colhi | c];
                                            if ((c = pat & 3) != 0)
                                                line_buf[p + 7] = cur_palette[colhi | c];
                                        } else {
                                            if ((c = pat & 3) != 0)
                                                line_buf[p    ] = cur_palette[colhi | c];
                                            if ((c = (pat >> 4) & 3) != 0)
                                                line_buf[p + 1] = cur_palette[colhi | c];
                                            if ((c = (pat >> 8) & 3) != 0)
                                                line_buf[p + 2] = cur_palette[colhi | c];
                                            if ((c = (pat >> 12) & 3) != 0)
                                                line_buf[p + 3] = cur_palette[colhi | c];
                                            if ((c = (pat >> 16) & 3) != 0)
                                                line_buf[p + 4] = cur_palette[colhi | c];
                                            if ((c = (pat >> 20) & 3) != 0)
                                                line_buf[p + 5] = cur_palette[colhi | c];
                                            if ((c = (pat >> 24) & 3) != 0)
                                                line_buf[p + 6] = cur_palette[colhi | c];
                                            if ((c = (pat >> 28) & 3) != 0)
                                                line_buf[p + 7] = cur_palette[colhi | c];
                                        }
                                    }
                                }
                            } else {
                                // FOR MAPPER #9
                                final int[] fg_flags = new int[280]; //FOR Mapper #9
                                for (int si = 0; si < 64; si++) {
                                    final int s = (si << 2);
                                    final int sprY = spr_ram[s] + 1;
                                    final int lineOfSprite = i - sprY;
                                    if (lineOfSprite < 0 || lineOfSprite >= sprHeight)
                                        continue;
                                    int tileIndex = spr_ram[s + 1];
                                    final int sprAttribs = spr_ram[s + 2];
                                    final int sprVFlip = (sprAttribs & 0x80);
                                    final int sprHFlip = (sprAttribs & 0x40);
                                    final int sprBGPriority = (sprAttribs & 0x20);
                                    int y = lineOfSprite;
                                    int p = spr_ram[s + 3] + 8;
                                    if (sprVFlip != 0)
                                        y = (sprHeight - 1) - y;
                                    if ((((tileIndex) & 0x00FF) == 0x00FD) || (((tileIndex) & 0x00FF) == 0x00FE)) {
                                        mapper.PPU_Latch_FDFE(tileIndex << 4);
                                    }
                                    if (sprHeight == 16) {
                                        if ((tileIndex & 0x01) != 0) {
                                            tileIndex += 0x100;
                                            if (y < 8)
                                                tileIndex--;
                                        } else {
                                            if (y >= 8)
                                                tileIndex++;
                                        }
                                    } else {
                                        tileIndex += spr_pattern_table_addr >> 4;
                                    }
                                    int patno_hi = tileIndex >> 6;
                                    int patno_lo = ((tileIndex & 0x3F) << 3);
                                    if (patdirty[patno_hi][tileIndex & 0x3F] == 0) {
                                        int patno_lo2 = (patno_lo << 1);
                                        for (int v = 0; v < 8; v++) {
                                            int lo = (ppu_map[patno_hi][patno_lo2 + v    ] & 0xFF);
                                            int hi = (ppu_map[patno_hi][patno_lo2 + v + 8] & 0xFF);
                                            int pat;
                                            pat = ((lo & 0x01) << 28) | ((hi & 0x01) << 29)
                                                | ((lo & 0x02) << 23) | ((hi & 0x02) << 24)
                                                | ((lo & 0x04) << 18) | ((hi & 0x04) << 19)
                                                | ((lo & 0x08) << 13) | ((hi & 0x08) << 14)
                                                | ((lo & 0x10) <<  8) | ((hi & 0x10) <<  9)
                                                | ((lo & 0x20) <<  3) | ((hi & 0x20) <<  4)
                                                | ((lo & 0x40) >>  2) | ((hi & 0x40) >>  1)
                                                | ((lo & 0x80) >>  7) | ((hi & 0x80) >>  6);
                                            patpix[patno_hi][patno_lo | v] =
                                                pat | (((pat + 0x77777777) ^ 0x44444444) & 0xCCCCCCCC);
                                        }
                                        patdirty[patno_hi][tileIndex & 0x3F] = 1;
                                    }
                                    final int pat = patpix[patno_hi][patno_lo | (y & 7)];
                                    final int colhi = ((sprAttribs & 3) << 2) | 0x10;
                                    if (si == 0) {
                                        sprite_hit[lineOfSprite] = 0;
                                        if (pat != 0) {
                                            final int zero_palette = this.zeroPalette_array[0];
                                            for (int k = 0; k < 8; k++)
                                                if (line_buf[p + k] != zero_palette) {
                                                    PPU_R2 |= 0x40;
                                                    sprite_hit[lineOfSprite] = 1;
                                                    break;
                                                }
                                        }
                                    }
                                    {
                                        int c;
                                        if (sprBGPriority != 0) {
                                            final int zero_palette = this.zeroPalette_array[0];
                                            if (sprHFlip != 0) {
                                                if (fg_flags[p    ] == 0 && line_buf[p    ] == zero_palette && (c = (pat >> 28) & 3) != 0) {
                                                    line_buf[p    ] = cur_palette[colhi | c];
                                                    fg_flags[p    ] = 1;
                                                }
                                                if (fg_flags[p + 1] == 0 && line_buf[p + 1] == zero_palette && (c = (pat >> 24) & 3) != 0) {
                                                    line_buf[p + 1] = cur_palette[colhi | c];
                                                    fg_flags[p + 1] = 1;
                                                }
                                                if (fg_flags[p + 2] == 0 && line_buf[p + 2] == zero_palette && (c = (pat >> 20) & 3) != 0) {
                                                    line_buf[p + 2] = cur_palette[colhi | c];
                                                    fg_flags[p + 2] = 1;
                                                }
                                                if (fg_flags[p + 3] == 0 && line_buf[p + 3] == zero_palette && (c = (pat >> 16) & 3) != 0) {
                                                    line_buf[p + 3] = cur_palette[colhi | c];
                                                    fg_flags[p + 3] = 1;
                                                }
                                                if (fg_flags[p + 4] == 0 && line_buf[p + 4] == zero_palette && (c = (pat >> 12) & 3) != 0) {
                                                    line_buf[p + 4] = cur_palette[colhi | c];
                                                    fg_flags[p + 4] = 1;
                                                }
                                                if (fg_flags[p + 5] == 0 && line_buf[p + 5] == zero_palette && (c = (pat >>  8) & 3) != 0) {
                                                    line_buf[p + 5] = cur_palette[colhi | c];
                                                    fg_flags[p + 5] = 1;
                                                }
                                                if (fg_flags[p + 6] == 0 && line_buf[p + 6] == zero_palette && (c = (pat >>  4) & 3) != 0) {
                                                    line_buf[p + 6] = cur_palette[colhi | c];
                                                    fg_flags[p + 6] = 1;
                                                }
                                                if (fg_flags[p + 7] == 0 && line_buf[p + 7] == zero_palette && (c = pat & 3) != 0) {
                                                    line_buf[p + 7] = cur_palette[colhi | c];
                                                    fg_flags[p + 7] = 1;
                                                }
                                            } else {
                                                if (fg_flags[p    ] == 0 && line_buf[p    ] == zero_palette && (c = pat & 3) != 0) {
                                                    line_buf[p    ] = cur_palette[colhi | c];
                                                    fg_flags[p    ] = 1;
                                                }
                                                if (fg_flags[p + 1] == 0 && line_buf[p + 1] == zero_palette && (c = (pat >>  4) & 3) != 0) {
                                                    line_buf[p + 1] = cur_palette[colhi | c];
                                                    fg_flags[p + 1] = 1;
                                                }
                                                if (fg_flags[p + 2] == 0 && line_buf[p + 2] == zero_palette && (c = (pat >>  8) & 3) != 0) {
                                                    line_buf[p + 2] = cur_palette[colhi | c];
                                                    fg_flags[p + 2] = 1;
                                                }
                                                if (fg_flags[p + 3] == 0 && line_buf[p + 3] == zero_palette && (c = (pat >> 12) & 3) != 0) {
                                                    line_buf[p + 3] = cur_palette[colhi | c];
                                                    fg_flags[p + 3] = 1;
                                                }
                                                if (fg_flags[p + 4] == 0 && line_buf[p + 4] == zero_palette && (c = (pat >> 16) & 3) != 0) {
                                                    line_buf[p + 4] = cur_palette[colhi | c];
                                                    fg_flags[p + 4] = 1;
                                                }
                                                if (fg_flags[p + 5] == 0 && line_buf[p + 5] == zero_palette && (c = (pat >> 20) & 3) != 0) {
                                                    line_buf[p + 5] = cur_palette[colhi | c];
                                                    fg_flags[p + 5] = 1;
                                                }
                                                if (fg_flags[p + 6] == 0 && line_buf[p + 6] == zero_palette && (c = (pat >> 24) & 3) != 0) {
                                                    line_buf[p + 6] = cur_palette[colhi | c];
                                                    fg_flags[p + 6] = 1;
                                                }
                                                if (fg_flags[p + 7] == 0 && line_buf[p + 7] == zero_palette && (c = (pat >> 28) & 3) != 0) {
                                                    line_buf[p + 7] = cur_palette[colhi | c];
                                                    fg_flags[p + 7] = 1;
                                                }
                                            }
                                        } else if (sprHFlip != 0) {
                                            if (fg_flags[p    ] == 0 && (c = (pat >> 28) & 3) != 0) {
                                                line_buf[p    ] = cur_palette[colhi | c];
                                                fg_flags[p    ] = 1;
                                            }
                                            if (fg_flags[p + 1] == 0 && (c = (pat >> 24) & 3) != 0) {
                                                line_buf[p + 1] = cur_palette[colhi | c];
                                                fg_flags[p + 1] = 1;
                                            }
                                            if (fg_flags[p + 2] == 0 && (c = (pat >> 20) & 3) != 0) {
                                                line_buf[p + 2] = cur_palette[colhi | c];
                                                fg_flags[p + 2] = 1;
                                            }
                                            if (fg_flags[p + 3] == 0 && (c = (pat >> 16) & 3) != 0) {
                                                line_buf[p + 3] = cur_palette[colhi | c];
                                                fg_flags[p + 3] = 1;
                                            }
                                            if (fg_flags[p + 4] == 0 && (c = (pat >> 12) & 3) != 0) {
                                                line_buf[p + 4] = cur_palette[colhi | c];
                                                fg_flags[p + 4] = 1;
                                            }
                                            if (fg_flags[p + 5] == 0 && (c = (pat >> 8) & 3) != 0) {
                                                line_buf[p + 5] = cur_palette[colhi | c];
                                                fg_flags[p + 5] = 1;
                                            }
                                            if (fg_flags[p + 6] == 0 && (c = (pat >> 4) & 3) != 0) {
                                                line_buf[p + 6] = cur_palette[colhi | c];
                                                fg_flags[p + 6] = 1;
                                            }
                                            if (fg_flags[p + 7] == 0 && (c = pat & 3) != 0) {
                                                line_buf[p + 7] = cur_palette[colhi | c];
                                                fg_flags[p + 7] = 1;
                                            }
                                        } else {
                                            if (fg_flags[p    ] == 0 && (c = pat & 3) != 0) {
                                                line_buf[p    ] = cur_palette[colhi | c];
                                                fg_flags[p    ] = 1;
                                            }
                                            if (fg_flags[p + 1] == 0 && (c = (pat >> 4) & 3) != 0) {
                                                line_buf[p + 1] = cur_palette[colhi | c];
                                                fg_flags[p + 1] = 1;
                                            }
                                            if (fg_flags[p + 2] == 0 && (c = (pat >> 8) & 3) != 0) {
                                                line_buf[p + 2] = cur_palette[colhi | c];
                                                fg_flags[p + 2] = 1;
                                            }
                                            if (fg_flags[p + 3] == 0 && (c = (pat >> 12) & 3) != 0) {
                                                line_buf[p + 3] = cur_palette[colhi | c];
                                                fg_flags[p + 3] = 1;
                                            }
                                            if (fg_flags[p + 4] == 0 && (c = (pat >> 16) & 3) != 0) {
                                                line_buf[p + 4] = cur_palette[colhi | c];
                                                fg_flags[p + 4] = 1;
                                            }
                                            if (fg_flags[p + 5] == 0 && (c = (pat >> 20) & 3) != 0) {
                                                line_buf[p + 5] = cur_palette[colhi | c];
                                                fg_flags[p + 5] = 1;
                                            }
                                            if (fg_flags[p + 6] == 0 && (c = (pat >> 24) & 3) != 0) {
                                                line_buf[p + 6] = cur_palette[colhi | c];
                                                fg_flags[p + 6] = 1;
                                            }
                                            if (fg_flags[p + 7] == 0 && (c = (pat >> 28) & 3) != 0) {
                                                line_buf[p + 7] = cur_palette[colhi | c];
                                                fg_flags[p + 7] = 1;
                                            }
                                        }
                                    }
                                    if(++spritesInScanLine == 8) break;
                                }
                            }
                            if (spritesInScanLine >= 8)
                                PPU_R2 |= 0x20;
                            else
                                PPU_R2 &= 0xDF;
                            this.PPU_R2 = PPU_R2;
                        }
                        /*** SCAN NEXT LINE ***/
                        if ((PPU_R1 & 0x18) != 0) {
                            if ((loopy_v & 0x7000) == 0x7000) {
                                loopy_v &= 0x8FFF;
                                if ((loopy_v & 0x03E0) == 0x03A0)
                                    loopy_v = (loopy_v ^ 0x0800) & 0xFC1F;
                                else if ((loopy_v & 0x03E0) == 0x03E0)
                                    loopy_v &= 0xFC1F;
                                else
                                    loopy_v += 0x0020;
                            } else
                                loopy_v += 0x1000;
                        }
                        /*** COPY FRAME BUFFER ***/
                        if (render_frame && i >= 8 && i < 232) {
                            System.arraycopy(line_buf, 8, fb, ((i - 8) << 8), 256);
                        }
                    } else {
                        /*** CPU CYCLE ***/
                        emulate_cpu_cycles(cyc_normal);
                        /*** H SYNC ***/
                        mapper.HSync(i);
                        /*** SCAN START LINE & SCAN NEXT LINE***/
                        if ((PPU_R1 & 0x18) != 0) {
                            loopy_v = (loopy_v & 0xFBE0) | (loopy_t & 0x041F);
                            if ((PPU_R1 & 0x10) != 0) {
                                final int sprHeight = ((PPU_R0 & 0x20) != 0) ? 16 : 8;
                                final int sprY = spr_ram[0] + 1;
                                final int lineOfSprite = i - sprY;
                                if (lineOfSprite >= 0 && lineOfSprite < sprHeight)
                                    if (sprite_hit[lineOfSprite] != 0)
                                        PPU_R2 |= 0x40;
                            }
                            if ((loopy_v & 0x7000) == 0x7000) {
                                loopy_v &= 0x8FFF;
                                if ((loopy_v & 0x03E0) == 0x03A0)
                                    loopy_v = (loopy_v ^ 0x0800) & 0xFC1F;
                                else if ((loopy_v & 0x03E0) == 0x03E0)
                                    loopy_v &= 0xFC1F;
                                else
                                    loopy_v += 0x0020;
                            } else
                                loopy_v += 0x1000;
                        }
                    }
                }
                if ((frame_irq_enabled & 0xC0) == 0) {
                    int_pending |= IRQ_FRAMEIRQ;
                }
                blank_line = true;
                for (int i = 240; i <= 261; i++) {
                    /*** V SYNC ***/
                    if (i == 240) {
                        mapper.VSync();
                    }
                    if (i == 241) {
                        PPU_R2 |= 0x80;
                        if ((PPU_R0 & 0x80) != 0) {
                            int_pending |= IRQ_NMI;
                        }
                    }
                    if (i == 261) {
                        PPU_R2 &= 0x3F;
                    }
                    /*** CPU CYCLE ***/
                    emulate_cpu_cycles(cyc_normal);
                    /*** H SYNC ***/
                    mapper.HSync(i);
                }
                //if (soundOut) audio.audioBufferHandler();
                audio.apu_emulate_frame();
                if (render_frame) gui.endFrame();
            } catch (Throwable th) {
            }
        }
    }

    public final void load_state(DataInputStream dis) throws IOException {
        //PǏϐ
        super.load_state(dis);

        P_BI = P & 0x3c;
        P_C  = P & 1;
        P_V  = (P & 0x40) << 1;
        P_ZN = ((P & 0x82) ^ 2) | ((P & 2) << 30);
    }

    private final int get_index(byte[] p, byte[][] a) {
        if (a == null) {
            return -1;
        }
        for (int i = 0; i < a.length; i++) {
            if (p == a[i]) {
                return i;
            }
        }
        return -1;
    }
    
    public boolean is_blank_line() {
        return blank_line;
    }
    
    public final boolean is_disk_system() {
        return disk_system;
    }

    public final int get_default_cycle_line() {
        return CYCLE_PER_LINE;
    }
    
    /*************************************
        MEMORY
    *************************************/
    private final int read_mem(int addr) {
        switch (addr >> 13) {
            case 0 :
                return RAM[addr & 0x07FF] & 0xFF;
            case 1 :
                int data;
                switch (addr & 7) {
                    case 1 :
                        return PPU_R1;
                    case 2 :
                        toggle_2005_2006 = false;
                        data = PPU_R2;
                        PPU_R2 &= 0x7F;
                        return data;
                    case 3 :
                        return spr_ram_rw_ptr;
                    case 4 :
                        data = spr_ram[spr_ram_rw_ptr];
                        spr_ram_rw_ptr = (spr_ram_rw_ptr + 1) & 0xFF;
                        return data;
                    case 7 :
                        addr = loopy_v & 0x3FFF;
                        loopy_v = (loopy_v + ppu_addr_inc) & 0xFFFF;
                        if (addr >= 0x3000)
                            return pal_ram[addr & 0x1F];
                        else {
                            int tmp = read_2007_buffer;
                            read_2007_buffer = ppu_map[addr >> 10][addr & 0x03FF] & 0xFF;
                            return tmp;
                        }
                    default :
                        return 0;
                }
            case 2 :
                if (addr >= 0x4018)
                    return mapper.MemoryReadLow(addr);
                switch (addr & 0x1F) {
                    case 0x15 :
                        if ((frame_irq_enabled & 0xC0) == 0)
                            return 0x40 | audio.apu_read(addr);
                            //return 0x40;
                        else
                            return audio.apu_read(addr);
                            //return 0;
                    case 0x16 :
                        return gui.readJoyPadBit();
                    case 0x17 :
                        return gui.readJoyPadBit2();
                    default :
                        return 0;
                }
            case 3 :
                mapper.MemoryReadSaveRAM(addr);
            default :
                return cpu_map[addr >> 13][addr & 0x1FFF] & 0xFF;
        }
    }

    private final void write_mem(int addr, int data) {
        switch (addr >> 13) {
            case 0 :
                RAM[addr & 0x07FF] = (byte) data;
                return;
            case 1 :
                switch (addr & 7) {
                    case 0 :
                        PPU_R0 = data;
                        final int b_addr = ((data & 0x10) << 8);
                        if (bg_pattern_table_addr != b_addr) {
                            bg_pattern_table_addr = b_addr;
                            //System.arraycopy(zero_array, 0, patdirty, b_addr >> 4, 256);
                        }
                        final int s_addr = ((data & 0x08) << 9);
                        if (spr_pattern_table_addr != s_addr) {
                            spr_pattern_table_addr = s_addr;
                            //System.arraycopy(zero_array, 0, patdirty, s_addr >> 4, 256);
                        }
                        ppu_addr_inc = (data & 4) != 0 ? 32 : 1;
                        loopy_t = (loopy_t & 0xF3FF) | ((data & 3) << 10);
                        return;
                    case 1 :
                        PPU_R1 = data;
                        return;
                    case 3 :
                        spr_ram_rw_ptr = data;
                        return;
                    case 4 :
                        spr_ram[spr_ram_rw_ptr++] = data;
                        return;
                    case 5 :
                        if (toggle_2005_2006 =
                                    !toggle_2005_2006) {
                            loopy_t = (loopy_t & 0xFFE0) | ((data & 0xF8) >> 3);
                            loopy_x = data & 7;
                        } else {
                            loopy_t =
                                (loopy_t & 0x8C1F)
                                | ((data & 0xF8) << 2)
                                | ((data & 7) << 12);
                        }
                        return;
                    case 6 :
                        if (toggle_2005_2006 = !toggle_2005_2006) {
                            loopy_t = (loopy_t & 0x00FF) | ((data & 0x3F) << 8);
                        } else {
                            loopy_v = loopy_t = (loopy_t & 0xFF00) | data;
                        }
                        return;
                    case 7 :
                        addr = loopy_v & 0x3FFF;
                        loopy_v = (loopy_v + ppu_addr_inc) & 0xFFFF;
                        if (addr >= 0x3F00) {
                            data &= 0x3F;
                            if ((addr & 0x0F) == 0) {
                                pal_ram[0] = data;
                                cur_palette[0x00] = nes_palette[data] & 0x00FFFFFF;
                                for(int i = 0; i < 280; i++) zeroPalette_array[i] = cur_palette[0];
                                pal_ram[0x10] = data;
                                cur_palette[0x10] = nes_palette[data];
                            } else {
                                final int pal = addr & 0x1F;
                                pal_ram[pal] = data;
                                cur_palette[pal] = nes_palette[data];
                            }
                        } else if (addr >= 0x2000) {
                            addr &= 0x2FFF;
                            ppu_map[addr >> 10][addr & 0x03FF] = (byte) data;
                        } else if (!vram_write_protect && patdirty[addr >> 10][64] == 0) {
                            ppu_map[addr >> 10][addr & 0x03FF] = (byte) data;
                            patdirty[addr >> 10][(addr >> 4) & 0x3F] = 0;
                        }
                        return;
                    default :
                        return;
                }
            case 2 :
                if (addr >= 0x4018) {
                    mapper.MemoryWriteLow(addr, data);
                    return;
                }
                switch (addr & 0x1F) {
                    case 0x00 :
                    case 0x01 :
                    case 0x02 :
                    case 0x03 :
                    case 0x04 :
                    case 0x05 :
                    case 0x06 :
                    case 0x07 :
                    case 0x08 :
                    case 0x09 :
                    case 0x0A :
                    case 0x0B :
                    case 0x0C :
                    case 0x0D :
                    case 0x0E :
                    case 0x0F :
                    case 0x10 :
                    case 0x11 :
                    case 0x12 :
                    case 0x13 :
                    case 0x15 :
                        //if (soundOut) audio.apuHandler(addr, data);
                        audio.apu_write(addr, data);
                        return;
                    case 0x14 :
                        byte[] mem = cpu_map[data >> 5];
                        int off = (data & 0x1F) << 8;
                        for (int i = 0; i < 256; i++)
                            spr_ram[i] = mem[off + i] & 0xFF;
                        cyc_pending -= 514 * 12;
                        return;
                    case 0x16 :
                        if ((data & 1) == 0)
                            gui.resetJoyPad();
                        return;
                    case 0x17 :
                        if ((data & 1) == 0)
                            gui.resetJoyPad2();
                        frame_irq_enabled = data;
                        return;
                    default :
                        return;
                }
            case 3 :
                SRAM[addr & 0x1FFF] = (byte) data;
                mapper.MemoryWriteSaveRAM(addr, data);
                return;
            default :
                mapper.MemoryWrite(addr, data);
                return;
        }
    }

    /*************************************
        CPU
    *************************************/

    //NP2ł do_irq(), do_pending_irq() 傫ςAȉ `_irq() ֐QɕςĂ
    public final void do_irq() {
        int_pending |= IRQ_TRIGGER;
    }

    public final void do_pending_irq() {
        int_pending |= IRQ_TRIGGER2;
    }

    public final void set_mapper_irq() {
        int_pending |= IRQ_MAPPER;
    }

    public final void clear_mapper_irq() {
        int_pending &= ~IRQ_MAPPER;
    }
    
    public final void set_mapper2_irq() {
        int_pending |= IRQ_MAPPER2;
    }

    public final void clear_mapper2_irq() {
        int_pending &= ~IRQ_MAPPER2;
    }

    private final void emulate_cpu_cycles(int cyc) {
        int A = this.A;
        int PCL, PCH;
        int X = this.X;
        int Y = this.Y;
        int S = this.S;
        int P = this.P_BI;
        int C = this.P_C;
        int V = this.P_V;
        int T = this.P_ZN;
        final byte[] RAM = this.RAM;
        final byte[][] cpu_map = this.cpu_map;
        byte[] curpage;
        final int exec_cycle = cyc;

        cyc += cyc_pending;
        cyc_pending = 0;

        do {
            int tmp, ea;
            boolean do_nmi = false;
            boolean do_irq = false;
            PCH = PC >> 13;
            PCL = PC & 0x1FFF;
            if (int_pending != 0) {
                if ((int_pending & IRQ_NMI) != 0) {
                    cyc_pending += (cyc - 1);
                    cyc = 1;
                    do_nmi = true;
                    int_pending &= ~IRQ_NMI;
                } else {
                    int_pending &= ~IRQ_TRIGGER;
                    if ((P & 4) == 0 && (cpu_map[PCH][PCL] & 0xFF) != 0x40) {
                        cyc_pending += (cyc - 1);
                        cyc = 1;
                    	do_irq = true;
                        int_pending &= ~IRQ_TRIGGER2;
                        int_pending &= ~IRQ_FRAMEIRQ;
                    }
                }
            }
            while (cyc > 0) {
                curpage = cpu_map[PCH];
                switch (curpage[PCL++] & 0xFF/*OPC*/) {
                case 0x1 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    A =
                        T =
                            A
                            | read_mem(
                                ((RAM[tmp] & 0xFF)
                                 | ((RAM[tmp + 1] & 0xFF) << 8)));
                    cyc -= 72;
                    break;
                case 0x5 :
                    A = T = A | (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0x9 :
                    A = T = A | (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                case 0xd :
                    A =
                        T =
                            A
                            | read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF)
                                    << 8)));
                    cyc -= 48;
                    break;
                case 0x11 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A | read_mem(ea);
                    cyc -= 60;
                    break;
                case 0x15 :
                    A =
                        T =
                            A
                            | (RAM[((curpage[PCL++] & 0xFF) + X)
                                   & 0xFF]
                               & 0xFF);
                    cyc -= 48;
                    break;
                case 0x19 :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A | read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x1d :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    A = T = A | read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x21 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    A =
                        T =
                            A
                            & read_mem(
                                ((RAM[tmp] & 0xFF)
                                 | ((RAM[tmp + 1] & 0xFF) << 8)));
                    cyc -= 72;
                    break;
                case 0x25 :
                    A = T = A & (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0x29 :
                    A = T = A & (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                case 0x2d :
                    A =
                        T =
                            A
                            & read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF)
                                    << 8)));
                    cyc -= 48;
                    break;
                case 0x31 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A & read_mem(ea);
                    cyc -= 60;
                    break;
                case 0x35 :
                    A =
                        T =
                            A
                            & (RAM[((curpage[PCL++] & 0xFF) + X)
                                   & 0xFF]
                               & 0xFF);
                    cyc -= 48;
                    break;
                case 0x39 :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A & read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x3d :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    A = T = A & read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x41 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    A =
                        T =
                            A
                            ^ read_mem(
                                ((RAM[tmp] & 0xFF)
                                 | ((RAM[tmp + 1] & 0xFF) << 8)));
                    cyc -= 72;
                    break;
                case 0x45 :
                    A = T = A ^ (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0x49 :
                    A = T = A ^ (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                case 0x4d :
                    A =
                        T =
                            A
                            ^ read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF)
                                    << 8)));
                    cyc -= 48;
                    break;
                case 0x51 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A ^ read_mem(ea);
                    cyc -= 60;
                    break;
                case 0x55 :
                    A =
                        T =
                            A
                            ^ (RAM[((curpage[PCL++] & 0xFF) + X)
                                   & 0xFF]
                               & 0xFF);
                    cyc -= 48;
                    break;
                case 0x59 :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = A ^ read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x5d :
                    ea = (((curpage[PCL++] & 0xFF)
                            | ((curpage[PCL++] & 0xFF)
                           << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    A = T = A ^ read_mem(ea);
                    cyc -= 48;
                    break;
                case 0x61 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp =
                        read_mem(
                            ((RAM[tmp] & 0xFF)
                             | ((RAM[tmp + 1] & 0xFF) << 8)));
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 72;
                    break;
                case 0x65 :
                    tmp = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 36;
                    break;
                case 0x69 :
                    tmp = (curpage[PCL++] & 0xFF);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 24;
                    break;
                case 0x6d :
                    tmp =
                        read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x71 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 60;
                    break;
                case 0x75 :
                    tmp =
                        (RAM[((curpage[PCL++] & 0xFF) + X)
                             & 0xFF]
                         & 0xFF);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x79 :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x7d :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A + tmp + C;
                    C = (T >> 8) & 1;
                    V = (T ^ A) & (T ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x81 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    write_mem(
                        ((RAM[tmp] & 0xFF)
                         | ((RAM[tmp + 1] & 0xFF) << 8)),
                        A);
                    cyc -= 72;
                    break;
                case 0x85 :
                    RAM[(curpage[PCL++] & 0xFF)] = (byte) A;
                    cyc -= 36;
                    break;
                case 0x89 :
                    cyc -= 24;
                    break;
                case 0x8d :
                    write_mem(
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8)),
                        A);
                    cyc -= 48;
                    break;
                case 0x91 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = (((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    write_mem(ea, A);
                    cyc -= 72;
                    break;
                case 0x95 :
                    RAM[((curpage[PCL++] & 0xFF) + X) & 0xFF] =
                        (byte) A;
                    cyc -= 48;
                    break;
                case 0x99 :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    write_mem(
                        ea,
                        A);
                    cyc -= 60;
                    break;
                case 0x9d :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    write_mem(ea, A);
                    cyc -= 60;
                    break;
                case 0xa1 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    A =
                        T =
                            read_mem(
                                ((RAM[tmp] & 0xFF)
                                 | ((RAM[tmp + 1] & 0xFF) << 8)));
                    cyc -= 72;
                    break;
                case 0xa5 :
                    A = T = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0xa9 :
                    A = T = (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                case 0xad :
                    A =
                        T =
                            read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF) << 8)));
                    cyc -= 48;
                    break;
                case 0xb1 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = read_mem(ea);
                    cyc -= 60;
                    break;
                case 0xb5 :
                    A =
                        T =
                            (RAM[((curpage[PCL++] & 0xFF) + X)
                                 & 0xFF]
                             & 0xFF);
                    cyc -= 48;
                    break;
                case 0xb9 :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    A = T = read_mem(ea);
                    cyc -= 48;
                    break;
                case 0xbd :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    A = T = read_mem(ea);
                    cyc -= 48;
                    break;
                case 0xc1 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    T =
                        A
                        - read_mem(
                            ((RAM[tmp] & 0xFF)
                             | ((RAM[tmp + 1] & 0xFF) << 8)));
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 72;
                    break;
                case 0xc5 :
                    T = A - (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 36;
                    break;
                case 0xc9 :
                    T = A - (curpage[PCL++] & 0xFF);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 24;
                    break;
                case 0xcd :
                    T =
                        A
                        - read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xd1 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    T = A - read_mem(ea);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 60;
                    break;
                case 0xd5 :
                    T =
                        A
                        - (RAM[((curpage[PCL++] & 0xFF) + X)
                               & 0xFF]
                           & 0xFF);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xd9 :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    T = A - read_mem(ea);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xdd :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    T = A - read_mem(ea);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xe1 :
                    tmp = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp =
                        read_mem(
                            ((RAM[tmp] & 0xFF)
                             | ((RAM[tmp + 1] & 0xFF) << 8)));
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 72;
                    break;
                case 0xe5 :
                    tmp = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 36;
                    break;
                case 0xe9 :
                    tmp = (curpage[PCL++] & 0xFF);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 24;
                    break;
                case 0xed :
                    tmp =
                        read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xf1 :
                    tmp = (curpage[PCL++] & 0xFF);
                    ea = ((((RAM[tmp] & 0xFF)
                           | ((RAM[tmp + 1] & 0xFF) << 8)))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 60;
                    break;
                case 0xf5 :
                    tmp =
                        (RAM[((curpage[PCL++] & 0xFF) + X)
                             & 0xFF]
                         & 0xFF);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xf9 :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xfd :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = A - tmp - 1 + C;
                    C = (~T >> 8) & 1;
                    V = (T ^ A) & (A ^ tmp);
                    A = T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x6 :
                    ea = (curpage[PCL++] & 0xFF);
                    tmp = (RAM[ea] & 0xFF);
                    T = (tmp << 1) & 0xFF;
                    C = (tmp >> 7) & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0xe :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    tmp = read_mem(ea);
                    T = (tmp << 1) & 0xFF;
                    C = (tmp >> 7) & 1;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0x16 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp = (RAM[ea] & 0xFF);
                    T = (tmp << 1) & 0xFF;
                    C = (tmp >> 7) & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0x1e :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = (tmp << 1) & 0xFF;
                    C = (tmp >> 7) & 1;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0x26 :
                    ea = (curpage[PCL++] & 0xFF);
                    tmp = (RAM[ea] & 0xFF);
                    T = ((tmp << 1) & 0xFF) | C;
                    C = (tmp >> 7) & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0x2e :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    tmp = read_mem(ea);
                    T = ((tmp << 1) & 0xFF) | C;
                    C = (tmp >> 7) & 1;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0x36 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp = (RAM[ea] & 0xFF);
                    T = ((tmp << 1) & 0xFF) | C;
                    C = (tmp >> 7) & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0x3e :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = ((tmp << 1) & 0xFF) | C;
                    C = (tmp >> 7) & 1;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0x46 :
                    ea = (curpage[PCL++] & 0xFF);
                    tmp = (RAM[ea] & 0xFF);
                    T = tmp >> 1;
                    C = tmp & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0x4e :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    tmp = read_mem(ea);
                    T = tmp >> 1;
                    C = tmp & 1;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0x56 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp = (RAM[ea] & 0xFF);
                    T = tmp >> 1;
                    C = tmp & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0x5e :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = tmp >> 1;
                    C = tmp & 1;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0x66 :
                    ea = (curpage[PCL++] & 0xFF);
                    tmp = (RAM[ea] & 0xFF);
                    T = (tmp >> 1) | (C << 7);
                    C = tmp & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0x6e :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    tmp = read_mem(ea);
                    T = (tmp >> 1) | (C << 7);
                    C = tmp & 1;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0x76 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    tmp = (RAM[ea] & 0xFF);
                    T = (tmp >> 1) | (C << 7);
                    C = tmp & 1;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0x7e :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    tmp = read_mem(ea);
                    T = (tmp >> 1) | (C << 7);
                    C = tmp & 1;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0x86 :
                    RAM[(curpage[PCL++] & 0xFF)] = (byte) X;
                    cyc -= 36;
                    break;
                case 0x8e :
                    write_mem(
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8)),
                        X);
                    cyc -= 48;
                    break;
                case 0x96 :
                    RAM[((curpage[PCL++] & 0xFF) + Y) & 0xFF] =
                        (byte) X;
                    cyc -= 48;
                    break;
                case 0xa6 :
                    X = T = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0xae :
                    X =
                        T =
                            read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF) << 8)));
                    cyc -= 48;
                    break;
                case 0xb6 :
                    X =
                        T =
                            (RAM[((curpage[PCL++] & 0xFF) + Y)
                                 & 0xFF]
                             & 0xFF);
                    cyc -= 48;
                    break;
                case 0xbe :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + Y)
                         & 0xFFFF;
                    if((ea & 0xFF) < Y) cyc -= 12;
                    X = T = read_mem(ea);
                    cyc -= 48;
                    break;
                case 0xc6 :
                    ea = (curpage[PCL++] & 0xFF);
                    T = ((RAM[ea] & 0xFF) - 1) & 0xFF;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0xce :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    T = (read_mem(ea) - 1) & 0xFF;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0xd6 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    T = ((RAM[ea] & 0xFF) - 1) & 0xFF;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0xde :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    T = (read_mem(ea) - 1) & 0xFF;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0xe6 :
                    ea = (curpage[PCL++] & 0xFF);
                    T = ((RAM[ea] & 0xFF) + 1) & 0xFF;
                    RAM[ea] = (byte) T;
                    cyc -= 60;
                    break;
                case 0xee :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    T = (read_mem(ea) + 1) & 0xFF;
                    write_mem(ea, T);
                    cyc -= 72;
                    break;
                case 0xf6 :
                    ea = ((curpage[PCL++] & 0xFF) + X) & 0xFF;
                    T = ((RAM[ea] & 0xFF) + 1) & 0xFF;
                    RAM[ea] = (byte) T;
                    cyc -= 72;
                    break;
                case 0xfe :
                    ea =
                        (((curpage[PCL++] & 0xFF)
                          | ((curpage[PCL++] & 0xFF) << 8))
                         + X)
                        & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    T = (read_mem(ea) + 1) & 0xFF;
                    write_mem(ea, T);
                    cyc -= 84;
                    break;
                case 0x24 :
                    T = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    V = T << 1;
                    if ((A & T) == 0)
                        T |= ~0x1FF;
                    cyc -= 36;
                    break;
                case 0x2c :
                    T =
                        read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    V = T << 1;
                    if ((A & T) == 0)
                        T |= ~0x1FF;
                    cyc -= 48;
                    break;
                case 0x84 :
                    RAM[(curpage[PCL++] & 0xFF)] = (byte) Y;
                    cyc -= 36;
                    break;
                case 0x8c :
                    write_mem(
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8)),
                        Y);
                    cyc -= 48;
                    break;
                case 0x94 :
                    RAM[((curpage[PCL++] & 0xFF) + X) & 0xFF] =
                        (byte) Y;
                    cyc -= 48;
                    break;
                case 0xa4 :
                    Y = T = (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    cyc -= 36;
                    break;
                case 0xac :
                    Y =
                        T =
                            read_mem(
                                ((curpage[PCL++] & 0xFF)
                                 | ((curpage[PCL++] & 0xFF) << 8)));
                    cyc -= 48;
                    break;
                case 0xb4 :
                    Y =
                        T =
                            (RAM[((curpage[PCL++] & 0xFF) + X)
                                 & 0xFF]
                             & 0xFF);
                    cyc -= 48;
                    break;
                case 0xbc :
                    ea = (((curpage[PCL++] & 0xFF)
                           | ((curpage[PCL++] & 0xFF) << 8))
                          + X)
                         & 0xFFFF;
                    if((ea & 0xFF) < X) cyc -= 12;
                    Y = T = read_mem(ea);
                    cyc -= 48;
                    break;
                case 0xc4 :
                    T = Y - (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 36;
                    break;
                case 0xcc :
                    T =
                        Y
                        - read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0xe4 :
                    T = X - (RAM[(curpage[PCL++] & 0xFF)] & 0xFF);
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 36;
                    break;
                case 0xec :
                    T =
                        X
                        - read_mem(
                            ((curpage[PCL++] & 0xFF)
                             | ((curpage[PCL++] & 0xFF) << 8)));
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 48;
                    break;
                case 0x0 :
                    tmp = (PCH << 13) + PCL + 1;
                    RAM[S + 0x100] = (byte) (tmp >> 8);
                    S = (S - 1) & 0xFF;
                    RAM[S + 0x100] = (byte) (tmp);
                    S = (S - 1) & 0xFF;
                    P = (P & 0x3c) | (C) | ((V >> 1) & 0x40) | (T & 0x80);
                    if (T <= 0)
                        P |= 2;
                    P |= 0x10;
                    RAM[S + 0x100] = (byte) P;
                    S = (S - 1) & 0xFF;
                    ea = read_mem(0xFFFE) | (read_mem(0xFFFF) << 8);
                    curpage = cpu_map[PCH = ea >> 13];
                    PCL = ea & 0x1FFF;
                    P |= 4;
                    cyc -= 84;
                    break;
                case 0x8 :
                    P = (P & 0x3c) | (C) | ((V >> 1) & 0x40) | (T & 0x80);
                    if (T <= 0)
                        P |= 2;
                    RAM[S + 0x100] = (byte) (P | 0x10);
                    S = (S - 1) & 0xFF;
                    cyc -= 36;
                    break;
                case 0x18 :
                    C = 0;
                    cyc -= 24;
                    break;
                case 0x20 :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    tmp = (PCH << 13) + PCL - 1;
                    RAM[S + 0x100] = (byte) (tmp >> 8);
                    S = (S - 1) & 0xFF;
                    RAM[S + 0x100] = (byte) (tmp);
                    S = (S - 1) & 0xFF;
                    curpage = cpu_map[PCH = ea >> 13];
                    PCL = ea & 0x1FFF;
                    cyc -= 72;
                    break;
                case 0x28 :
                    S = (S + 1) & 0xFF;
                    P = RAM[S + 0x100] & 0xFF;
                    C = P & 1;
                    V = P << 1;
                    T = ((P & 0x82) ^ 2) | ((P & 2) << 30);
                    cyc -= 48;
                    break;
                case 0x38 :
                    C = 1;
                    cyc -= 24;
                    break;
                case 0x40 :
                    S = (S + 1) & 0xFF;
                    P = RAM[S + 0x100] & 0xFF;
                    C = P & 1;
                    V = P << 1;
                    T = ((P & 0x82) ^ 2) | ((P & 2) << 30);
                    S = (S + 1) & 0xFF;
                    PCL = RAM[S + 0x100] & 0xFF;
                    S = (S + 1) & 0xFF;
                    tmp = RAM[S + 0x100] & 0xFF;
                    PCL += ((tmp & 0x1F) << 8);
                    curpage = cpu_map[PCH = tmp >> 5];
                    cyc -= 72;
                    break;
                case 0x48 :
                    RAM[S + 0x100] = (byte) (A);
                    S = (S - 1) & 0xFF;
                    cyc -= 36;
                    break;
                case 0x58 :
                    P &= ~4;
                    cyc -= 24;
                    break;
                case 0x60 :
                    S = (S + 1) & 0xFF;
                    PCL = RAM[S + 0x100] & 0xFF;
                    S = (S + 1) & 0xFF;
                    tmp = RAM[S + 0x100] & 0xFF;
                    PCL += ((tmp & 0x1F) << 8) + 1;
                    curpage = cpu_map[PCH = tmp >> 5];
                    cyc -= 72;
                    break;
                case 0x68 :
                    S = (S + 1) & 0xFF;
                    T = RAM[S + 0x100] & 0xFF;
                    A = T;
                    cyc -= 48;
                    break;
                case 0x78 :
                    P |= 4;
                    cyc -= 24;
                    break;
                case 0x88 :
                    Y = T = (Y - 1) & 0xFF;
                    cyc -= 24;
                    break;
                case 0x98 :
                    A = T = Y;
                    cyc -= 24;
                    break;
                case 0xa0 :
                    Y = T = (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                case 0xa8 :
                    Y = T = A;
                    cyc -= 24;
                    break;
                case 0xb8 :
                    V = 0;
                    cyc -= 24;
                    break;
                case 0xc0 :
                    tmp = (curpage[PCL++] & 0xFF);
                    T = Y - tmp;
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 24;
                    break;
                case 0xc8 :
                    Y = T = (Y + 1) & 0xFF;
                    cyc -= 24;
                    break;
                case 0xd8 :
                    P &= ~8;
                    cyc -= 24;
                    break;
                case 0xe0 :
                    tmp = (curpage[PCL++] & 0xFF);
                    T = X - tmp;
                    C = (~T >> 8) & 1;
                    T &= 0xFF;
                    cyc -= 24;
                    break;
                case 0xe8 :
                    X = T = (X + 1) & 0xFF;
                    cyc -= 24;
                    break;
                case 0xf8 :
                    P |= 8;
                    cyc -= 24;
                    break;
                case 0xa :
                    T = (A << 1) & 0xFF;
                    C = (A >> 7) & 1;
                    A = T;
                    cyc -= 24;
                    break;
                case 0x2a :
                    T = ((A << 1) & 0xFF) | C;
                    C = (A >> 7) & 1;
                    A = T;
                    cyc -= 24;
                    break;
                case 0x4a :
                    T = A >> 1;
                    C = A & 1;
                    A = T;
                    cyc -= 24;
                    break;
                case 0x6a :
                    T = (A >> 1) | (C << 7);
                    C = A & 1;
                    A = T;
                    cyc -= 24;
                    break;
                case 0x8a :
                    A = T = X;
                    cyc -= 24;
                    break;
                case 0xaa :
                    X = T = A;
                    cyc -= 24;
                    break;
                case 0xca :
                    X = T = (X - 1) & 0xFF;
                    cyc -= 24;
                    break;
                case 0xea :
                    cyc -= 24;
                    break;
                case 0x9a :
                    S = X;
                    cyc -= 24;
                    break;
                case 0xba :
                    X = T = S;
                    cyc -= 24;
                    break;
                case 0x10 :
                    tmp = curpage[PCL++];
                    if ((T & 0x80) == 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0x30 :
                    tmp = curpage[PCL++];
                    if ((T & 0x80) != 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0x50 :
                    tmp = curpage[PCL++];
                    if ((V & 0x80) == 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0x70 :
                    tmp = curpage[PCL++];
                    if ((V & 0x80) != 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0x90 :
                    tmp = curpage[PCL++];
                    if (C == 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0xb0 :
                    tmp = curpage[PCL++];
                    if (C != 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0xd0 :
                    tmp = curpage[PCL++];
                    if (T > 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0xf0 :
                    tmp = curpage[PCL++];
                    if (T <= 0) {
                        if((((PCL & 0xFF) + tmp) & 0x100) != 0)
                            cyc -= 12;
                        PCL += tmp;
                        cyc -= 36;
                        break;
                    } else {
                        cyc -= 24;
                        break;
                    }
                case 0x4c :
                    ea =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    curpage = cpu_map[PCH = ea >> 13];
                    PCL = ea & 0x1FFF;
                    cyc -= 36;
                    break;
                case 0x6c :
                    tmp =
                        ((curpage[PCL++] & 0xFF)
                         | ((curpage[PCL++] & 0xFF) << 8));
                    if ((tmp & 0xFF) != 0xFF)
                        ea = read_mem(tmp) | (read_mem(tmp + 1) << 8);
                    else
                        ea = read_mem(tmp) | (read_mem(tmp & 0xFF00) << 8);
                    curpage = cpu_map[PCH = ea >> 13];
                    PCL = ea & 0x1FFF;
                    cyc -= 60;
                    break;
                case 0xa2 :
                    X = T = (curpage[PCL++] & 0xFF);
                    cyc -= 24;
                    break;
                default :
                    break;
                }
                if((PCL & ~0x1FFF) != 0) {
                    ea = (PCH << 13) + PCL;
                    curpage = cpu_map[PCH = ea >> 13];
                    PCL = ea & 0x1FFF;
                    //System.out.println(" -> PC (" + Integer.toHexString(ea) + ")");
                }
            }

            if (do_nmi) {
                P &= ~0x10;
                tmp = (PCH << 13) + PCL;
                RAM[S + 0x100] = (byte) (tmp >> 8);
                S = (S - 1) & 0xFF;
                RAM[S + 0x100] = (byte) (tmp);
                S = (S - 1) & 0xFF;
                P = (P & 0x3c) | (C) | ((V >> 1) & 0x40) | (T & 0x80);
                if (T <= 0)
                    P |= 2;
                RAM[S + 0x100] = (byte) P;
                S = (S - 1) & 0xFF;
                ea = read_mem(0xFFFA) | (read_mem(0xFFFB) << 8);
                curpage = cpu_map[PCH = ea >> 13];
                PCL = ea & 0x1FFF;
                P |= 4;
                cyc -= 84;
            }
            if (do_irq) {
                P &= ~0x10;
                tmp = (PCH << 13) + PCL;
                RAM[S + 0x100] = (byte) (tmp >> 8);
                S = (S - 1) & 0xFF;
                RAM[S + 0x100] = (byte) (tmp);
                S = (S - 1) & 0xFF;
                P = (P & 0x3c) | (C) | ((V >> 1) & 0x40) | (T & 0x80);
                if (T <= 0)
                    P |= 2;
                RAM[S + 0x100] = (byte) P;
                S = (S - 1) & 0xFF;
                ea = read_mem(0xFFFE) | (read_mem(0xFFFF) << 8);
                curpage = cpu_map[PCH = ea >> 13];
                PCL = ea & 0x1FFF;
                P |= 4;
                cyc -= 84;
            }
            cyc += cyc_pending;
            cyc_pending = 0;
            PC = (PCH << 13) + PCL;
        } while (cyc > 0);
        this.A = A;
        this.X = X;
        this.Y = Y;
        this.S = S;
        this.P_BI = P;
        this.P_C  = C; 
        this.P_V  = V; 
        this.P_ZN = T; 
        if(exclk_mapper){
        	mapper.Clock(exec_cycle);
        }
        cyc_pending += cyc;
    }
    
}
