package dojapcmsound;

class PcmAudioHandler_N505i extends PcmAudioHandler {

	private final int SAMPLECOUNT_MAXVAL;
	private final int OUTBUF_SIZE; 
	private final byte[] mldheader,mldfooter;

	PcmAudioHandler_N505i() {
		mldheader = loadLocalResouce("resource:///N505head.mld");
		mldfooter = loadLocalResouce("resource:///N505foot.mld");
		
		SAMPLECOUNT_MAXVAL = (0xFFFF - 8) * 2;		//ExclusiveMsgɂ鐧B4bitTvȂ̂2{B
		OUTBUF_SIZE = SAMPLECOUNT_MAXVAL / 2 + 500;	//Tvobt@ + wb_ƃtb^ƂB

		resetEncoder();
	}

	protected byte[] getMld() {
		int sampleSize;
		int mldSize;
		int tracSize;

		if(bufferredSampleCount == 0) return null;

		//Tvalign
		//ŏITvFFƂ00ƂAmCYɂȂȂH
		if(bufferredSampleCount % 2 != 0) bufferredSampleCount++;

		sampleSize = bufferredSampleCount / 2;	    
		mldSize = mldheader.length + mldfooter.length + sampleSize;
		tracSize = mldSize - 110;	//wb_TRAC`Nf[^܂ł̃ItZbg

		System.arraycopy(mldfooter, 0, outbuf, mldheader.length + sampleSize , mldfooter.length);

		//MLDTCY
		outbuf[4] = (byte)(mldSize - 8 >> 24); 
		outbuf[5] = (byte)(mldSize - 8 >> 16); 
		outbuf[6] = (byte)(mldSize - 8 >> 8); 
		outbuf[7] = (byte)(mldSize - 8 >> 0);
		//TRACTCY
		outbuf[106] = (byte)(tracSize >> 24);
		outbuf[107] = (byte)(tracSize >> 16);
		outbuf[108] = (byte)(tracSize >> 8);
		outbuf[109] = (byte)(tracSize >> 0);
		//TvExclusiveMsg
		outbuf[143] = (byte)(sampleSize + 8 >> 8);
		outbuf[144] = (byte)(sampleSize + 8);
		//Tv[g
		outbuf[mldheader.length - 2] = (byte)(sampleRate >> 8);
		outbuf[mldheader.length - 1] = (byte)sampleRate;		

		//Tvƃ[gĐԌvZčĐI삵Ȃ_

		return  outbuf;
	}

	public void writeSample(int inputSample) {

		if(bufferredSampleCount >= SAMPLECOUNT_MAXVAL) return;

		//Tvobt@m
		if(bufferredSampleCount == 0) {
			outbuf = new byte[OUTBUF_SIZE];
			System.arraycopy(mldheader, 0, outbuf, 0, mldheader.length);
			resetEncoder();
		}

		//LSB
		if(bufferredSampleCount % 2 == 0)
			outbuf[mldheader.length + bufferredSampleCount / 2] =
				(byte)(encode(inputSample) & 0x0F);
		//MSB
		else  
			outbuf[mldheader.length + bufferredSampleCount / 2] |=
				(byte)(encode(inputSample) << 4);

		bufferredSampleCount++;
	}	


//	------------------------------------
//	Yamaha.adpcmGR[hp
//	------------------------------------
	private int index;
	private int last;		

	private void resetEncoder() {
		index = 127;
		last = 0;
	}

	private int adjust(int code, int SS)
	{
		switch (code & 0x07){
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
			SS = (SS * 115) / 128;
			break;

		case 0x04:
			SS = (SS * 307) / 256;
			break;

		case 0x05:
			SS = (SS * 409) / 256;
			break;

		case 0x06:
			SS = (SS * 2);
			break;

		case 0x07:
			SS = (SS * 307) / 128;
			break;
		}

		if (SS < 127)       SS = 127;
		if (SS > 32768*3/4) SS = 32768*3/4;

		return SS;
	}

	private int decode(int code)
	{
		int diff, E, SS, samp;

		SS = index;
		E = SS/8;
		if ((code & 0x01) != 0)
			E += SS/4;
		if ((code & 0x02) != 0)
			E += SS/2;
		if ((code & 0x04) != 0)
			E += SS;
		diff = ((code & 0x08) != 0) ? -E : E;
		samp = last + diff;

		if (samp > 32767)  samp = 32767;
		if (samp < -32768) samp = -32768;

		last = samp;
		index = adjust(code, SS);

		return( last );
	}

	private int encode(int samp)
	{
		int code, diff, E, SS;

		SS = index;
		code = 0x00;
		if( (diff = samp - last) < 0 )
			code = 0x08;
		E = diff < 0 ? -diff : diff;
		if( E >= SS ) {
			code = code | 0x04;
			E -= SS;
		}
		if( E >= SS/2 ) {
			code = code | 0x02;
			E -= SS/2;
		}
		if( E >= SS/4 ) {
			code = code | 0x01;
		}

		last = decode(code);
		return( code );
	}
}