package dojapcmsound;

class PcmAudioHandler_SA702i extends PcmAudioHandler {

	private final int SAMPLECOUNT_MAXVAL;
	private final int OUTBUF_SIZE;

	private final G721encoder encoder;
	private final byte[] mldheader,mldfooter;


	PcmAudioHandler_SA702i() {
		mldheader = loadLocalResouce("resource:///SA702head.mld");
		mldfooter = loadLocalResouce("resource:///SA702foot.mld");
		
		SAMPLECOUNT_MAXVAL = (0xFFFF - 8) * 2;
		OUTBUF_SIZE = SAMPLECOUNT_MAXVAL / 2 + 500;
		
		encoder = new G721encoder();
	}

	protected byte[] getMld() {
		int sampleSize;
		int mldSize;
		int adatSize;
		int rateCode;

		if(bufferredSampleCount == 0) return null;

		//Tvalign
		if(bufferredSampleCount % 2 != 0) bufferredSampleCount++;
		
		switch(sampleRate) {
		case 8000:
			rateCode = 0x08;
			break;
		case 16000:
			rateCode = 0x10;
			break;
		case 32000:
			rateCode = 0x20;
			break;
		default :
			rateCode = 0x08;
			break;
		}

		sampleSize = bufferredSampleCount / 2;	    
		mldSize = mldheader.length + mldfooter.length + sampleSize;
		adatSize = sampleSize + 13;	//adat`NTCYBTvTCY + adpmwb_ƂB

		System.arraycopy(mldfooter, 0, outbuf, mldheader.length + sampleSize , mldfooter.length);

		//MLDTCY
		outbuf[4] = (byte)(mldSize - 8 >> 24); 
		outbuf[5] = (byte)(mldSize - 8 >> 16); 
		outbuf[6] = (byte)(mldSize - 8 >> 8); 
		outbuf[7] = (byte)(mldSize - 8 >> 0);
		//ADAT`NTCY
		outbuf[79] = (byte)(adatSize >> 24);
		outbuf[80] = (byte)(adatSize >> 16);
		outbuf[81] = (byte)(adatSize >> 8);
		outbuf[82] = (byte)(adatSize >> 0);
		//Tv[g
		outbuf[93] = (byte)rateCode;

		clearSample();
		return  outbuf;
	}

	public void writeSample(int inputSample) {

		if(bufferredSampleCount >= SAMPLECOUNT_MAXVAL) return;

		//Tvobt@m
		if(bufferredSampleCount == 0) {
			outbuf = new byte[OUTBUF_SIZE];
			System.arraycopy(mldheader, 0, outbuf, 0, mldheader.length);
			encoder.initState();
		}

		//LSB
		if(bufferredSampleCount % 2 == 0) 
			outbuf[mldheader.length + bufferredSampleCount / 2] = 
				(byte)(encoder.encode(inputSample) & 0x0F);
		//MSB
		else 
			outbuf[mldheader.length + bufferredSampleCount / 2] |=
				(byte)(encoder.encode(inputSample) << 4);

		bufferredSampleCount++;
	}	
}
