package dojapcmsound;

class PcmAudioHandler_SH252i extends PcmAudioHandler {

	private final int SAMPLECOUNT_MAXVAL;
	private final int OUTBUF_SIZE;

	private final G721encoder encoder;
	private final byte[] mldheader,mldfooter;


	PcmAudioHandler_SH252i() {
		mldheader = loadLocalResouce("resource:///SH252head.mld");
		mldfooter = loadLocalResouce("resource:///SH252foot.mld");
		
		SAMPLECOUNT_MAXVAL = (0xFFFF - 8) * 2;
		OUTBUF_SIZE = SAMPLECOUNT_MAXVAL / 2 + 500;
		
		encoder = new G721encoder();
	}

	protected byte[] getMld() {
		int sampleSize;
		int mldSize;
		int tracSize;
		int rateCode;

		if(bufferredSampleCount == 0) return null;

		//Tvalign
		if(bufferredSampleCount % 2 != 0) bufferredSampleCount++;
		
		switch(sampleRate) {
		case 8000:
			rateCode = 0x45;
			break;
		case 16000:
			rateCode = 0x4D;
			break;
		case 32000:
			rateCode = 0x55;
			break;
		default :
			rateCode = 0x45;
			break;
		}

		sampleSize = bufferredSampleCount / 2;	    
		mldSize = mldheader.length + mldfooter.length + sampleSize;
		tracSize = mldSize - 149;	//1g߃TCYBwb_2gȍ~BSĤ͉4gB

		System.arraycopy(mldfooter, 0, outbuf, mldheader.length + sampleSize , mldfooter.length);

		//MLDTCY
		outbuf[4] = (byte)(mldSize - 8 >> 24); 
		outbuf[5] = (byte)(mldSize - 8 >> 16); 
		outbuf[6] = (byte)(mldSize - 8 >> 8); 
		outbuf[7] = (byte)(mldSize - 8 >> 0);
		//TRACTCY
		outbuf[53] = (byte)(tracSize >> 24);
		outbuf[54] = (byte)(tracSize >> 16);
		outbuf[55] = (byte)(tracSize >> 8);
		outbuf[56] = (byte)(tracSize >> 0);
		//TvExclusiveMsg
		outbuf[103] = (byte)(sampleSize + 9 >> 8);
		outbuf[104] = (byte)(sampleSize + 9);
		//Tv
		outbuf[112] = (byte)(sampleSize >> 8);
		outbuf[113] = (byte)(sampleSize);
		//Tv[g
		outbuf[108] = (byte)rateCode; // 

		clearSample();
		return  outbuf;
	}

	public void writeSample(int inputSample) {

		if(bufferredSampleCount >= SAMPLECOUNT_MAXVAL) return;

		//Tvobt@m
		if(bufferredSampleCount == 0) {
			outbuf = new byte[OUTBUF_SIZE];
			System.arraycopy(mldheader, 0, outbuf, 0, mldheader.length);
			encoder.initState();
		}

		//LSB
		if(bufferredSampleCount % 2 == 0) 
			outbuf[mldheader.length + bufferredSampleCount / 2] = 
				(byte)(encoder.encode(inputSample) & 0x0F);
		//MSB
		else 
			outbuf[mldheader.length + bufferredSampleCount / 2] |=
				(byte)(encoder.encode(inputSample) << 4);

		bufferredSampleCount++;
	}	
}
