import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.Vector;

import javax.microedition.io.Connector;

import com.nttdocomo.fs.File;
import com.nttdocomo.system.ImageStore;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.TextBox;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.ImageEncoder;
import com.nttdocomo.ui.EncodedImage;
import com.nttdocomo.ui.PhoneSystem;
import com.nttdocomo.io.HttpConnection;
import com.nttdocomo.io.ConnectionException;
//import com.nttdocomo.opt.ui.Canvas2;
import com.nttdocomo.opt.ui.Display2;
import com.nttdocomo.opt.ui.PhoneSystem2;
import com.nttdocomo.opt.ui.PointingDevice;

public final class NESCanvas extends Canvas {

    private static final String VERSION_STR
               = "    NemulatorPlus Ver.1.25.17 \n     - Nemulator Ver.1.25c\n     - FDS Ver.17"
               + "\n             +\n     - NemuLite Ver.1.25c.05c\n     - NemuPlus Ver2 Beta-1"
               + "\n     - N90Xpointer(ossan)"
               + "\n     - ROMt(508)";
    private static final String SOFTKEY_ROOT_STR   = "MENU";
    private static final String SOFTKEY_ROM_STR    = "̕ҏW";
    private static final String SOFTKEY_KEYSET_STR = "ݒر";
    private static final String SOFTKEY_SAVE_STR   = "ް폜";
    private static final String SOFTKEY_PAD_STR    = "PADݒ";
    private static final String SOFTKEY_CHEAT_STR  = "CHEAT";
    private static final String SOFTKEY_RESET_STR  = "RESET";
    private static final String SOFTKEY_DISK_STR   = "DISK";
    private static final String SOFTKEY_ROMSET_STR = "ROMݒ";
    private static final String SOFTKEY_RET_STR    = " ߂ ";
    private static final String SOFTKEY_EXIT_STR   = " I ";
    private static final String SOFTKEY_INIT_STR   = "";
    private static final String SOFTKEY_ZOOM_STR   = "`̈";

    /**
     * ScratchPadpo[W.
     * ꂪƂɏNScratchPadf[^ړB
     */
    private static final int VERSION = 502;

    // 萔
    private static final int MODE_NONE = 0;
    private static final int MODE_GAME = 1;
    private static final int MODE_MENU_ROOT = 2;
    private static final int MODE_MENU_SAVE = 3;
    private static final int MODE_MENU_LOAD = 4;
    private static final int MODE_MENU_ROM = 5;
    private static final int MODE_MENU_EXPORT = 6;
    private static final int MODE_MENU_IMPORT = 7;
    private static final int MODE_MENU_SETTING = 8;
    private static final int MODE_MENU_KEYCON = 9;
    private static final int MODE_MENU_KEYCON_SET = 10;
    private static final int MODE_MENU_BUTTON_SET = 11;
    private static final int MODE_MENU_MICKEY_SET = 12;
    private static final int MODE_MENU_CHEAT_SET = 13;
    private static final int MODE_MENU_SOFTKEY = 14;
    private static final int MODE_MENU_ROMFILE = 15;
    private static final int MODE_MENU_CONFIRM = 16;
    private static final int MODE_MENU_AUDIO1_SET = 17;
    private static final int MODE_MENU_DISKSIDE = 18;
    private static final int MODE_MENU_TOOLS = 19;
    private static final int MODE_MENU_AUDIO2_SET = 20;
    private static final int MODE_MENU_AUDIO3_SET = 21;
    private static final int MODE_MENU_ROMSET = 22;
    private static final int MODE_MENU_SELECT_CORE = 23;
    private static final int MODE_ZOOM_SET = 24;
    private static final int MODE_MENU_KEYCON2 = 25;
    private static final int MODE_MENU_KEYCON2_SET = 26;
    private static final int MODE_MENU_OTHER_SET = 27;
    private static final int MODE_DIALOG = 28;
    /** Z[uf[^. */
    private static final int NUM_SAVE = 12;

    /** y[WSDROM. */
    private static final int NUM_SDROM = 12;
    
    /** őSDROM y[W. */
    private static final int MAX_SDROM_PAGE = 20;

    /** Z[uf[^P̃TCY. */
    //private static final int SIZE_SAVE = 24000;
    private static final int SIZE_SAVE = 60000;

    /*
     * ݒۑp̃TCY.
     */
    private static final int SIZE_SP_OTHERS = 400;
    private static final int SIZE_SP_KEYS = 240;
    private static final int SIZE_SP_SAVES = 500;
    private static final int SIZE_SP_ADJUST = 120; //(NUM_SDROM * MAX_SDROM_PAGE) / 2
    private static final int SIZE_SP_RESERVE = 40;
    private static final int SIZE_SP_SETTING = 1300;

    /*
     * ߋo[W̃TCY.
     */
    private static final int SIZE_SP_OTHERS_500 = 100;
    private static final int SIZE_SP_KEYS_500 = 240;
    private static final int SIZE_SP_SAVES_500 = 500;
    private static final int SIZE_SP_ADJUST_500 = 120; //(NUM_SDROM * MAX_SDROM_PAGE) / 2
    private static final int SIZE_SP_RESERVE_500 = 40;
    private static final int SIZE_SP_SETTING_500 = 1000;

    private static final int SIZE_SP_OTHERS_501 = 200;
    private static final int SIZE_SP_KEYS_501 = SIZE_SP_KEYS_500;
    private static final int SIZE_SP_SAVES_501 = SIZE_SP_SAVES_500;
    private static final int SIZE_SP_ADJUST_501 = SIZE_SP_ADJUST_500;
    private static final int SIZE_SP_RESERVE_501 = SIZE_SP_RESERVE_500;
    private static final int SIZE_SP_SETTING_501 = 1100;

    /** Save1̖OB{Game. */
    private static final int SIZE_SAVE_NAME = 34;

    /** ROM̒ */
    private static final int SIZE_ROM_NAME = 30;
    
    /** ROM LbV **/
    //private static final int START_SP_ROMDATA   =  0x3000;
    //private static final int SIZE_SP_BIOS       =  0x2000; //0x03000 - 0x05000
    //private static final int SIZE_SP_SRAM       =  0x4000; //0x05000 - 0x09000
    //private static final int SIZE_SP_ROM        = 0xA1000; //0x09000 - 0xAA000
    //private static final int SIZE_SP_SAVE12     = 0x10000; //0xAA000 - 0xBA000

    /* Exportp1Block̃TCY */
    private static final int EXPORT_BLOCK_SIZE = 255;

    /* ɏ`[g̐ */
    private static final int NUM_CHEAT = 4;

    // j[e
    String[] MENU_ROOT =
        new String[] {
            "ROMI",
            "f[^[h",
            "f[^Z[u",
            "Zbg",
            "Sʐݒ",
            "L[ݒ",
            "pbh@\ݒ",
            "fBXN",
            "ȈՃ`[g",
            "c[",
            "Ver.",
            "COREI"};

    String[] MENU_KEYCON =
        new String[] {
            "A{^",
            "B{^",
            "SELECT{^",
            "START{^",
            "L[",
            "L[",
            "L[",
            "L[",
            "[h",
            "Z[u",
            "ڰѽ+1",
            "ڰѽ-1" };

    String[] MENU_KEYCON2 =
        new String[] {
            "}CNL[",
            "Q[̍\tgL[",
            "Q[̉E\tgL[",
            "pbhݒL[",
            "ȈՃ`[gďoL[",
            "ZbgL[",
            "TEhݒL[",
            "fBXNL[",
            "ROM\L[",
            "`̈ݒL[",
            "ȈՃZ[uL[" };

    String[] SOFTKEY_SOUND_STR  = new String[] {" ~ ", "  "};
    String[] ON_OFF_STR = new String[] { "OFF", "ON" };
    String[] PRELOAD_STR = new String[] { "OFF", "ON" };
    String[] FRAMES_STR = new String[] { "OFF", "LIMIT", "AUTO" };
    String[] CTRL_STR = new String[] { "1P", "1P/2P", "2P" };
    String[] RSPEED_STR = new String[] { "OFF", "1()" ,"2()", "3()", "4(ᑬ)", "5(ᑬ)"};
    String[] FLIPMODE_STR = new String[] { "ʏ", "E90", "180", "90" };
    String[] RENDERMODE_STR = new String[] {"","Cx[X[]","Cx[X[O]","\x[X[]","\x[X[O]","^Cx[X"};
    String[] ZOOM_STR = new String[] {"W","g","Ch","t","t["};
    String[] FPSDISP_STR = new String[] {"(X^bN)","(tB)","(TCh)",""};

    String[] SOFTKEY_STR = 
        new String[] {
            "pbhݒ",
            "ȈՃ`[g",
            "Zbg",
            "TEh",
            "Cӷݒ",
            "fBXN",
            "ROM",
            "`̈",
            "CYCLE" };
    String[] BGCOLOR_STR = new String[] { "blue", "gray" };
    String[] SOUND_STR = new String[] { "PRESET", "N-MODE", "P-MODE", "CUSTOM" };
    String[] MINVOL_STR = new String[] { "W", "", "傫" };
    String[] SOUND_MODE_STR = new String[] { "N505i", "SH252i", "SA702i", "MODE 1", "MODE X(NP2)" };
    String[] SOUND_FILTER_STR = new String[] { "NONE", "LOW-PASS", "WEIGHTED" };
    public int[] SOUND_RATE_ARRAY = new int[] { 8000, 16000, 32000 };
    String[] POINTER_STR = new String[] { "4", "8" };
    String[] SOFTKEY_BGCOLOR_STR = new String[] { "BLUE", "GRAY", "BLACK", "BLUE+", "GRAY+", "BLACK+" };
    String[] DIALOG_STR = new String[] { "Doja", "Ǝ(DojaF)", "Ǝ(ÐF)" };

    // CX^Xϐ
    private NESCore core;
    private PSGi psgi;
    private Disp disp;
    private ROMCache romcache;

    public final int fb[] = new int[256 * 256];
    private int joypad, joypadBit, joypadBit2, joypadMic;
    private final int padTbl[][] = new int[][] {
                                  { 0, 1, 2, 3, 4, 5, 6, 7},
                                  { 0, 1, 2, 3, 6, 7, 5, 4},
                                  { 0, 1, 2, 3, 5, 4, 7, 6},
                                  { 0, 1, 2, 3, 7, 6, 4, 5}};
    private int frame_count, last_frame;
    private int skippedFrameCount;
    private long lastTime_, startTime_;
    private String messageStr = "";

    public static final int CORE_ORIGINAL = 0;
    public static final int CORE_SOFTBANK = 1;
    public static final int CORE_NEMUPLUS2 = 2;

    // Doja-5.1 DisplayNX "KEY_XYZ" ꗗ
    String[] KEY_DESC = 
        new String[] {
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "?",
            "?",
            "?",
            "?",
            "",
            "",
            "",
            "",
            "~",
            "",
            "E",
            "?",
            "",
            "",
            "",
            "",
            "",
            "I",
            "",
            "",
            "",
            "w",
            "",
            "?",
            "?",
            "?",
            "?",
            "޲",
            "?",
            "?",
            "GPS",
            "?",
            "?",
            "?",
            "?",
            "?",
            "۰",
            "E۰",
            "w1",
            "w2",
            "w3",
            "Myڸ",
            "?",
            "?",
            "?",
            "ްѲ",
            "ްѱ",
            "()",
            "?" };

    /////////////////////////////////
    // ݒ荀
    /////////////////////////////////
    // fps
    int fps_ = 0;
    // FrameSkip
    private int frameSkip_ = 5;
    // fps\邩ǂB
    private boolean fpsOff_;
    // NɑOROMǂݍނB
    private boolean startAndLoad_;
    // A{^A
    private int aRen_ = 0;
    // B{^A
    private int bRen_ = 0;
    // A{^z[h
    private int aHold_ = 0;
    // B{^z[h
    private int bHold_ = 0;
    // 2PRg[
    private int con2p_ = 0;
    // A˃JE^
    private int rcount_ = 0;
    // j[̓
    private boolean alpha_;
    // }CNL[ݒ
    private int mickey_ = 0;
    // x(60FPS)
    private int sleep_ = 0;
    // 90](0:ʏA1:EA2:180A3:)
    private int flipMode_ = 0;
    private int flipModeKey_ = 0;
    // E\tgL[̋@\
    private int rSoftkey_ = 0;
    // j[wiF
    private int menuBGcolor_ = 0;
    // mFbZ[W
    private int confirmMsg_ = 0;
    // NtO
    private boolean firstExec_ = false;
    // SDROMt@CXg
    private String[] sdRomnm_ = new String[NUM_SDROM];
    // SDROMAWXgXg
    private int[] sdRomadj_ = new int[NUM_SDROM * MAX_SDROM_PAGE];
    // OSDROMԍ
    private int sdNo_ = 0;
    // SRAMZ[ut@C
    private String saveFile_ = null;
    // SDt@Cy[W
    private int sdPage_ = 0;
    // Save{Game
    private String[] saveStr_ = new String[NUM_SAVE];
    // ݒޔ
    private int svframeSkip_ = 0;
    // E\tgL[}XN
    private int skeyMask_ = 0;
    
    // APU MODE
    // TEh@탂[h
    public int soundMode;
    // TEho
    public int soundEnable = 0;
    // TEhʒl
    public int soundVolume = 100;
    // TEhChIt
    public boolean channelOff_[];
    {
        channelOff_ = new boolean[4];
        for(int i = 0; i < 4; i++) channelOff_[i] = false;
    }
    // TEhChIt2
    public boolean pcm_channelOff_[];
    {
        pcm_channelOff_ = new boolean[6];
        for(int i = 0; i < 6; i++) pcm_channelOff_[i] = false;
    }
    /*FOR APU1*/
    // TEhF
    public int sound_ = 0;
    // gݍ݉Fݒ
    public int[] instNum_ = new int[4];
    /*FOR APU2*/
    // TEhĐTv[g
    public int soundSampleRate;
    // TEhobt@ t[JEg
    public int soundBufCount;
    // Apuo̓tB^[h
    public int soundApuFilter;

    /* FOR APU3 - NP2I[fBI */    
    // TEhF
    public int np2_sound_ = PSGi.MODE_PRESET;
    public int[] np2_instNum_ = new int[5];
    // TEhʒl -> soundVolumegp
    //private int volValue_ = 100;
    // TEho -> soundEnablegp
    //private boolean sVol_ = false;
    // TEhChIt
    private boolean sCh1Off_ = false;
    private boolean sCh2Off_ = false;
    private boolean sCh3Off_ = false;
    private boolean sCh4Off_ = false;
    // TEhobt@
    private int sbuf_ = 16;
    // RAI
    //private int core_ = CORE_ORIGINAL;
    public int core_ = CORE_ORIGINAL;
    // Y[
    private int zoom_ = 0;
    private int svZoom_ = 0;
    private int fpsDisp_ = 3;
    // 0:t[(TCY),1:t[(ʒu) Ŏgp
    private int pos_x[] = new int[2];
    private int pos_y[] = new int[2];

    // ̑
    private boolean showSoftLabel_ = true; // Q[̃\tgx\L
    private boolean reverseEnable_ = false; // ʂ̔
    private boolean rotateEnable_ = false; // Fۂ[V
    private int wt_on_game_ = 0; // Q[̃\tgL[(~b)
    private int wt_on_refresh_ = 200; // ʃtbV̕`҂(~b)
    private boolean use_vgafont_ = false; // QVGAłVGAtHggǂ
    // ƭۗp
    private boolean pointerEnable_ = false;
    private byte pointerSense_ = 0;
    private boolean pointerType_ = false;
    // ROMLbV
    private boolean noRomCache_ = false;
    private int compressMode_ = 0;
    private boolean noCompress_ = false;
    // V_CAO (0:IWiA1:V+悤ȐFA2:V+ÐF)
    private int dialogType_ = 1;
    /////////////////////////////////
    // ̑CX^X
    /////////////////////////////////
    // N̓j[\
    private int mode_ = MODE_MENU_ROM;
    // JgROM
    private String curRom_ = "";
    // SDROMy[Wԍ
    private int page_ = 1;
    // rootj[Iԍ
    private int selectMenuNo_ = 0;
    // SubMenu
    private int selectSubMenuNo_ = 0;
    //private int[] svSubMenuNo_ = new int[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    private int svSubMenuLoadNo = 0;
    private int svSubMenuSaveNo = 0;
    private int svSubMenuSettingNo = 0;
    private int svSubMenuCheatNo = 0;
    private int svSubMenuKeyConfNo = 0;
    private int svSubMenuPadNo = 0;
    private int svSubMenuToolNo = 0;
    private int svSubMenuImportNo = 0;
    private int svSubMenuExportNo = 0;
    private int svSubMenuRomsetNo = 2;
    private int svSubMenuAudioSetting1No = 0;
    private int svSubMenuAudioSetting2No = 0;
    private int svSubMenuAudioSetting3No = 0;
    private int svSubMenuRomFileNo = 0;
    private int svSubMenuConfirmNo = 0;
    private int svSubMenuOtherNo = 0;
    private int svSubMenuKeyConfPage = 1;

    //j[Ɏgp
    private static final int SELECT = 0;
    private static final int LEFT = 1;
    private static final int RIGHT = 2;

    // SubMenuXg
    String[] subMenu_ = new String[1];
    // L[ݒ
    String[] keyconStr_ = new String[MENU_KEYCON.length];
    byte[] keycon2_ = new byte[MENU_KEYCON2.length];
    int[][] keyConfig_ = new int[keyconStr_.length][];
    // pbh@\ptO
    private boolean padDisp_ = false;
    // t[
    public float adjust_cycle = 0.0f;
    // t[ - NP2RA
    public int adjust_dozencycle = 0;
    // ftHg`ʃ[h - NP2RA
    public int change_method = NESCore_NP2.UNKNOWN_RENDER;
    // `[g֘A
    private String cheat_;
    private boolean[] chtSwitch_ = new boolean[NUM_CHEAT];
    private String[] chtStr_ = new String[NUM_CHEAT];
    private int[] chtS_ = new int[NUM_CHEAT];
    private int[] chtAdr_ = new int[NUM_CHEAT];
    private int[] chtK_ = new int[NUM_CHEAT];
    private byte[][] chtDat_ = new byte[NUM_CHEAT][4];
    // Y[
    private int scale = 2; //ׂĂ̕menuGVGAo
    private int mscale = 2; //ʏʂ݂menuG̑傫
    private int zoomMask_ = 0;
    private boolean zoomSizeMode_ = true;
    private boolean pos_reset = false;
    // ޔp
    private int svPos_x4 = 0;
    private int svPos_y4 = 0;
    //ŋNǂ
    private boolean widedisplay_ = false;
    // L[ݒ2
    private boolean keycon2_set = false;
    private int keycon1 = 0;
    // 
    private boolean soft1Pressed = false;
    private boolean soft2Pressed = false;
    private boolean keyLongPressed = false;
    // V_CAOp
    // confirm͓Qs邱ƂŎ邵ڂȂ̂ŁA
    // Q񏈗ɌȂӏɂ dialogNotReady tO𗧂ċ̃_CAO\B
    // ̂قAj[ʂȂ_CAO\łȂʂł dialogNotReady 𗧂ĂB
    // ({Iɂ mode_ = MODE_GAME ɓƂɂ͗Ă)
    // svMode ̓_CAOO mode_ ۑpBsvParam lB
    // {Iɂ͎_CAO͑Sʂ̃Av[`ŎȂƂ߂
    public boolean dialogNotReady = true;
    private boolean dialogPressed = false;
    private boolean dialogReleased = false;
    private boolean dialogShowed = false;
    private boolean dialogYes = true;
    private int dialogMode = 0;
    private String dialogMessage = "";
    private int svMode = mode_;
    private int svParam = 0;

    private Image img;
    private Image allImg = null; //]pS̃C[W
    private Graphics allG = null;

    //private Image fb2 = null;
    public Image fb2 = null;
    private Graphics fb2G = null;

    private Image menuImg = null;
    private Graphics menuG = null;
    private Image msgImg = null;
    private Graphics msgG = null;

    private byte[] GIF_HEADER = { 'G', // 0x47
        'I', // 0x49
        'F', // 0x46
        '8', // 0x38
        '9', // 0x39
        'a', // 0x61
        0x01,
            0x00,
            0x01,
            0x00,
            0x80 - 0x100,
            0x00,
            0x00,
            0xFF - 0x100,
            0xFF - 0x100,
            0xFF - 0x100,
            0x00,
            0x00,
            0x00,
            0x2C,
            0x00,
            0x00,
            0x00,
            0x00,
            0x01,
            0x00,
            0x01,
            0x00,
            0x00,
            0x02,
            0x02,
            0x44,
            0x01,
            0x00,
            0x21,
            0xFE - 0x100 };

    private final Font DEFAULT_FONT;
    private Font MENU_DEFAULT_FONT;
    private int HEIGHT_LINE;
    private int BASE_LINE;
    private int DIALOG_HEIGHT_LINE;
    private int DIALOG_BASE_LINE;

    // [h
    private int MY_KEY_LEFT = Display.KEY_LEFT;
    private int MY_KEY_UP = Display.KEY_UP;
    private int MY_KEY_RIGHT = Display.KEY_RIGHT;
    private int MY_KEY_DOWN = Display.KEY_DOWN;

    // Q[̉E\tgL[̏ꏊύXp
    private int MY_KEY_SOFT1 = Display.KEY_SOFT1;
    private int MY_KEY_SOFT2 = Display.KEY_SOFT2;

    private int MENU_WIDTH;
    private int MENU_HEIGHT;

    public int width;
    public int height;

    NESCanvas() {
        setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
        setBackground(Graphics.getColorOfName(Graphics.BLACK));

        fb2 = Image.createImage(256, 256);
        fb2G = fb2.getGraphics();

        for (int i = 0; i < keycon2_.length; i++)
            keycon2_[i] = 0xFF - 0x100;
        keycon2_[1] = (byte)MY_KEY_SOFT1;
        keycon2_[2] = (byte)MY_KEY_SOFT2;

        try {
            MediaImage mi = MediaManager.getImage("resource:///title.gif");
            mi.use();
            img = mi.getImage();
        } catch (IOException e) {}

        // XNb`pbhǍ
        readSP();
        readSPkeys();
        readSPsaves();
        readSPadjusts();
        // SDt@CPy[W쐬
        if (!firstExec_) {
            sdPage_ = 1;
            createSdfiles(1);
            createDisksysfiles();
            firstExec_ = true;
            writeSP();
        }
        // ƭۗp
        try {
            if (pointerEnable_ && pointerSense_ != 0 && PointingDevice.isAvailable()) {
                PointingDevice.setMode(PointingDevice.MODE_JOYSTICK);
                PointingDevice.setEnabled(true);
            }
        } catch (Exception ex) {
        }
        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
        page_ = sdNo_ / NUM_SDROM + 1;
        selectSubMenuNo_ = sdNo_ % NUM_SDROM;
        readSdromNameSP(page_);

        cheatReset();
        psgi = new PSGi();
        bootCore(core_);

        romcache = new ROMCache(this);

        width = getWidth();
        height = getHeight();

        int dispSwitch = 0;
        if (width == 480) {
            //VGAc
            dispSwitch = 1;
        } else if (height == 480) {
            //P905ip VGA(邢͂ꑊ)
            dispSwitch = 2;
        } else if (width == 240) {
            //QVGAc
            dispSwitch = 3;
        } else if (height == 240) {
            //P905ip QVGA(邢͂ꑊ)
            dispSwitch = 4;
        } else {
            dispSwitch = 0;
        }

        switch (dispSwitch) {
            case 1 :
                //VGAc - (DrawArea Zx)
                mscale = 1;
                Font.setDefaultFont(Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM));
                disp = new Disp480x640(this, core);
                if (height > 640) {
                    zoomMask_ = 2 + 4 + 8 + 16 + 32;
                } else if (height == 640) {
                    zoomMask_ = 2 + 4 + 8      + 32;
                } else if (height > 480) {
                    zoomMask_ = 2 + 4     + 16 + 32;
                } else {
                    zoomMask_ = 2 + 4          + 32;
                }
                break;
            case 2 :
                //P905ip VGA(邢͂ꑊ) - (DrawArea xZ)
                mscale = 1;
                Font.setDefaultFont(Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM));
                disp = new Disp640x480(this, core);
                if (width > 640) {
                    widedisplay_ = true;
                    zoomMask_ = 2 + 4 + 8 + 16 + 32;
                } else if (width == 640) {
                    widedisplay_ = true;
                    zoomMask_ = 2 + 4 + 8      + 32;
                } else if (width > 480) {
                    widedisplay_ = true;
                    zoomMask_ = 2 + 4 +     16 + 32;
                } else {
                    zoomMask_ = 2 + 4          + 32;
                }
                break;
            case 3 :
                //QVGAc - (DrawArea Zx)
                disp = new Disp240x320(this, core);
                if (height > 320) {
                    zoomMask_ = 2     + 8 + 16 + 32;
                } else if (height == 320) {
                    zoomMask_ = 2     + 8      + 32;
                } else if (height > 240) {
                    zoomMask_ = 2         + 16 + 32;
                } else {
                    zoomMask_ = 2              + 32;
                }
                break;
            case 4 :
                //P905ip QVGA(邢͂ꑊ) - (DrawArea xZ)
                disp = new Disp320x240(this, core);
                if (width > 426) {
                    zoomMask_ = 2     + 8 + 16 + 32;
                } else if (width > 320) {
                    widedisplay_ = true;
                    zoomMask_ = 2     + 8 + 16 + 32;
                } else if (width == 320) {
                    widedisplay_ = true;
                    zoomMask_ = 2     + 8      + 32;
                } else if (width > 240) {
                    widedisplay_ = true;
                    zoomMask_ = 2         + 16 + 32;
                } else {
                    zoomMask_ = 2              + 32;
                }
                break;
            default :
                disp = new Disp240x320(this, core);
                zoomMask_ = 2              + 32;
        }

        // ]
        allImg = Image.createImage(width, height);

        if (!widedisplay_) {
            int tmp = width;
            width = height;
            height = tmp;
        }
        disp.init();
        MENU_WIDTH = width * mscale;
        MENU_HEIGHT = height * mscale;

        DEFAULT_FONT = Font.getDefaultFont();
        MENU_DEFAULT_FONT = Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM);
        // s = tHg + ̗] + ̗]
        HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2) * scale;
        // x[X = ] + tHgAscent
        BASE_LINE = 3 * scale + MENU_DEFAULT_FONT.getAscent();

        // _CAOp s = tHg + ̗] + ̗]
        DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2*scale;
        // _CAOp x[X = ] + tHgAscent
        DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1*scale;

        // j[p
        if (!use_vgafont_ && mscale == 2) {
            MENU_WIDTH /= mscale;
            MENU_HEIGHT /= mscale;
            scale = 1;
            mscale = 1;
            menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
            msgImg = Image.createImage(MENU_WIDTH, 16);
            MENU_DEFAULT_FONT = DEFAULT_FONT;
            HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2);
            BASE_LINE = 3 + MENU_DEFAULT_FONT.getAscent();
            DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2;
            DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1;
        } else {
            try {
                menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
                msgImg = Image.createImage(MENU_WIDTH, 16 * scale);
            } catch (Exception ex) {
                // XXX Ԃ傫C[WȂ̂ŁAăgC
                MENU_WIDTH /= mscale;
                MENU_HEIGHT /= mscale;
                scale = 1;
                mscale = 1;
                menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
                msgImg = Image.createImage(MENU_WIDTH, 16);
                MENU_DEFAULT_FONT = DEFAULT_FONT;
                HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2);
                BASE_LINE = 3 + MENU_DEFAULT_FONT.getAscent();
                DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2;
                DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1;
            }
        }
        menuG = menuImg.getGraphics();
        menuG.setFont(MENU_DEFAULT_FONT);
        msgG = msgImg.getGraphics();
        msgG.setFont(MENU_DEFAULT_FONT);

        allG = allImg.getGraphics();
        allG.setFont(DEFAULT_FONT);

        if (isReverse()) {
            MY_KEY_LEFT = Display.KEY_UP;
            MY_KEY_UP = Display.KEY_RIGHT;
            MY_KEY_RIGHT = Display.KEY_DOWN;
            MY_KEY_DOWN = Display.KEY_LEFT;
        }

        setFlipModeKey();
        refreshDisplay();

        romcache.init();
        boolean svNoRomCache = noRomCache_;
        noRomCache_ = romcache.enableRomCache(!noRomCache_);
        if (noRomCache_ != svNoRomCache) {
            writeSP();
        }
        romcache.setCompressMode(compressMode_);
        romcache.disableCompress(noCompress_);
        core.set_spmode(!noRomCache_);

        // OROMǂݍ
        if (startAndLoad_) {
            boolean from_sp = true;
            if (noRomCache_) {
                from_sp = false;
            } else if (!romcache.hasRom()) {
                from_sp = false;
            }
            int c = loadRom(from_sp, 0);

            if (c == 0) {
                // OI(slot:0)w肳ꂽް(slot:>0)ǂݍ
                int slot = -1;
                if (romcache.romid(0) == sdNo_) slot = 0;
                try {
                    String savedstate = IApplication.getCurrentApp().getParameter("savedstate");
                    if (savedstate != null)
                        slot = Integer.parseInt(savedstate);
                } catch (Exception e) {}

                if (slot >= 0) {
                    while(!core.exist);
                    // XXX }bp0̒q悭Ȃ̂0.1b炢҂Ă݂
                    try {
                        Thread.sleep(100L);
                    } catch (Exception ex) {}
                    core.request(NESCore.REQUEST_LOAD, slot);
                }
            }
        }
    }

    private final void resetFrame() {
        frame_count = 0;
        last_frame = 0;
        skippedFrameCount = 0;
        lastTime_ = 0;
        startTime_ = 0;
    }

    public boolean startFrame() {
        //ɏ
        for (int i = 0; i < NUM_CHEAT; i++) {
            if (chtSwitch_[i]) {
                if (chtS_[i] == 0) {
                    for (int j = 0; j < chtK_[i]; j++) core.RAM[chtAdr_[i] + j] = chtDat_[i][j];
                }else{
                    for (int j = 0; j < chtK_[i]; j++) core.SRAM[chtAdr_[i] + j] = chtDat_[i][j];
                }
            }
        }

        frame_count++;
        if (sleep_  == 2) {
            double ftime,dtime;
            long ctime;
            if (frame_count % 61 == 0) {
                if (!fpsOff_) messageStr = (60 - skippedFrameCount) + "/60 frames.";
                skippedFrameCount = 0;
            }
            ctime = System.currentTimeMillis();
            ftime = startTime_ + 16.66666 * frame_count;
            dtime = ctime - ftime;
            if (dtime > 500 || dtime < -500) {
                startTime_ = System.currentTimeMillis();
                frame_count = 0;
                last_frame = 0;
            }
            if (ctime < ftime) {
                return true;
            } else {
                skippedFrameCount++;
                if(skippedFrameCount == 60)
                    return true;
                else
                    return false;
            }
        } else {
            return frame_count % frameSkip_ == 0;
        }
    }

    Graphics g = getGraphics();

    public void endFrame() {
        if (frame_count - last_frame >= 60) {
            long current = System.currentTimeMillis();
            fps_ = 60000 / (int) (current - lastTime_);
            last_frame += 60;
            lastTime_ = current;

            if (!fpsOff_ && sleep_ < 2) {
                messageStr = fps_ + "FPS FS=" + frameSkip_;
            }
        }

        paint(g);

        // x(60FPS)
        if (sleep_ == 1) {
            long tm = startTime_ + (long)(1667 * frameSkip_ / 100);
            do {
                startTime_ = System.currentTimeMillis();
            } while (tm > startTime_);
            long delay = (startTime_ - tm);
            if (delay > 0 && delay < 50) {
                startTime_ -= delay;
            }
        }
    }

    //readJoyPadBit() Ŏgz̐錾OoBQ[̃L[ς邩IH
    int[] keyArray = new int[8];

    public int readJoyPadBit() {
        // GAME[ĥ
        if (joypadBit == 0 && mode_ == MODE_GAME) {
            joypadBit2 = 0;
            int key = getKeypadState() & skeyMask_;
            //System.out.println("getKeypadState:" + key);
            // KeyConfigp
            //int[] keyArray = new int[8];
            for (int i = 0; i < keyArray.length; i++) {
                // Ƃ肠dœo^ł̂5܂ŁB
                int[] condition = new int[5];
                for (int j = 0; j < keyConfig_[i].length; j++) {
                    condition[j] = key >> keyConfig_[i][j];
                }
                keyArray[i] =
                    ((condition[0]
                        | condition[1]
                        | condition[2]
                        | condition[3]
                        | condition[4])
                        & 1)
                        << padTbl[rotateEnable_?flipMode_:flipModeKey_][i];
            }

            // AˁAz[h
            rcount_++;
            if (aHold_ == 1) keyArray[0] ^= 0x01;
            if (aRen_ != 0 && keyArray[0] == 0x01 && (rcount_ & (1 << (aRen_ - 1))) == 0) keyArray[0] = 0;
            if (bHold_ == 1) keyArray[1] ^= 0x02;
            if (bRen_ != 0 && keyArray[1] == 0x02 && (rcount_ & (1 << (bRen_ - 1))) == 0) keyArray[1] = 0;

            // ƭۗp
            if (pointerEnable_) {
                try {
                    if (pointerSense_ != 0 && PointingDevice.isAvailable()) {
                        int x = PointingDevice.getDirectionX();
                        int y = PointingDevice.getDirectionY();
                        byte p = pointerSense_;
                        int[] k =keyArray;
                        if (!pointerType_) {
                            switch (flipMode_) {
                                case 0 :if(Math.abs(x)>Math.abs(y)){if(x>p){k[7]=128;}if(x<(-1*p)){k[6]=64; }}
                                        else{if(y<(-1*p)){k[4]=16; }if(y>p){k[5]=32; }}break;
                                case 1 :if(Math.abs(x)>Math.abs(y)){if(x>p){k[4]=16; }if(x<(-1*p)){k[5]=32; }}
                                        else{if(y<(-1*p)){k[6]=64; }if(y>p){k[7]=128;}}break;
                                case 2 :if(Math.abs(x)>Math.abs(y)){if(x>p){k[6]=64; }if(x<(-1*p)){k[7]=128;}}
                                        else{if(y<(-1*p)){k[5]=32; }if(y>p){k[4]=16; }}break;
                                case 3 :if(Math.abs(x)>Math.abs(y)){if(x>p){k[5]=32; }if(x<(-1*p)){k[4]=16; }}
                                        else{if(y<(-1*p)){k[7]=128;}if(y>p){k[6]=64; }}break;
                            }
                        } else {
                            switch (flipMode_) {
                                case 0 :if(y<(-1*p)){k[4]=16; }if(x>p){k[7]=128;}if(y>p){k[5]=32; }if(x<(-1*p)){k[6]=64; }break;
                                case 1 :if(y<(-1*p)){k[6]=64; }if(x>p){k[4]=16; }if(y>p){k[7]=128;}if(x<(-1*p)){k[5]=32; }break;
                                case 2 :if(y<(-1*p)){k[5]=32; }if(x>p){k[6]=64; }if(y>p){k[4]=16; }if(x<(-1*p)){k[7]=128;}break;
                                case 3 :if(y<(-1*p)){k[7]=128;}if(x>p){k[5]=32; }if(y>p){k[6]=64; }if(x<(-1*p)){k[4]=16; }break;
                            }
                        }
                    }
                } catch (Exception ex) {
                }
            }

            joypad =
                keyArray[0]
                    | keyArray[1]
                    | keyArray[2]
                    | keyArray[3]
                    | keyArray[4]
                    | keyArray[5]
                    | keyArray[6]
                    | keyArray[7];
            //}CNrbg
            joypadMic = 0;
            if ((key >> mickey_ & 1) == 1) joypadMic = 4;
        }

        //int n = (joypad >> joypadBit) & 1;
        //}CNrbgt
        int n = joypadMic;
        if (con2p_ != 2) n = (joypad >> joypadBit) & 1 | joypadMic;
        joypadBit = (joypadBit + 1) & 7;
        return n;
    }

    public int readJoyPadBit2() {
        // 2Player
        int n = 0;
        if (con2p_ != 0) n = (joypad >> joypadBit2) & 1;
        joypadBit2 = (joypadBit2 + 1) & 7;
        return n;
    }

    public void resetJoyPad() {
        joypadBit = 0;
    }

    public void resetJoyPad2() {
        joypadBit2 = 0;
    }

    public String getSaveFile(final int slot) {
        return "NO" + formatNumber(slot, 2) + ".SAV";
    }

    public String getSramSaveFile() {
        return saveFile_;
    }

    public void setMessage(final String s) {
        /*
         * XXX
         *  񗓂ɃbZ[W\郁\bh肷łB
         *  1.j[\
         *   (1)MenuImgdrawString()  paintMenuImage() (messageStrgp)
         *   (2)msgImgdrawString()  paintMenuImage() ({\bh)
         *   (3)msgImgdrawString()  paintMenuImage() (oi[\cbannerStrgp)
         *  2.Q[ʕ\
         *   (1)g܂allGɒ drawString() (`ݒFʏ탂[hcmessageStrgp)
         *   (2)edispNX fps \ƂĎ
         *   (3)edispNX drawString() pĂB(񗓂ɂ͎gĂȂ)
         */
        messageStr = s;
        msgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
        msgG.fillRect(0, 0, MENU_WIDTH, 16 * scale);
        msgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
        msgG.drawString(s, 4 * scale, BASE_LINE);
        paintMenuImage(msgImg, mscale, 0, 224 * scale/mscale, MENU_WIDTH, 16 * scale);
    }

    public void processEvent(final int type, final int param) {
        long wt = (long)wt_on_game_;
        long ct = 0;
        if (type == Display.KEY_PRESSED_EVENT) {
            switch (mode_) {
                case MODE_GAME :
                    if (param == MY_KEY_SOFT1) {
                        while (getKeypadState() != 0){
                            ct = System.currentTimeMillis();
                            if (wt < 200) {
                                soft1Pressed = true;
                            }
                            while (System.currentTimeMillis() - ct < wt) {
                                if (getKeypadState() == 0) break;
                                try {
                                    Thread.sleep(10L);
                                } catch (Exception ex) {}
                            }
                            wt = 180;
                        }
                    } else if (param == MY_KEY_SOFT2) {
                        while (getKeypadState() != 0){
                            ct = System.currentTimeMillis();
                            if (wt < 200) {
                                soft2Pressed = true;
                            }
                            while (System.currentTimeMillis() - ct < wt) {
                                if (getKeypadState() == 0) break;
                                try {
                                    Thread.sleep(10L);
                                } catch (Exception ex) {}
                            }
                            wt = 180;
                        }
                    } else {  /* if (param == ...) */
                            boolean done = false;
                            for (int i = 8; i < keyConfig_.length; i++) {
                                for (int j = 0; j < keyConfig_[i].length; j++) {
                                    if (param == keyConfig_[i][j]) {
                                        done = true;
                                        keycon1 = i;
                                    }
                                }
                            }
                            if (keycon2_set && !done) {
                                soft2Pressed = true;
                                wt = 700;
                                while (getKeypadState() != 0){
                                    ct = System.currentTimeMillis();
                                    if (wt < 200) {
                                        soft2Pressed = false;
                                    }
                                    while (System.currentTimeMillis() - ct < wt) {
                                        if (getKeypadState() == 0) break;
                                        try {
                                            Thread.sleep(10L);
                                        } catch (Exception ex) {}
                                    }
                                    wt = 180;
                                }
                            }
                    } /* if (param == ...) */
                    break;

                case MODE_MENU_KEYCON_SET :
                case MODE_MENU_KEYCON2_SET :
                case MODE_MENU_MICKEY_SET :
                    break;

                case MODE_DIALOG :
                    switch (param) {
                        case Display.KEY_SELECT :
                            dialogPressed = true;
                            repaint();
                            break;
                        case Display.KEY_UP :
                        case Display.KEY_DOWN :
                        case Display.KEY_RIGHT :
                        case Display.KEY_LEFT :
                            dialogYes = !dialogYes;
                            repaint();
                            break;
                    }
                    break;

                default :
                    svParam = param;
                    keyPressMenu(param);
                    break;
            }

        } else if (type == Display.KEY_RELEASED_EVENT) {
            switch (mode_) {
                case MODE_GAME :
                    if (soft1Pressed && param == MY_KEY_SOFT1) {
                        soft1Pressed = false;
                        core.request(NESCore.REQUEST_SLEEP, 0);
                        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
                        messageStr = "";
                        mode_ = MODE_MENU_ROOT;
                        refreshDisplay();
                        repaint();
                    } else if (soft2Pressed) {
                        soft2Pressed = false;
                        if ((param == MY_KEY_SOFT2 && rSoftkey_ == 0) || param == keycon2_[3]) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            padDisp_ = true;
                            setSoftLabel(Frame.SOFT_KEY_1, null);
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
                            selectSubMenuNo_ = svSubMenuPadNo;
                            mode_ = MODE_MENU_BUTTON_SET;
                            messageStr = "";
                            refreshDisplay();
                            repaint();
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 1) || param == keycon2_[4]) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            padDisp_ = true;
                            setSoftLabel(Frame.SOFT_KEY_1, null);
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
                            selectSubMenuNo_ = svSubMenuCheatNo;
                            mode_ = MODE_MENU_CHEAT_SET;
                            messageStr = "";
                            refreshDisplay();
                            repaint();
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 2) || param == keycon2_[5]) {
                            boolean rYes = true;
                            if ((confirmMsg_ & 4) != 0) {
                                core.request(NESCore.REQUEST_SLEEP, 0);
                                rYes = confirm("Zbg܂H");
                            }
                            if (rYes) {
                                core.request(NESCore.REQUEST_RESET, 0);
                            } else {
                                core.request(NESCore.REQUEST_START, 0);
                            }
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 3) || param == keycon2_[6]) {
                            soundEnable = (soundEnable + 1) & 1;
                            setRightSoftkeyLabel();
                            writeSP();
                            core.setApuVolume(soundEnable, soundVolume);
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 5) || param == keycon2_[7]) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            padDisp_ = true;
                            setSoftLabel(Frame.SOFT_KEY_1, null);
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
                            byte current_disk = core.get_disk_side();
                            selectSubMenuNo_ = (current_disk > 0 && current_disk <= 4) ? (current_disk - 1) : (0);
                            mode_ = MODE_MENU_DISKSIDE;
                            messageStr = "";
                            refreshDisplay();
                            repaint();
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 6) || param == keycon2_[8]) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            padDisp_ = true;
                            setSoftLabel(Frame.SOFT_KEY_1, null);
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
                            selectSubMenuNo_ = svSubMenuRomsetNo;
                            mode_ = MODE_MENU_ROMSET;
                            messageStr = "";
                            refreshDisplay();
                            repaint();
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 7) || param == keycon2_[9]) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            padDisp_ = true;
                            setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_RET_STR);
                            setSoftLabel(Frame.SOFT_KEY_2, ZOOM_STR[(flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_]);
                            zoomSizeMode_ = true;
                            mode_ = MODE_ZOOM_SET;
                            if ((!isReverse() && flipMode_ == 2) || (isReverse() && flipMode_ == 1)) {
                                //cʁA180
                                //Po[X@E90@flipModeKey_ = 2@flipMode_ = 1
                                //FE|180@flipModeKey_3.flipMode_2@flipModeKey_1.flipMode_2
                                MY_KEY_LEFT = Display.KEY_RIGHT;
                                MY_KEY_UP = Display.KEY_DOWN;
                                MY_KEY_RIGHT = Display.KEY_LEFT;
                                MY_KEY_DOWN = Display.KEY_UP;
                            } else if (flipMode_ == 3 && !isReverse() || (isReverse() && flipMode_ == 2)) {
                                //cʁA90
                                //FE|@90@flipModeKey_0.flipMode_3@flipModeKey_2.flipMode_3
                                //Po[X@180@flipModeKey_ = 3@flipMode_ = 2
                                MY_KEY_LEFT = Display.KEY_DOWN;
                                MY_KEY_UP = Display.KEY_LEFT;
                                MY_KEY_RIGHT = Display.KEY_UP;
                                MY_KEY_DOWN = Display.KEY_RIGHT;
                            } else if (flipMode_ == 1 || (isReverse() && flipMode_ != 3)) {
                                //cʁAE90
                                //FE|@E90@flipModeKey_2.flipMode_1@flipModeKey_0.flipMode_1
                                //Po[X]
                                MY_KEY_LEFT = Display.KEY_UP;
                                MY_KEY_UP = Display.KEY_RIGHT;
                                MY_KEY_RIGHT = Display.KEY_DOWN;
                                MY_KEY_DOWN = Display.KEY_LEFT;
                            } else {
                                //cʁA]
                                //FE]Ȃ
                                //Po[X@90@flipModeKey_ = 0@flipMode_ = 3
                                MY_KEY_LEFT = Display.KEY_LEFT;
                                MY_KEY_UP = Display.KEY_UP;
                                MY_KEY_RIGHT = Display.KEY_RIGHT;
                                MY_KEY_DOWN = Display.KEY_DOWN;
                            }
                            repaint();
                        } else if ((param == MY_KEY_SOFT2 && rSoftkey_ == 8)) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            sdRomadj_[sdNo_] = (sdRomadj_[sdNo_] < 5)?(sdRomadj_[sdNo_] + 1):(-5);
                            adjust_cycle = (float)sdRomadj_[sdNo_] / 2;
                            adjust_dozencycle = sdRomadj_[sdNo_] * 6;
                            setRightSoftkeyLabel();
                            writeSPadjusts();
                            core.request(NESCore.REQUEST_RESET, 0);
                        } else if (param == keycon2_[6]) {
                            soundEnable = (soundEnable + 1) & 1;
                            setRightSoftkeyLabel();
                            writeSP();
                            core.setApuVolume(soundEnable, soundVolume);
                        } else if (param == keycon2_[10]) {
                            romcache.onSaving = true;
                            core.request(NESCore.REQUEST_SAVE, 0);
                            while(romcache.onSaving);
                        }

                    } else if (param == keycon2_[5]) {
                        boolean rYes = true;
                        if ((confirmMsg_ & 4) != 0) {
                            core.request(NESCore.REQUEST_SLEEP, 0);
                            rYes = confirm("ċN܂H");
                        }
                        if (rYes) {
                            if (!noRomCache_ && core.exist) {
                                romcache.onSaving = true;
                                core.request(NESCore.REQUEST_SAVE, 0);
                                while (romcache.onSaving);
                            }
                            reboot();
                        } else {
                            core.request(NESCore.REQUEST_START, 0);
                        }

                    } else if (keycon1 > 0) {
                        switch (keycon1) {
                            case 8 :
                                selectSubMenuNo_ = svSubMenuLoadNo;
                                core.request(NESCore.REQUEST_SLEEP, 0);
                                mode_ = MODE_MENU_LOAD;
                                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
                                repaint();
                                break;
                            case 9 :
                                selectSubMenuNo_ = svSubMenuSaveNo;
                                core.request(NESCore.REQUEST_SLEEP, 0);
                                mode_ = MODE_MENU_SAVE;
                                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SAVE_STR);
                                repaint();
                                break;
                            case 10 :
                                if (frameSkip_ < 30) {
                                    frameSkip_++;
                                }
                                break;
                            case 11 :
                                if (frameSkip_ > 1) {
                                    frameSkip_--;
                                }
                                break;
                            default :
                                break;
                        }
                        keycon1 = 0;

                    } /* if (param == ...) */
                    break;

                case MODE_MENU_KEYCON_SET :
                    keyConfigSet(param);
                    break;

                case MODE_MENU_KEYCON2_SET :
                    keyConfigSet2(param);
                    break;

                case MODE_MENU_MICKEY_SET :
                    if (param != Display.KEY_SOFT1) {
                        mickey_ = param;
                        writeSP();
                    }
                    //mode_ = MODE_MENU_SETTING;
                    mode_ = MODE_MENU_KEYCON2;
                    repaint();
                    break;

                case MODE_DIALOG :
                    if (param == Display.KEY_SELECT) {
                        dialogPressed = false;
                        dialogReleased = true;
                        dialogMessage = "";
                        mode_ = svMode;
                        repaint();
                        if (dialogMode == Dialog.DIALOG_YESNO) {
                            keyPressMenu(svParam);
                            keyReleaseMenu(svParam);
                        } else {
                            dialogReleased = false;
                            dialogShowed = false;
                            messageStr = "";
                            refreshDisplay();
                            repaint();
                        }
                    }
                    break;

                default :
                    keyReleaseMenu(param);
                    break;
            }

        } else if (type == Display2.DISPLAY_STYLE_CHANGED_EVENT ||
                   type == Display.RESUME_VM_EVENT) {
            //ȓd͐ݒ(ƂTXyh)ĂƁAĊJςĂ
            //DISPLAY_STYLE_CHANGED_EVENT΂Ȃ̂ŁARESUME_VM_EVENTE
            setFlipModeKey();
            refreshDisplay();
            repaint();
        }

    }


    /*
     * {Iɂ͒ɕKvȏ keyPressMenu() 
     *  - ɌJԂ     keyPressMenu()Ń[v
     *  - _@ɂP񂾂 keyPressMenu()ŃtO𗧂ĂāAkeyRelaseMenu()ŏ
     */
    private void keyPressMenu(final int param) {
        long wt = 700;
        long ct = 0;
        if (param == MY_KEY_SOFT2) {
            if (padDisp_ && mode_== MODE_ZOOM_SET) {
                while (getKeypadState() != 0){
                    ct = System.currentTimeMillis();
                    if (wt < 200) {
                        pos_reset = true;
                    }
                    while (System.currentTimeMillis() - ct < wt) {
                        if (getKeypadState() == 0) break;
                        try {
                            Thread.sleep(10L);
                        } catch (Exception ex) {}
                    }
                    wt = 180;
                }
            }

        } else if (param == Display.KEY_SELECT) {
            while (getKeypadState() != 0){
                ct = System.currentTimeMillis();
                if (wt < 200) {
                    keyLongPressed = true;
                }
                while (System.currentTimeMillis() - ct < wt) {
                    if (getKeypadState() == 0) break;
                    try {
                        Thread.sleep(10L);
                    } catch (Exception ex) {}
                }
                wt = 180;
            }

        } else if (param == MY_KEY_UP) {
            while (getKeypadState() != 0){
                ct = System.currentTimeMillis();
                if (mode_ == MODE_MENU_ROOT) {
                    selectMenuNo_ =
                        incNo(selectMenuNo_, -1, MENU_ROOT.length);
                } else if (mode_ == MODE_ZOOM_SET) {
                    int zoomA = (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4 && zoomSizeMode_) ? 0 : 1;
                    int sc = (2 / (scale / mscale));
                    if (wt < 200) pos_y[zoomA] -= 32 / sc;
                    else pos_y[zoomA] -= 8 / sc;
                    if (pos_y[zoomA] < 0) pos_y[zoomA] = 0;
                    writeSP();
                    refreshDisplay();
                } else {
                    selectSubMenuNo_ =
                        incNo(
                            selectSubMenuNo_,
                            -1,
                            subMenu_.length);
                }
                repaint();
                while (System.currentTimeMillis() - ct < wt) {
                    if (getKeypadState() == 0) break;
                    try {
                        Thread.sleep(10L);
                    } catch (Exception ex) {}
                }
                wt = 180;
            }

        } else if (param == MY_KEY_DOWN) {
            while (getKeypadState() != 0){
                ct = System.currentTimeMillis();
                if (mode_ == MODE_MENU_ROOT) {
                    selectMenuNo_ =
                        incNo(selectMenuNo_, +1, MENU_ROOT.length);
                } else if (mode_ == MODE_ZOOM_SET) {
                    int zoomA = (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4 && zoomSizeMode_) ? 0 : 1;
                    int sc = (2 / (scale / mscale));
                    if (wt < 200) pos_y[zoomA] += 32 / sc;
                    else pos_y[zoomA] += 8 / sc;
                    switch (zoomA) {
                        case 0 :
                            if ((pos_y[0] + pos_y[1]) > height) pos_y[0] = ((height - pos_y[1]) > 0) ? (height - pos_y[1]) : 0;
                            break;
                        case 1 :
                            if ((pos_y[1] + pos_y[0]) > height) pos_y[1] = ((height - pos_y[0]) > 0) ? (height - pos_y[0]) : 0;
                            break;
                    }
                    writeSP();
                    refreshDisplay();
                } else {
                    selectSubMenuNo_ =
                        incNo(
                            selectSubMenuNo_,
                            +1,
                            subMenu_.length);
                }
                repaint();
                while (System.currentTimeMillis() - ct < wt) {
                    if (getKeypadState() == 0) break;
                    try {
                        Thread.sleep(10L);
                    } catch (Exception ex) {}
                }
                wt = 180;
            }

        } else if (param == MY_KEY_RIGHT) {
            while (getKeypadState() != 0){
                ct = System.currentTimeMillis();
                switch (mode_) {
                    case MODE_MENU_ROM:
                        if (page_ < sdPage_ ){
                            page_++;
                        } else {
                            page_ = 1;
                        }
                        readSdromNameSP(page_);
                        break;
                    case MODE_MENU_SETTING:
                        selectMenuSetting(RIGHT);
                        break;
                    case MODE_MENU_BUTTON_SET :
                        selectMenuButtonSetting(RIGHT);
                        break;
                    case MODE_MENU_AUDIO1_SET:
                    	selectAudioSetting1(RIGHT);
                        if (selectSubMenuNo_ > 2 && selectSubMenuNo_ < 7){
                            if (wt < 200)
                                instNum_[selectSubMenuNo_ - 3] = (instNum_[selectSubMenuNo_ - 3] + 10) / 10 * 10;
                            else
                                instNum_[selectSubMenuNo_ - 3]++;
                            if (instNum_[selectSubMenuNo_ - 3] > 128) instNum_[selectSubMenuNo_ - 3] = 1;
                        }
                        break;
                    case MODE_MENU_AUDIO2_SET:
                    	selectAudioSetting2(RIGHT);
                        if (selectSubMenuNo_ == 3){
                            if (wt < 200)
                                soundBufCount += 10;
                            else
                                soundBufCount++;
                            if (soundBufCount > 60) soundBufCount = 15; 
                        }
                        break;
                    case MODE_MENU_AUDIO3_SET:
                    	selectAudioSetting3(RIGHT);
                        // j[̕тς̂ 1`5ł͂ȂA2`6B
                        // {[AUDIO1܂AUDIO2̃j[Őݒ肷ׂB
                        if (selectSubMenuNo_ > 1 && selectSubMenuNo_ < 7){
                            if (wt < 200)
                                np2_instNum_[selectSubMenuNo_ - 2] = (np2_instNum_[selectSubMenuNo_ - 2] + 10) / 10 * 10;
                            else
                                np2_instNum_[selectSubMenuNo_ - 2]++;
                            if (np2_instNum_[selectSubMenuNo_ - 2] > 128) np2_instNum_[selectSubMenuNo_ - 2] = 1;
                        }
                        break;
                    case MODE_MENU_ROMFILE :
                        selectMenuRomFile(RIGHT);
                        break;
                    case MODE_MENU_CONFIRM :
                        selectMenuConfirm(RIGHT);
                        break;
                    case MODE_ZOOM_SET :
                        int zoomA = (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4 && zoomSizeMode_) ? 0 : 1;
                        int sc = (2 / (scale / mscale));
                        if (wt < 200) pos_x[zoomA] += 32 / sc;
                        else pos_x[zoomA] += 8 / sc;
                        switch (zoomA) {
                            case 0 :
                                if ((pos_x[0] + pos_x[1]) > width) pos_x[0] = ((width - pos_x[1]) > 0) ? (width - pos_x[1]) : 0;
                                break;
                            case 1 :
                                if ((pos_x[1] + pos_x[0]) > width) pos_x[1] = ((width - pos_x[0]) > 0) ? (width - pos_x[0]) : 0;
                                break;
                        }
                        writeSP();
                        refreshDisplay();
                        break;
                    case MODE_MENU_KEYCON :
                        selectSubMenuNo_ = (selectSubMenuNo_ >= MENU_KEYCON2.length) ? MENU_KEYCON2.length - 1 : selectSubMenuNo_;
                        mode_ = MODE_MENU_KEYCON2;
                        break;
                    case MODE_MENU_KEYCON2 :
                        mode_ = MODE_MENU_KEYCON;
                        break;
                    case MODE_MENU_OTHER_SET :
                        selectMenuOtherSetting(RIGHT);
                        if (selectSubMenuNo_ == 1) {
                            if (wt < 200) wt_on_game_ += 1000;
                            else wt_on_game_ += 100;
                            if (wt_on_game_ > 10000) wt_on_game_ = 10000;
                        } else if (selectSubMenuNo_ == 2) {
                            if (wt < 200) wt_on_refresh_ += 1000;
                            else wt_on_refresh_ += 100;
                            if (wt_on_refresh_ > 10000) wt_on_refresh_ = 10000;
                        }
                        break;
                }
                repaint();
                while (System.currentTimeMillis() - ct < wt) {
                    if (getKeypadState() == 0) break;
                    try {
                        Thread.sleep(10L);
                    } catch (Exception ex) {}
                }
                wt = 180;
            }

        } else if (param == MY_KEY_LEFT) {
            while (getKeypadState() != 0){
                ct = System.currentTimeMillis();
                switch(mode_) {
                    case MODE_MENU_ROM:
                        if (page_ > 1 ){
                            page_--;
                        } else {
                            page_ = sdPage_;
                        }
                        readSdromNameSP(page_);
                    case MODE_MENU_SETTING :
                        selectMenuSetting(LEFT);
                        break;
                    case MODE_MENU_BUTTON_SET :
                        selectMenuButtonSetting(LEFT);
                        break;
                    case MODE_MENU_AUDIO1_SET:
                    	selectAudioSetting1(LEFT);
                        if (selectSubMenuNo_ > 2 && selectSubMenuNo_ < 7){
                            if (wt < 200)
                                instNum_[selectSubMenuNo_ - 3] = (instNum_[selectSubMenuNo_ - 3] - 1) / 10 * 10;
                            else
                                instNum_[selectSubMenuNo_ - 3]--;
                            if (instNum_[selectSubMenuNo_ - 3] < 1) instNum_[selectSubMenuNo_ - 3] = 128;
                        }
                        break;
                    case MODE_MENU_AUDIO2_SET:
                    	selectAudioSetting2(LEFT);
                        if (selectSubMenuNo_ == 3){
                            if (wt < 200)
                                soundBufCount -= 10;
                            else
                                soundBufCount--;
                            if (soundBufCount < 15) soundBufCount = 60;
                        }
                        break;
                    case MODE_MENU_AUDIO3_SET:
                    	selectAudioSetting3(LEFT);
                        // j[̕тς̂ 1`5ł͂ȂA2`6B
                        // {[AUDIO1܂AUDIO2̃j[Őݒ肷ׂB
                        if (selectSubMenuNo_ > 1 && selectSubMenuNo_ < 7){
                            if (wt < 200)
                                np2_instNum_[selectSubMenuNo_ - 2] = (np2_instNum_[selectSubMenuNo_ - 2] - 2) / 10 * 10;
                            else
                                np2_instNum_[selectSubMenuNo_ - 2]--;
                            if (np2_instNum_[selectSubMenuNo_ - 2] < 1) np2_instNum_[selectSubMenuNo_ - 2] = 128;
                        }
                        break;
                    case MODE_MENU_ROMFILE :
                        selectMenuRomFile(LEFT);
                        break;
                    case MODE_MENU_CONFIRM :
                        selectMenuConfirm(LEFT);
                        break;
                    case MODE_ZOOM_SET :
                        int zoomA = (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4 && zoomSizeMode_) ? 0 : 1;
                        int sc = (2 / (scale / mscale));
                        if (wt < 200) pos_x[zoomA] -= 32 / sc;
                        else pos_x[zoomA] -= 8 / sc;
                        if (pos_x[zoomA] < 0) pos_x[zoomA] = 0;
                        writeSP();
                        refreshDisplay();
                        break;
                    case MODE_MENU_KEYCON :
                        selectSubMenuNo_ = (selectSubMenuNo_ >= MENU_KEYCON2.length) ? MENU_KEYCON2.length - 1 : selectSubMenuNo_;
                        mode_ = MODE_MENU_KEYCON2;
                        break;
                    case MODE_MENU_KEYCON2 :
                        mode_ = MODE_MENU_KEYCON;
                        break;
                    case MODE_MENU_OTHER_SET :
                        selectMenuOtherSetting(LEFT);
                        if (selectSubMenuNo_ == 1) {
                            if (wt < 200) wt_on_game_ -= 1000;
                            else wt_on_game_ -= 100;
                            if (wt_on_game_ < 0) wt_on_game_ = 0;
                        } else if (selectSubMenuNo_ == 2) {
                            if (wt < 200) wt_on_refresh_ -= 1000;
                            else wt_on_refresh_ -= 100;
                            if (wt_on_refresh_ < 0) wt_on_refresh_ = 0;
                        }
                        break;
                }
                repaint();
                while (System.currentTimeMillis() - ct < wt) {
                    if (getKeypadState() == 0) break;
                    try {
                        Thread.sleep(10L);
                    } catch (Exception ex) {}
                }
                wt = 180;
            }
        }
    }

    /*
     * {Iɂ͍ĕ`(repaint) keyReleaseMenu() 
     */
    private void keyReleaseMenu(final int param) {
        String tmp;
        boolean done = false;
        if (padDisp_) { //Q[̌ďo@\(AőSł͂Ȃ)
            // Q[̌Ăяo@\ݒ肵\tgL[łL
            if (param == MY_KEY_SOFT1) {
                switch (mode_) {
                    case MODE_ZOOM_SET :
                        mode_ = MODE_GAME;
                        setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                        setRightSoftkeyLabel();
                        padDisp_ = false;
                        core.request(NESCore.REQUEST_START, 0);
                        writeSP();
                        done = true;
                        break;
                }
            } else if (param == MY_KEY_SOFT2) {
                switch (mode_) {
                    case MODE_MENU_BUTTON_SET:
                    case MODE_MENU_CHEAT_SET:
                    case MODE_MENU_DISKSIDE:
                        if (rSoftkey_ == 0) {
                            svSubMenuPadNo = selectSubMenuNo_;
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
                        } else if(rSoftkey_ == 1){
                            svSubMenuCheatNo = selectSubMenuNo_;
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_CHEAT_STR);
                        } else if(rSoftkey_ == 5){
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_DISK_STR);
                        }
                        padDisp_ = false;
                        core.request(NESCore.REQUEST_START, 0);
                        mode_ = MODE_GAME;
                        setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                        setRightSoftkeyLabel();
                        done = true;
                        break;
                    case MODE_MENU_ROMSET:
                        svSubMenuRomsetNo = selectSubMenuNo_;
                        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROMSET_STR);
                        boolean rYes = true;
                        dialogNotReady = true;
                        rYes = confirm("Zbg܂H");
                        if (rYes) {
                            core.request(NESCore.REQUEST_RESET, 0);
                        } else {
                            core.request(NESCore.REQUEST_START, 0);
                        }
                        padDisp_ = false;
                        mode_ = MODE_GAME;
                        setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                        setRightSoftkeyLabel();
                        done = true;
                        break;
                    case MODE_ZOOM_SET :
                        if (pos_reset) {
                            pos_reset = false;
                            if (confirm("ʒuZbg܂H")) {
                                if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
                                    pos_x[0] = 100;
                                    pos_y[0] = 100;
                                    pos_x[1] = 0;
                                    pos_y[1] = 0;
                                    svPos_x4 = 0;
                                    svPos_y4 = 0;
                                }
                                writeSP();
                            }
                        } else {
                            switch (flipModeKey_) {
                                case 1 :
                                case 3 :
                                    if (++svZoom_ > 4) svZoom_ = 0;
                                    if (((2 << svZoom_) & zoomMask_) == 0) {
                                        if (++svZoom_ > 4) svZoom_ = 0;
                                        if (((2 << svZoom_) & zoomMask_) == 0) {
                                            if (++svZoom_ > 4) svZoom_ = 0;
                                            if (((2 << svZoom_) & zoomMask_) == 0) {
                                                if (++svZoom_ > 4) svZoom_ = 0;
                                                if (((2 << svZoom_) & zoomMask_) == 0) {
                                                    if (++svZoom_ > 4) svZoom_ = 0;
                                                }
                                            }
                                        }
                                    }
                                    break;
                                case 0 :
                                case 2 :
                                    if (++zoom_ > 4) zoom_ = 0;
                                    if (((2 << zoom_) & zoomMask_) == 0) {
                                        if (++zoom_ > 4) zoom_ = 0;
                                        if (((2 << zoom_) & zoomMask_) == 0) {
                                            if (++zoom_ > 4) zoom_ = 0;
                                            if (((2 << zoom_) & zoomMask_) == 0) {
                                                if (++zoom_ > 4) zoom_ = 0;
                                                if (((2 << zoom_) & zoomMask_) == 0) {
                                                    if (++zoom_ > 4) zoom_ = 0;
                                                }
                                            }
                                        }
                                    }
                                    break;
                            }
                            int sc = (2 / (scale / mscale));
                            switch ((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) {
                                case 4 :
                                    if (pos_x[0] + pos_x[1] > width) {
                                        pos_x[1] = 0;
                                        if (pos_x[0] > width) pos_x[0] = width;
                                    }
                                    if (pos_y[0] + pos_y[1] > height) {
                                        pos_y[1] = 0;
                                        if (pos_y[0] > height) pos_y[0] = height;
                                    }
                                    break;
                            }
                            setSoftLabel(Frame.SOFT_KEY_2, ZOOM_STR[(flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_]);
                            writeSP();
                        }
                        done = true;
                        break;
                } /* switch (mode_) */
            } /* if (param == ... */
        } /* if (padDisp_) */
        if (done) {
            refreshDisplay();
            repaint();
            return;
        }

        switch (param) {
            case Display.KEY_SOFT1 :
                if(!padDisp_) {
                    if (mode_ != MODE_MENU_ROOT) {
                        switch (mode_) {
                            case MODE_MENU_SOFTKEY :
                                selectSubMenuNo_ = 6;
                                mode_ = MODE_MENU_SETTING;
                                break;
                            case MODE_MENU_AUDIO1_SET :
                            case MODE_MENU_AUDIO2_SET :
                                svSubMenuAudioSetting1No = selectSubMenuNo_;
                                svSubMenuAudioSetting2No = selectSubMenuNo_;
                                selectSubMenuNo_ = 8;
                                mode_ = MODE_MENU_SETTING;
                                core.setApuUserSetting();
                                writeSP();
                                break;
                            case MODE_MENU_AUDIO3_SET : // XXX - 1,2ƓAsetApuUserSetting()ŌĂԂ悤ɂ邩ǂ
                                svSubMenuAudioSetting3No = selectSubMenuNo_;
                                selectSubMenuNo_ = 8;
                                mode_ = MODE_MENU_SETTING;
                                setSoundParms();
                                writeSP();
                                break;
                            case MODE_MENU_ROMFILE :
                                svSubMenuRomFileNo = selectSubMenuNo_;
                                selectSubMenuNo_ = 9;
                                mode_ = MODE_MENU_SETTING;
                                break;
                            case MODE_MENU_CONFIRM :
                                svSubMenuConfirmNo = selectSubMenuNo_;
                                selectSubMenuNo_ = 10;
                                mode_ = MODE_MENU_SETTING;
                                break;
                            case MODE_MENU_OTHER_SET :
                                svSubMenuOtherNo = selectSubMenuNo_;
                                selectSubMenuNo_ = 11;
                                mode_ = MODE_MENU_SETTING;
                                break;
                            case MODE_MENU_LOAD :
                                svSubMenuLoadNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                messageStr = "";
                                break;
                            case MODE_MENU_SAVE :
                                svSubMenuSaveNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                messageStr = "";
                                break;
                            case MODE_MENU_SETTING :
                                svSubMenuSettingNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                break;
                            case MODE_MENU_KEYCON :
                                svSubMenuKeyConfNo = selectSubMenuNo_;
                                svSubMenuKeyConfPage = 1;
                                mode_ = MODE_MENU_ROOT;
                                messageStr = "";
                                break;
                            case MODE_MENU_KEYCON2 :
                                svSubMenuKeyConfNo = selectSubMenuNo_;
                                svSubMenuKeyConfPage = 2;
                                mode_ = MODE_MENU_ROOT;
                                messageStr = "";
                                break;
                            case MODE_MENU_BUTTON_SET:
                                svSubMenuPadNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                break;
                            case MODE_MENU_DISKSIDE:
                                mode_ = MODE_MENU_ROOT;
                                break;
                            case MODE_MENU_CHEAT_SET:
                                svSubMenuCheatNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                break;
                            case MODE_MENU_TOOLS:
                                svSubMenuToolNo = selectSubMenuNo_;
                                mode_ = MODE_MENU_ROOT;
                                break;
                            case MODE_MENU_EXPORT :
                                svSubMenuExportNo = selectSubMenuNo_;
                                selectSubMenuNo_ = 0;
                                mode_ = MODE_MENU_TOOLS;
                                messageStr = "";
                                break;
                            case MODE_MENU_IMPORT :
                                svSubMenuImportNo = selectSubMenuNo_;
                                selectSubMenuNo_ = 1;
                                mode_ = MODE_MENU_TOOLS;
                                messageStr = "";
                                break;
                            case MODE_MENU_ROMSET:
                                repaint();
                                break;
                            case MODE_MENU_SELECT_CORE :
                                mode_ = MODE_MENU_ROOT;
                                break;
                            default :
                                messageStr = "";
                                mode_ = MODE_MENU_ROOT;
                        }
                        if (mode_ == MODE_MENU_ROOT) {
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
                        } else if (mode_ == MODE_MENU_SETTING) {
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
                        } else {
                            setSoftLabel(Frame.SOFT_KEY_2, null);
                        }
                    } else {
                        messageStr = "";
                        core.request(NESCore.REQUEST_START, 0);
                        setRightSoftkeyLabel();
                        mode_ = MODE_GAME;
                        refreshDisplay();
                    } /* (mode_ != MODE_MENU_ROOT) */
                    padDisp_ = false;
                } else {
                    switch (mode_) {
                        case MODE_ZOOM_SET :
                            if (padDisp_) {
                                mode_ = MODE_GAME;
                                setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                                setRightSoftkeyLabel();
                                padDisp_ = false;
                                core.request(NESCore.REQUEST_START, 0);
                                writeSP();
                                refreshDisplay();
                            }
                            break;
                    }
                } /* (!padDisp_) */
                repaint();
                break;

            case Display.KEY_SOFT2 :
                switch (mode_) {
                    case MODE_MENU_ROOT :
                        boolean rYes = true;
                        if ((confirmMsg_ & 8) != 0) rYes = confirm("I܂H");
                        if (rYes){
                            if (!noRomCache_ && core.exist) {
                                romcache.onSaving = true;
                                core.request(NESCore.REQUEST_SAVE, 0);
                                while (romcache.onSaving);
                            }
                            core.request(NESCore.REQUEST_STOP, 0);
                            while(core.exist) ;
                            IApplication.getCurrentApp().terminate();
                        }
                        break;
                    case MODE_MENU_ROM :
                        imeOn(sdRomnm_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
                        break;
                    case MODE_MENU_LOAD :
                        tmp = saveStr_[selectSubMenuNo_].trim();
                        if (!tmp.equals("")) imeOn(saveStr_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
                        break;
                    case MODE_MENU_SAVE :
                        tmp = saveStr_[selectSubMenuNo_].trim();
                        if (!tmp.equals("")){
                            if (confirm("No." + (selectSubMenuNo_ + 1)
                                + "\n"
                                + saveStr_[selectSubMenuNo_]
                                + "\n폜܂H")) {
                                messageStr = "f[^폜";
                                setMessage(messageStr);
                                if (noRomCache_) {
                                    SDbinding sd = new SDbinding();
                                    sd.deleteFile(getSaveFile(selectSubMenuNo_ + 1));
                                } else {
                                    romcache.deleteSaveData(selectSubMenuNo_ + 1);
                                }
                                saveStr_[selectSubMenuNo_] = "";
                                writeSPsaves(selectSubMenuNo_);
                                messageStr = "";
                                repaint();
                            }
                        }
                        break;
                    case MODE_MENU_SETTING :
                        if (++menuBGcolor_ > 5) menuBGcolor_ = 0;
                        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
                        writeSP();
                        repaint();
                        break;
                    case MODE_MENU_KEYCON :
                         if (confirm("L[ݒNA܂H")) {
                             for (int i = 0; i < keyConfig_.length; i++) {
                                 keyconStr_[i] = "";
                                 keyStr2Vector(i);
                             }
                             writeSPkeys();
                         }
                         break;
                    case MODE_MENU_KEYCON2 :
                         if (confirm("}CNȊÕL[ݒNA܂H")) {
                             for (int i = 0; i < keycon2_.length; i++) {
                                 keycon2_[i] = 0xFF - 0x100;
                             }
                             keycon2_[1] = (byte)Display.KEY_SOFT1;
                             keycon2_[2] = (byte)Display.KEY_SOFT2;
                             MY_KEY_SOFT1 = Display.KEY_SOFT1;
                             MY_KEY_SOFT2 = Display.KEY_SOFT2;
                             keycon2_set = false;
                             writeSP();
                         }
                         break;
                    case MODE_MENU_BUTTON_SET:
                    case MODE_MENU_CHEAT_SET:
                    case MODE_MENU_DISKSIDE:
                        if (padDisp_){
                            if (rSoftkey_ == 0) {
                                svSubMenuPadNo = selectSubMenuNo_;
                                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
                            } else if(rSoftkey_ == 1){
                                svSubMenuCheatNo = selectSubMenuNo_;
                                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_CHEAT_STR);
                            } else if(rSoftkey_ == 5){
                                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_DISK_STR);
                            }
                            padDisp_ = false;
                            core.request(NESCore.REQUEST_START, 0);
                            mode_ = MODE_GAME;
                            setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                            setRightSoftkeyLabel();
                            refreshDisplay();
                            repaint();
                        }
                        break;
                    case MODE_MENU_ROMSET:
                        if (padDisp_){
                            svSubMenuRomsetNo = selectSubMenuNo_;
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROMSET_STR);
                            padDisp_ = false;
                            rYes = confirm("Zbg܂H");
                            if (rYes) {
                                core.request(NESCore.REQUEST_RESET, 0);
                            } else {
                                core.request(NESCore.REQUEST_START, 0);
                            }
                            mode_ = MODE_GAME;
                            setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
                            setRightSoftkeyLabel();
                            refreshDisplay();
                            repaint();
                        }
                        break;
                    case MODE_MENU_AUDIO3_SET :
                        if (confirm("lɖ߂܂H")) {
                            initApu_np2();
                        }
                        break;
                    default :
                        break;
                }
                break;

            case Display.KEY_1 :
            case Display.KEY_2 :
            case Display.KEY_3 :
            case Display.KEY_4 :
            case Display.KEY_5 :
            case Display.KEY_6 :
            case Display.KEY_7 :
            case Display.KEY_8 :
            case Display.KEY_9 :
            case Display.KEY_0 :
            case Display.KEY_ASTERISK :
            case Display.KEY_POUND :
                int pno;
                switch (param) {
                  case Display.KEY_0 :
                    pno = 10;
                    break;
                  case Display.KEY_ASTERISK :
                  case Display.KEY_POUND :
                    pno = param + 1;
                    break;
                  default :
                    pno = param;
                }
                if (mode_ == MODE_MENU_ROOT) {
                    if (pno > MENU_ROOT.length) {
                        break;
                    }
                    selectMenuNo_ = pno - 1;
                } else {
                    if (pno > subMenu_.length) {
                        break;
                    }
                    selectSubMenuNo_ = pno - 1;
                }
                paint(g);
                // KEY_SELECT̓BbreakȂB
            case Display.KEY_SELECT :
                // oi[\ʒuZbg
                switch (mode_) {
                    case MODE_MENU_ROOT :
                        selectMenuRoot();
                        break;
                    case MODE_MENU_ROM :
                        boolean from_sp = false;
                        int stop_mode = 0;
                        // NROMROMLbVLȂSDGȂ
                        if (!noRomCache_) {
                            if (((page_ - 1) * NUM_SDROM + selectSubMenuNo_) == sdNo_)
                                if (romcache.hasRom()) {
                                    from_sp = true;
                                    stop_mode = 1;
                                }
                        }
                        messageStr = "";
                        int c = loadRom(from_sp, stop_mode);

                        if (c == 0 && !noRomCache_) {
                            boolean rYes = false;
                            int slot = 0;
                            if (keyLongPressed) {
                                // ŃZ[uXe[gTēǂݍ
                                slot = romcache.findSaveId(((page_ - 1) * NUM_SDROM + selectSubMenuNo_));
                                if (slot > 0) {
                                    rYes = true;
                                    if ((confirmMsg_ & 1) != 0)
                                        rYes = confirm("No." + slot
                                            + "\n" + saveStr_[slot - 1] + "\n[h܂H");
                                }
                            }
                            if (rYes) {
                                // SPLbVNp
                                if (!from_sp && startAndLoad_)
                                    reboot("savedstate", Integer.toString(slot));

                                refreshDisplay();
                                repaint();

                                // Z[uXe[gǂݍ
                                while(!core.exist);
                                // XXX 0.1b҂
                                try {
                                    Thread.sleep(100L);
                                } catch (Exception ex) {}
                                core.request(NESCore.REQUEST_LOAD, slot);
                            } else if (!from_sp && startAndLoad_) {
                                // SPLbVNp
                                reboot();
                            }
                        } else {
                            refreshDisplay();
                            repaint();
                        }

                        break;
                    case MODE_MENU_SAVE :
                        save();
                        refreshDisplay();
                        repaint();
                        break;
                    case MODE_MENU_LOAD :
                        tmp = saveStr_[selectSubMenuNo_].trim();
                        if (tmp.equals("")){
                            infomsg("Lȃf[^ł͂܂B");
                        } else {
                            boolean rYes = true;
                            if ((confirmMsg_ & 1) != 0)
                                rYes = confirm("No." + (selectSubMenuNo_ + 1)
                                    + "\n" + saveStr_[selectSubMenuNo_] + "\n[h܂H");
                            if (rYes) {
                                // ROMǂݍ
                                if (!noRomCache_ && keyLongPressed) {
                                    int slot = selectSubMenuNo_ + 1;
                                    int romid = romcache.romid(slot);
                                    if (romid >= 0) {
                                        from_sp = false;
                                        stop_mode = 0;
                                        if (romid == sdNo_)
                                            if (romcache.hasRom()) {
                                                from_sp = true;
                                                stop_mode = 1;
                                            }
                                        messageStr = "";
                                        page_ = romid / NUM_SDROM + 1;
                                        selectSubMenuNo_ = romid % NUM_SDROM;
                                        loadRom(from_sp, stop_mode);
                                        // SPLbVNp
                                        if (!from_sp && startAndLoad_)
                                            reboot("savedstate", Integer.toString(slot));

                                        refreshDisplay();
                                        repaint();
                                        while(!core.exist);
                                        // XXX 0.1b҂
                                        try {
                                            Thread.sleep(100L);
                                        } catch (Exception ex) {}
                                        selectSubMenuNo_ = slot - 1;
                                    }
                                }

                                messageStr = "f[^[h";
                                setMessage(messageStr);
                                core.request(NESCore.REQUEST_LOAD, selectSubMenuNo_ + 1);
                                setRightSoftkeyLabel();
                                svSubMenuLoadNo = selectSubMenuNo_;
                                messageStr = "";
                                mode_ = MODE_GAME;
                                refreshDisplay();
                                repaint();
                            }
                        }
                        break;
                    case MODE_MENU_EXPORT :
                        tmp = saveStr_[selectSubMenuNo_].trim();
                        if (tmp.equals("")){
                            infomsg("Lȃf[^ł͂܂B");
                        } else {
                            messageStr = "f[^GIFo͒";
                            setMessage(messageStr);
                            exportGIF();
                        }
                        break;
                    case MODE_MENU_IMPORT :
                        messageStr = "f[^GIFǍ";
                        setMessage(messageStr);
                        importGIF();
                        break;
                    case MODE_MENU_SETTING :
                        selectMenuSetting(SELECT);
                        break;
                    case MODE_MENU_SOFTKEY :
                        selectMenuSoftkey();
                        break;
                    case MODE_MENU_KEYCON :
                        setSoftLabel(Frame.SOFT_KEY_2, null);
                        mode_ = MODE_MENU_KEYCON_SET;
                        repaint();
                        break;
                    case MODE_MENU_KEYCON2 :
                        setSoftLabel(Frame.SOFT_KEY_2, null);
                        mode_ = MODE_MENU_KEYCON2_SET;
                        repaint();
                        break;
                    case MODE_MENU_BUTTON_SET :
                        selectMenuButtonSetting(SELECT);
                        break;
                    case MODE_MENU_DISKSIDE:
                        selectDiskSideSetting();
                        refreshDisplay();
                        repaint();
                        break;
                    case MODE_MENU_ROMSET:
                        selectRomSetting();
                        break;
                    case MODE_MENU_CHEAT_SET :
                        selectMenuCheatSetting();
                        break;
                    case MODE_MENU_AUDIO1_SET :
                        selectAudioSetting1(SELECT);
                        break;
                    case MODE_MENU_AUDIO2_SET :
                        selectAudioSetting2(SELECT);
                        break;
                    case MODE_MENU_AUDIO3_SET :
                        selectAudioSetting3(SELECT);
                        break;
                    case MODE_MENU_ROMFILE :
                        selectMenuRomFile(SELECT);
                        break;
                    case MODE_MENU_CONFIRM :
                        selectMenuConfirm(SELECT);
                        break;
                    case MODE_MENU_TOOLS :
                        selectMenuTools();
                        break;
                    case MODE_MENU_SELECT_CORE :
                        selectMenuSelectCore();
                        break;
                    case MODE_MENU_OTHER_SET :
                        selectMenuOtherSetting(SELECT);
                        break;
                    case MODE_ZOOM_SET :
                        if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) zoomSizeMode_ = !zoomSizeMode_;
                        repaint();
                        break;
                    default :
                        break;
                }
                keyLongPressed = false;
                break;

            default :
                if (param == MY_KEY_UP || param == MY_KEY_DOWN ||
                    param == MY_KEY_RIGHT || param == MY_KEY_LEFT) {
                    repaint();
                }
                break;
        }
    }

    //͎󂯎
    public void processIMEEvent(int type, String text) {
        if (type==IME_COMMITTED) {
            switch (mode_) {
                case MODE_MENU_ROM :
                    // ROM̕ҏW
                    text = formatSpace(text, SIZE_ROM_NAME);
                    sdRomnm_[selectSubMenuNo_] = text;
                    writeSdromNameSP((page_ - 1) * NUM_SDROM + selectSubMenuNo_, text);
                    repaint();
                    break;
                case MODE_MENU_LOAD :
                    // Z[u̕ҏW
                    if (!text.equals("")){
                        text = formatSpace(text, SIZE_SAVE_NAME);
                        saveStr_[selectSubMenuNo_] = text;
                        writeSPsaves(selectSubMenuNo_);
                        repaint();
                    }
                    break;
                case MODE_MENU_CHEAT_SET :
                    // ȈՃ`[g
                    boolean errf = true;
                    String errstr = "";
                    if (selectSubMenuNo_ == 0) {
                        // ꎞIɏ
                        cheat_ = text;
                        if (text.equals("")) break;
                        if (text.length() >= 11){
                            String[] chtstr = split(text, '\n', 240);
                            for (int i = 0; i < chtstr.length; i++){
                                errstr = chtstr[i];
                                if (chtstr[i].length() >= 10){
                                    try{
                                        int s = Integer.parseInt(chtstr[i].substring(0, 1), 16);
                                        int adr = Integer.parseInt(chtstr[i].substring(1, 5), 16);
                                        int k = Integer.parseInt(chtstr[i].substring(6, 7), 16);
                                        if (k > 0 && k < 5 && chtstr[i].length() >= (8 + k * 2)){
                                            if (s == 0){
                                                if (adr >= 0 && (adr + k - 1) <= 0x7FF) {
                                                    for (int j = 0; j < k; j++)
                                                       core.RAM[adr + j]
                                                        = (byte)Integer.parseInt(chtstr[i].substring(8 + (k - 1 - j) * 2, 10 + (k - 1 - j) * 2), 16);
                                                        errf = false;
                                                } else {
                                                    break;
                                                }
                                            } else if (s == 1) {
                                                if (adr >= 0 && (adr + k - 1) <= 0x1FFF) {
                                                    for (int j = 0; j < k; j++)
                                                        core.SRAM[adr + j]
                                                         = (byte)Integer.parseInt(chtstr[i].substring(8 + (k - 1 - j) * 2, 10 + (k - 1 - j) * 2), 16);
                                                        errf = false;
                                                } else {
                                                    break;
                                                }
                                            } else {
                                                break;
                                            }
                                        }else{
                                            break;
                                        }
                                    } catch (Exception e) {
                                        break;
                                    }
                                }else{
                                    break;
                                }
                            }
                        }else{
                            errstr = text;
                        }
                    }else{
                        // ɏ
                        int i;
                        switch (selectSubMenuNo_) {
                            case 4 :
                                i = 1;
                                break;
                            case 6 :
                                i = 2;
                                break;
                            case 8 :
                                i = 3;
                                break;
                            default :
                                i = 0;
                                break;
                        }
                        if (text.equals("")) {
                            chtSwitch_[i] = false;
                            chtK_[i] = 0;
                            chtStr_[i] = "";
                            repaint();
                            break;
                        }
                        chtStr_[i] = text;
                        errstr = text;
                        if (text.length() >= 10){
                            try{
                                chtS_[i] = Integer.parseInt(text.substring(0, 1), 16);
                                chtAdr_[i] = Integer.parseInt(text.substring(1, 5), 16);
                                chtK_[i] = Integer.parseInt(text.substring(6, 7), 16);
                                if (chtK_[i] > 0 && chtK_[i] < 5 && text.length() >= (8 + chtK_[i] * 2)){
                                    if (chtS_[i] == 0 || chtS_[i] == 1) {
                                        if (chtS_[i] == 0){
                                            if (chtAdr_[i] >= 0 && (chtAdr_[i] + chtK_[i] - 1) <= 0x7FF) {
                                                for (int j = 0; j < chtK_[i]; j++)
                                                   chtDat_[i][j]
                                                    = (byte)Integer.parseInt(text.substring(8 + (chtK_[i] - 1 - j) * 2, 10 + (chtK_[i] - 1 - j) * 2), 16);
                                                        errf = false;
                                            } else {
                                                errf = true;
                                            }
                                        } else if (chtS_[i] == 1) {
                                            if (chtAdr_[i] >= 0 && (chtAdr_[i] + chtK_[i] - 1) <= 0x1FFF) {
                                                for (int j = 0; j < chtK_[i]; j++)
                                                   chtDat_[i][j]
                                                    = (byte)Integer.parseInt(text.substring(8 + (chtK_[i] - 1 - j) * 2, 10 + (chtK_[i] - 1 - j) * 2), 16);
                                                        errf = false;
                                            }
                                        }
                                    }
                                }
                            } catch (Exception e) { }
                        }
                        if (errf) {
                            chtSwitch_[i] = false;
                            chtK_[i] = 0;
                        }else{
                            chtSwitch_[i] = true;
                        }
                    }
                    if (errf) alert("`[gR[hG[\n" + errstr);
                    repaint();
                    break;
                case MODE_MENU_ROMFILE :
                    // ROM̃C|[g
                    if (selectSubMenuNo_ == 3 && !text.equals("")) {
                        messageStr = "ROM̃C|[g";
                        repaint();
                        String[] romnm = split(text, '\n', MAX_SDROM_PAGE * NUM_SDROM);
                        DataOutputStream out = null;
                        try {
                            out = openSPOutputStream(SIZE_SP_SETTING,
                                    SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
                            for (int i=0; i<romnm.length; i++) {
                                if (i > NUM_SDROM * sdPage_ - 1) break;
                                out.write(formatSpace(romnm[i], SIZE_ROM_NAME).getBytes());
                            }
                            out.flush();
                        } catch (Exception e) {
                            alert("err writeInportSP: " + e);
                        } finally {
                            try {
                                out.close();
                                out = null;
                            } catch (Exception ex) {
                                out = null;
                            }
                        }
                        messageStr = "";
                    }
                    repaint();
                    break;
                default :
                    break;
            }
        }
    }

    public void paint(final Graphics g) {
        g.setFont(DEFAULT_FONT);
        try {
            if (mode_ == MODE_GAME || mode_ == MODE_ZOOM_SET) {
                //g.lock();
                switch (flipModeKey_) {
                    case 0 : //cJFʏAJF
                        //g.setFlipMode(Graphics.FLIP_NONE);
                        switch (zoom_) {
                            case 0 : //ʏ
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt(g, messageStr, fpsDisp_);
                                break;
                            case 1 : //g
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_large(g, messageStr, fpsDisp_);
                                break;
                            case 2 : //Ch
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_wide(g, messageStr, fpsDisp_);
                                break;
                            case 3 : //t
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_full(g, messageStr, fpsDisp_);
                                break;
                            default : //t[
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_free(g, 0, 0, pos_x[0], pos_y[0], messageStr, fpsDisp_);
                                break;
                        }
                        break;
                    case 1 : //cJFEAJFʏ
                        //g.setFlipMode(Graphics.FLIP_NONE);
                        switch (svZoom_) {
                            case 0 : //ʏ
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz(g, messageStr, fpsDisp_);
                                break;
                            case 1 : //g
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_large(g, messageStr, fpsDisp_);
                                break;
                            case 2 : //Ch
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_wide(g, messageStr, fpsDisp_);
                                break;
                            case 3 : //t
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_full(g, messageStr, fpsDisp_);
                                break;
                            default : //t[
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_free(g, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_);
                                break;
                        }
                        break;
                    case 2 : //cJF180AJFE
                        allG.setFlipMode(Graphics.FLIP_NONE);
                        switch (zoom_) {
                            case 0 : //ʏ
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt(allG, messageStr, fpsDisp_);
                                g.setFlipMode(Graphics.FLIP_ROTATE);
                                g.drawImage(allImg, 0, 0);
                                break;
                            case 1 : //g
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_large(allG, messageStr, fpsDisp_);
                                g.setFlipMode(Graphics.FLIP_ROTATE);
                                g.drawImage(allImg, 0, 0);
                                break;
                            case 2 : //Ch
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_wide(allG, messageStr, fpsDisp_);
                                g.setFlipMode(Graphics.FLIP_ROTATE);
                                g.drawImage(allImg, 0, 0);
                                break;
                            case 3 : //t
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_full(allG, messageStr, fpsDisp_);
                                g.setFlipMode(Graphics.FLIP_ROTATE);
                                g.drawImage(allImg, 0, 0);
                                break;
                            default : //t[
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.vrt_free(allG, 0, 0, pos_x[0], pos_y[0], messageStr, fpsDisp_);
                                g.setFlipMode(Graphics.FLIP_ROTATE);
                                g.drawImage(allImg, 0, 0);
                                break;
                        }
                        break;
                    case 3 : //cJFAJF180
                        allG.setFlipMode(Graphics.FLIP_NONE);
                        switch (svZoom_) {
                            case 0 : //ʏ
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz(allG, messageStr, fpsDisp_);
                                break;
                            case 1 : //g
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_large(allG, messageStr, fpsDisp_);
                                break;
                            case 2 : //Ch
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_wide(allG, messageStr, fpsDisp_);
                                break;
                            case 3 : //t
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_full(allG, messageStr, fpsDisp_);
                                break;
                            default : //t[
                                fb2G.setRGBPixels(0, 0, 256, 224, core.fb, 0);
                                disp.hrz_free(allG, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_);
                                break;
                        }
                        g.setFlipMode(Graphics.FLIP_ROTATE);
                        g.drawImage(allImg, 0, 0);
                        break;
                    default :
                        break;
                }
                if (mode_ == MODE_ZOOM_SET) {
                    try {
                        setSoftLabelVisible(true);
                    } catch (Exception e) {}
                    g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0x80));
                    g.fillRect(0, 0, getWidth(), getHeight());
                    if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
                        /// ĴƂW\Bc͎蔲
                        String wxh = pos_x[0] + "x" + pos_y[0];
                        int x = pos_x[1] + pos_x[0];
                        int y = pos_y[1] + pos_y[0] - DEFAULT_FONT.getHeight();
                        int wxhWidth = DEFAULT_FONT.stringWidth(wxh);
                        if ((width - x) < wxhWidth) x = width - wxhWidth;
                        if (y < 0) y = 0;
                        int black = Graphics.getColorOfName(Graphics.BLACK);
                        int green = Graphics.getColorOfName(Graphics.GREEN);
                        int white = Graphics.getColorOfName(Graphics.WHITE);
                        int yellow = Graphics.getColorOfName(Graphics.YELLOW);
                        String m, nm;
                        if (zoomSizeMode_) {
                            m = "ރ[h";
                            nm = "ʒu[h";
                        } else {
                            m = "ʒu[h";
                            nm = "ރ[h";
                        }
 						if (flipModeKey_ == 0) { //cʎ
                            disp.drawString2(g, black, green, wxh, x, y);
                            disp.drawString2(g, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
                            disp.drawString2(g, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 1) {
                            disp.drawString(g, black, green, wxh, x, y);
                            disp.drawString(g, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
                            disp.drawString(g, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 2) { //c180x]
                            // ]蔲 Ȃ񂩂ǂ܂
                            disp.drawString2(allG, black, green, wxh, x, y);
                            disp.drawString2(allG, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
                            disp.drawString2(allG, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 3) {
                            // ]蔲
                            disp.drawString(allG, black, green, wxh, x, y);
                            disp.drawString(allG, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
                            disp.drawString(allG, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						}
                    }
                }
                //g.unlock(true);
            } else if (mode_ == MODE_NONE) {
                //Ȃ
            } else {
                try {
                    setSoftLabelVisible(true);
                } catch (Exception e) {}
                if (isReverse()) {
                    MY_KEY_LEFT = Display.KEY_UP;
                    MY_KEY_UP = Display.KEY_RIGHT;
                    MY_KEY_RIGHT = Display.KEY_DOWN;
                    MY_KEY_DOWN = Display.KEY_LEFT;
                } else {
                    MY_KEY_LEFT = Display.KEY_LEFT;
                    MY_KEY_UP = Display.KEY_UP;
                    MY_KEY_RIGHT = Display.KEY_RIGHT;
                    MY_KEY_DOWN = Display.KEY_DOWN;
                }
                paintMenu(menuG);
                g.lock();
                int mw = paintMenuImage(menuImg, mscale, 0, 0, MENU_WIDTH, MENU_HEIGHT);
                if (mode_ == MODE_DIALOG && !dialogReleased) {
                    switch (dialogMode) {
                        case Dialog.DIALOG_ERROR :
                            myDialog(dialogMessage, "G[I", g.getColorOfRGB(255,0,127), "nj", "", mw);
                            break;
                        case Dialog.DIALOG_INFO :
                            myDialog(dialogMessage, "", g.getColorOfRGB(0,127,255), "nj", "", mw);
                            break;
                        case Dialog.DIALOG_YESNO :
                            myDialog(dialogMessage, "mF", g.getColorOfRGB(180,230,230), "͂", "", mw);
                            break;
                    }
                    if (!dialogShowed) dialogShowed = true;
                    paintMenuImage(menuImg, mscale, 0, 0, MENU_WIDTH, MENU_HEIGHT);
                }
                g.unlock(true);
                dialogNotReady = false;
            }

        } catch (Exception ex) {
            //alert("err paint: " + ex);
        }
    }

    private int paintMenuImage(final Image img, final int sc, final int x, final int y, int width, int height) {
        // XXX - Ȃ
        int w = width;
        int h = height;
        //g.lock();
        if (widedisplay_) {
            if (isReverse()) {
                if (w/sc > getWidth()) w = getWidth() * sc;
                if (h/sc > getHeight()) h = getHeight() * sc;
                g.setFlipMode(Graphics.FLIP_NONE);
                g.drawScaledImage(img, x, y, w/sc, h/sc, 0, 0, w, h);
            } else if (isRotate() == 0) {
                if (w/sc > getHeight()) w = getHeight() * sc;
                if (h/sc > getHeight()) h = getHeight() * sc;
                g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
                g.drawScaledImage(img, (getWidth() - getHeight()) / 2 + getHeight() - y - h/sc, getHeight() - x - w/sc, w/sc, h/sc, 0, 0, w, h);
            } else if (isRotate() > 0) {
                if (w/sc > getWidth()) w = getWidth() * sc;
                if (h/sc > getHeight()) h = getHeight() * sc;
                g.setFlipMode(Graphics.FLIP_NONE);
                g.drawScaledImage(img, x, y, w/sc, h/sc, 0, 0, w, h);
            } else {
                if (w/sc > getHeight()) w = getHeight() * sc;
                if (h/sc > getHeight()) h = getHeight() * sc;
                g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
                g.drawScaledImage(img, (getWidth() - getHeight()) / 2 + y, getHeight() - x - w/sc, w/sc, h/sc, 0, 0, w, h);
            }
        } else {
            if (isReverse()) {
                if (w/sc > getHeight()) w = getHeight() * sc;
                if (h/sc > getWidth()) h = getWidth() * sc;
                g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
                g.drawScaledImage(img, getWidth() - y - h/sc, x, w/sc, h/sc, 0, 0, w, h);
            } else if (isRotate() == 1) {
                if (w/sc > getHeight()) w = getHeight() * sc;
                if (h/sc > getWidth()) h = getWidth() * sc;
                g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
                g.drawScaledImage(img, getWidth() - y - h/sc, x, w/sc, h/sc, 0, 0, w, h);
            } else if (isRotate() == 2) {
                if (w/sc > getHeight()) w = getHeight() * sc;
                if (h/sc > getWidth()) h = getWidth() * sc;
                g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
                g.drawScaledImage(img, y, x, w/sc, h/sc, 0, 0, w, h); 
            } else {
                if (w/sc > getWidth()) w = getWidth() * sc;
                if (h/sc > getWidth()) h = getWidth() * sc;
                g.setFlipMode(Graphics.FLIP_NONE);
                g.drawScaledImage(img, x, (getHeight() - getWidth()) / 2 + y, w/sc, h/sc, 0, 0, w, h);
            }
        }
        //g.unlock(true);
        // Ȃ肾Aj[ʂ̉ԂĂƂ낢𗧂
        return w;
    }

    private void paintMenu(final Graphics g) {
        g.lock();
        switch (mode_) {
            case MODE_MENU_ROOT :
                g.setPictoColorEnabled(false);
                menu(g, "Cj[", MENU_ROOT, selectMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("pbh@\ݒ")+20*scale);
                break;

            case MODE_MENU_ROM :
                subMenu_ = sdRomnm_;
                menu(g, "ROMI (PAGE " + page_ + "/" + sdPage_ + ")", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("                              ")+20*scale);
                if (menuBGcolor_ >= 3) {
                    messageStr = "(PAGE " + page_ + "/" + sdPage_ + ")";
                }
                break;

            case MODE_MENU_SAVE :
            case MODE_MENU_LOAD :
            case MODE_MENU_EXPORT :
            case MODE_MENU_IMPORT :
                String title = "";
                switch (mode_) {
                    case MODE_MENU_LOAD :
                        title = "f[^[h";
                        break;
                    case MODE_MENU_SAVE :
                        title = "f[^Z[u";
                        break;
                    case MODE_MENU_EXPORT :
                        title = "f[^GIFo";
                        break;
                    case MODE_MENU_IMPORT :
                        title = "f[^GIFǍ";
                        break;
                    default :
                        break;
                }
                subMenu_ = saveStr_;
                messageStr = (noRomCache_ ? "SD" : "SP") + "̃f[^QƂĂ܂";
                menu(g, title, subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("                                  ")+20*scale);
                break;

            case MODE_MENU_SETTING :
                int i = 0;
                if (!fpsOff_) i = 1;
                int j = 0;
                if (alpha_) j = 1;
                subMenu_ =
                    new String[] {
                        "FPS\         : " + ON_OFF_STR[i] + FPSDISP_STR[fpsDisp_],
                        "t[XLbv    : " + frameSkip_,
                        "x(60FPS)   : " + FRAMES_STR[sleep_],
                        "NOROMǍ   : " + ON_OFF_STR[startAndLoad_?(1):(0)],
                        "Q[ʂ̉]    : " + FLIPMODE_STR[flipMode_],
                        "TEho        : " + SOFTKEY_SOUND_STR[soundEnable].trim(),
                        "E\tgL[̋@\  : " + SOFTKEY_STR[rSoftkey_],
                        "j[̓    : " + ON_OFF_STR[j],
                        "I[fBIڍאݒ",
                        "ROMt@Cݒ",
                        "mFbZ[Wݒ",
                        "̑ݒ"
                        };
                menu(g, "Sʐݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("E\tgL[̋@\  : fBXN")+20*scale);
                break;

            case MODE_MENU_SOFTKEY :
                subMenu_ = SOFTKEY_STR;
                menu(g, "E\tgL[̋@\ : " + SOFTKEY_STR[rSoftkey_], subMenu_, selectSubMenuNo_, 
                    MENU_DEFAULT_FONT.stringWidth("fBXN")+20*scale);
                break;

            case MODE_MENU_KEYCON :
                subMenu_ =
                    new String[] {
                        "A{^        : " + keyStr2Desc(keyconStr_[0]),
                        "B{^        : " + keyStr2Desc(keyconStr_[1]),
                        "SELECT{^   : " + keyStr2Desc(keyconStr_[2]),
                        "START{^    : " + keyStr2Desc(keyconStr_[3]),
                        "L[         : " + keyStr2Desc(keyconStr_[4]),
                        "L[         : " + keyStr2Desc(keyconStr_[5]),
                        "L[         : " + keyStr2Desc(keyconStr_[6]),
                        "L[         : " + keyStr2Desc(keyconStr_[7]),
                        "[h         : " + keyStr2Desc(keyconStr_[8]),
                        "Z[u         : " + keyStr2Desc(keyconStr_[9]),
                        "ڰѽ+1    : " + keyStr2Desc(keyconStr_[10]),
                        "ڰѽ-1    : " + keyStr2Desc(keyconStr_[11]) };
                g.setPictoColorEnabled(true);
                menu(g, "L[ݒ(1/2)", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("A{^        : , P, Q, R")+20*scale);
                if (menuBGcolor_ >= 3) {
                    messageStr = "(PAGE 1/2)";
                }
                break;

            case MODE_MENU_KEYCON2 :
                subMenu_ =
                    new String[] {
                        "}CNL[          : " + keyStr2Desc(mickey_),
                        "Q[̍ăL[ : " + keyStr2Desc(MY_KEY_SOFT1),
                        "Q[̉EăL[ : " + keyStr2Desc(MY_KEY_SOFT2),
                        "pbhݒL[      : " + keyStr2Desc((int)keycon2_[3]),
                        "ȈՃ`[gďoL[  : " + keyStr2Desc((int)keycon2_[4]),
                        "ZbgL[        : " + keyStr2Desc((int)keycon2_[5]),
                        "TEhݒL[    : " + keyStr2Desc((int)keycon2_[6]),
                        "fBXNL[    : " + keyStr2Desc((int)keycon2_[7]),
                        "ROM\L[     : " + keyStr2Desc((int)keycon2_[8]),
                        "`̈ݒL[    : " + keyStr2Desc((int)keycon2_[9]),
                        "ȈՃZ[uL[      : " + keyStr2Desc((int)keycon2_[10]) };
                g.setPictoColorEnabled(true);
                menu(g, "L[ݒ(2/2)", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("}CNL[          : ()")+20*scale);
                // S̍ڂɃwvĂȂ̂ňʒuZbg
                if (menuBGcolor_ >= 3) {
                    messageStr = "(PAGE 2/2)";
                }
                break;

            case MODE_MENU_KEYCON_SET :
                g.setPictoColorEnabled(false);
                messageStr = "";
                keyConfigWindow(g);
                break;

            case MODE_MENU_KEYCON2_SET :
                g.setPictoColorEnabled(false);
                messageStr = "";
                keyConfigWindow2(g);
                break;

            case MODE_MENU_BUTTON_SET :
            {
                if (pointerEnable_) {
                    int pt = 0; //ƭ
                    if (pointerType_) pt = 1; //ƭ
                    subMenu_ =
                        new String[] {
                            "A{^̘A       : " + RSPEED_STR[aRen_],
                            "A{^̃z[h   : " + ON_OFF_STR[aHold_],
                            "A{^̘Aˁ{z[h",
                            "B{^̘A       : " + RSPEED_STR[bRen_],
                            "B{^̃z[h   : " + ON_OFF_STR[bHold_],
                            "B{^̘Aˁ{z[h",
                            "}`pbh@\    : " + CTRL_STR[con2p_],
                            "j[|C^[x  : " + pointerSense_,
                            "j[|C^[  : " + POINTER_STR[pt]
                            };
                } else {
                    subMenu_ =
                        new String[] {
                            "A{^̘A       : " + RSPEED_STR[aRen_],
                            "A{^̃z[h   : " + ON_OFF_STR[aHold_],
                            "A{^̘Aˁ{z[h",
                            "B{^̘A       : " + RSPEED_STR[bRen_],
                            "B{^̃z[h   : " + ON_OFF_STR[bHold_],
                            "B{^̘Aˁ{z[h",
                            "}`pbh@\    : " + CTRL_STR[con2p_]
                            };
                }
                menu(g, "pbh@\ݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("A{^̘A       : 2()")+20*scale);
                break;
            }

            case MODE_MENU_DISKSIDE :
                subMenu_ =
                    new String[] {
                        "1st Disk Side-A",
                        "1st Disk Side-B",
                        "2nd Disk Side-A",
                        "2nd Disk Side-B"
                        //"[fBXNf[^̏㏑]"
                        };
                menu(g, "fBXN", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("1st Disk Side-A  ")+20*scale);
                break;

            case MODE_MENU_ROMSET :
                String name = curRom_ + "[" + sdNo_ + "]";
                if (core_ == CORE_NEMUPLUS2) {
                    String cycle = "" + core.get_default_cycle_line();
                    if( cycle == "") cycle = "0000";
                    if(sdRomadj_[sdNo_] >= 0) {
                        cycle += " + (" + (sdRomadj_[sdNo_] *  6) + ")";
                    } else {
                        cycle += " - (" + (sdRomadj_[sdNo_] * -6) + ")";
                    }
                    subMenu_ =
                        new String[] {
                            "ROM           : " + name,
                            "}bp[ԍ    : " + core.mapper_no ,
                            "TCN      : " + cycle ,
                            "`ʃ[h      : " + RENDERMODE_STR[change_method]
                        };
                } else {
                    subMenu_ =
                        new String[] {
                            "ROM           : " + name,
                            "}bp[ԍ    : " + core.mapper_no
                        };
                }
                menu(g, "ROMݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("                                    ")+20*scale);
                break;
                
            case MODE_MENU_CHEAT_SET :
                int[] i1 = new int[NUM_CHEAT];
                String[] er = new String[NUM_CHEAT];
                for (int i2 = 0; i2< NUM_CHEAT; i2++){
                    if (chtSwitch_[i2]){
                        i1[i2] = 1;
                    }else{
                        i1[i2] = 0;
                    }
                    if (chtK_[i2] == 0 && !chtStr_[i2].equals("")){
                        er[i2] = "(װ)";
                    }else{
                        er[i2] = "";
                    }
                }
                subMenu_ =
                    new String[] {
                        "ꎞIɏ",
                        "ɏ#1        : " + ON_OFF_STR[i1[0]],
                        "  " + er[0] +  formatSpace(chtStr_[0], 30),
                        "ɏ#2        : " + ON_OFF_STR[i1[1]],
                        "  " + er[1] +  formatSpace(chtStr_[1], 30),
                        "ɏ#3        : " + ON_OFF_STR[i1[2]],
                        "  " + er[2] +  formatSpace(chtStr_[2], 30),
                        "ɏ#4        : " + ON_OFF_STR[i1[3]],
                        "  " + er[3] +  formatSpace(chtStr_[3], 30),
                        "`[gR[h̓Ǎ",
                        "`[gR[h̕ۑ"
                        };
                menu(g, "ȈՃ`[g", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("ɏ#1        : OFF")+20*scale);
                break;

            case MODE_MENU_TOOLS :
                subMenu_ =
                    new String[] {
                        "f[^GIFo",
                        "f[^GIFǍ",
                        "ʕۑ",
                        "ݒGIFo",
                        "ݒGIFǍ",
                        "320x240(QVGA)֓ւ",
                        "426x240(QVGA)֓ւ",
                        "640x480(VGA)֓ւ",
                        "854x480(VGA)֓ւ",
                        "240x320(cQVGA)֓ւ",
                        "240x426(cQVGA)֓ւ",
                        "480x854(cVGA)֓ւ"
                        //"480x640(cVGA)֓ւ",
                    };
                menu(g, "c[", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("426x240(QVGA)֓ւ")+20*scale);
                break;

            case MODE_MENU_MICKEY_SET :
                g.setPictoColorEnabled(false);
                micKeyConfigWindow(g);
                break;

            case MODE_MENU_AUDIO1_SET :
            {
                subMenu_ =
                    new String[] {
                        "TEh[h      : " + SOUND_MODE_STR[soundMode],
                        "ʐݒl          : " + soundVolume + "%",
                        "Fؑ(vēǍ)  : " + SOUND_STR[sound_],
                        "JX^FCh1     : " + instNum_[0],
                        "JX^FCh2     : " + instNum_[1],
                        "JX^FCh3     : " + instNum_[2],
                        "JX^FCh4     : " + instNum_[3],
                        "Ch1-`go      : " + ON_OFF_STR[channelOff_[0]?(0):(1)],
                        "Ch2-`go      : " + ON_OFF_STR[channelOff_[1]?(0):(1)],
                        "Ch3-Opgo      : " + ON_OFF_STR[channelOff_[2]?(0):(1)],
                        "Ch4-mCYo      : " + ON_OFF_STR[channelOff_[3]?(0):(1)],
                        "lɖ߂"
                        };
                menu(g, "I[fBIڍאݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("TEh[h      : MODE X(NP2)")+20*scale);
                break;
            }
            case MODE_MENU_AUDIO2_SET :
            {
                subMenu_ =
                    new String[] {
                        "TEh[h      : " + SOUND_MODE_STR[soundMode],
                        "                : " + soundVolume + "%",
                        "o̓Tv[g  : " + SOUND_RATE_ARRAY[soundSampleRate],
                        "obt@t[  : " + soundBufCount,
                        "Apuo̓tB^     : " + SOUND_FILTER_STR[soundApuFilter],
                        "`g1o         : " + ON_OFF_STR[pcm_channelOff_[0]?(0):(1)],
                        "`g2o         : " + ON_OFF_STR[pcm_channelOff_[1]?(0):(1)],
                        "Opgo          : " + ON_OFF_STR[pcm_channelOff_[2]?(0):(1)],
                        "mCYcho        : " + ON_OFF_STR[pcm_channelOff_[3]?(0):(1)],
                        "DMCcho           : " + ON_OFF_STR[pcm_channelOff_[4]?(0):(1)],
                        "go        : " + ON_OFF_STR[pcm_channelOff_[5]?(0):(1)],
                        "lɖ߂"
                        };
                menu(g, "I[fBIڍאݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("TEh[h      : MODE X(NP2)")+20*scale);
                break;
            }

            case MODE_MENU_AUDIO3_SET :
                // 1ԖڂɃTEh[hǉA11Ԗڂ̉ʐݒl폜(gs)
                //      "ʐݒl          : " + soundVolume + "%",
                subMenu_ =
                    new String[] {
                        "TEh[h      : " + SOUND_MODE_STR[soundMode],
                        "Fؑ(vēǍ)  : " + SOUND_STR[np2_sound_],
                        "1/8 Pulse Tone      : " + np2_instNum_[0],
                        "1/4 Pulse Tone      : " + np2_instNum_[1],
                        "1/2 Pulse Tone      : " + np2_instNum_[2],
                        "Triangle Tone       : " + np2_instNum_[3],
                        "Noise Tone          : " + np2_instNum_[4],
                        "Ch1-`go      : " + ON_OFF_STR[sCh1Off_?(0):(1)],
                        "Ch2-`go      : " + ON_OFF_STR[sCh2Off_?(0):(1)],
                        "Ch3-Opgo      : " + ON_OFF_STR[sCh3Off_?(0):(1)],
                        "Ch4-mCYo      : " + ON_OFF_STR[sCh4Off_?(0):(1)],
                        "TEhobt@  : " + sbuf_
                        };
                menu(g, "I[fBIڍאݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("TEh[h      : MODE X(NP2)")+20*scale);
                break;

            case MODE_MENU_ROMFILE :
                subMenu_ =
                    new String[] {
                        "SDt@C쐬(+1y[W)",
                        "SDt@C폜(-1y[W)",
                        "ROM̂̃GNX|[g",
                        "ROM̂̃C|[g",
                        "SDJ[h󂫗eʂ̊mF",
                        "---------------------------",
                        "SPROMLbV : " + ON_OFF_STR[noRomCache_?(0):(1)],
                        "SPk[h   : " + (compressMode_ + 1),
                        "SPk     : " + (noCompress_ ? "k" : "kL"),
                        "SPœK",
                        "SP",
                        "SP󂫗eʂ̊mF"
                        };
                menu(g, "ROMt@Cݒ :  " + sdPage_ + "PAGE" , subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("SPk     : k")+20*scale);
                break;

            case MODE_MENU_CONFIRM :
                subMenu_ =
                    new String[] {
                        "f[^[h      : " + ON_OFF_STR[confirmMsg_ & 1],
                        "f[^Z[u      : " + ON_OFF_STR[(confirmMsg_ & 2) >> 1],
                        "Zbg          : " + ON_OFF_STR[(confirmMsg_ & 4) >> 2],
                        "I              : " + ON_OFF_STR[(confirmMsg_ & 8) >> 3],
                        "`[gǍ        : " + ON_OFF_STR[(confirmMsg_ & 16) >> 4],
                        "`[gۑ        : " + ON_OFF_STR[(confirmMsg_ & 32) >> 5],
                        "Lׂ"
                        };
                menu(g, "mFbZ[Wݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("f[^[h      : OFF")+20*scale);
                break;

            case MODE_MENU_SELECT_CORE :
                subMenu_ =
                    new String[] {
                        "IWi",
                        "\tgoNRA",
                        "NemulatorPlus2RA(Beta)"
                        };
                menu(g, "COREI", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("NemulatorPlus2RA(Beta)")+20*scale);
                break;

            case MODE_MENU_OTHER_SET :
                subMenu_ =
                    new String[] {
                        "ްђ̷ٕ\  : " + ON_OFF_STR[showSoftLabel_?(1):(0)],
                        "ްђ̿ķ : " + ((float)wt_on_game_ / 1000) + "(b)",
                        "`گ̳  : " + ((float)wt_on_refresh_ / 1000) + "(b)",
                        "QVGAVGA̫Ăg : " + ON_OFF_STR[use_vgafont_?(1):(0)],
                        "Ӱ(P)   : " + ON_OFF_STR[reverseEnable_?(1):(0)],
                        "ƭ߲(N)    : " + ON_OFF_STR[pointerEnable_?(1):(0)],
                        "ӰӰ(F)  : " + ON_OFF_STR[rotateEnable_?(1):(0)],
                        "gp޲۸ނ   : " + DIALOG_STR[dialogType_]
                        };
                menu(g, "̑ݒ", subMenu_, selectSubMenuNo_,
                    MENU_DEFAULT_FONT.stringWidth("ްђ̿ķ : Ǝ(DojaF)")+20*scale);
                break;

            default :
                break;
        }
        // 
        g.setColor(Graphics.getColorOfName(Graphics.BLACK));
        g.fillRect(0, 224 * scale, MENU_WIDTH, 16 * scale);
        if (messageStr != null) {
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            g.drawString(messageStr, 4 * scale, 224 * scale + BASE_LINE);
        }
        g.unlock(true);
    }

    /*
     * drawMsg(), drawcTriangle(), drawChs()  Shoelace 炢܂ m(_ _)m
     */
    //bZ[W\GA̕`
    public void drawMsg(final Graphics g, int xp,int yp,int whd,int hgt){
        //bZ[W\̘g`
        int[] x={xp,xp+2,xp+whd-2,xp+whd,xp+whd,xp+whd-2,xp+2,xp,xp};
        int[] y={yp+2,yp,yp,yp+2,yp+hgt-2,yp+hgt,yp+hgt,yp+hgt-2,yp+2};
        int[] x2={xp-1,xp+2,xp+whd-2,xp+whd+1,xp+whd+1,xp+whd-2,xp+2,xp-1,xp-1};
        int[] y2={yp+2,yp-1,yp-1,yp+2,yp+hgt-2,yp+hgt+1,yp+hgt+1,yp+hgt-2,yp+2};

        //bZ[W\lCr[œhԂ
        g.setColor(g.getColorOfRGB(0x33,0x33,0x77,0xCF));
        g.fillRect(xp,yp,whd,hgt);

        //bZ[Wg\
        g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
        g.drawPolyline(x,y,9);
        g.setColor(g.getColorOfRGB(0xCC,0xCC,0xCC));
        g.drawPolyline(x2,y2,9);
    }

    //J[\̕`
    public void drawcTriangle(final Graphics g, int xp,int yp){
        int[] x={xp,xp+6*scale,xp,xp};
        int[] y={yp,yp+4*scale,yp+8*scale,yp};

        g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
        g.fillPolygon(x,y,4);
    }

    //EBhE̕`
    public void drawChs(final Graphics g, String[] sChois, int x, int y, int whd){
        g.setFont(MENU_DEFAULT_FONT);
        int myp=y+HEIGHT_LINE;
        drawMsg(g, x,y,whd,(HEIGHT_LINE*sChois.length)+7*scale);
        g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
        for(int i=0;i<sChois.length;i++) g.drawString(sChois[i],x+17*scale,myp+(i*HEIGHT_LINE));
    }

    // 5ɂ́ASheolaceEBhẺwBej[ňԒwB
    private void menu(final Graphics g, final String title, final String[] menu, final int select, final int windowWidth) {
        //g.setFont(DEFAULT_FONT);
        // wi
        // menuBGcolor_ 0:A1:DA2:A3:CRA4:CRDA5:CR
        if (alpha_) {
            if (core.mapper == null) {
                if (isReverse()) {
                	g.drawScaledImage(img, 0, 0, MENU_WIDTH, 224 * scale, 0, 0, 320, 224);
                } else {
                    g.drawScaledImage(img, 0, 0, 240 * scale, 224 * scale, 80, 0, 240, 224);
                }
            }else{
                fb2G.setRGBPixels(0, 0, 256, 256, core.fb, 0);
                if (isReverse()) {
                    g.drawScaledImage(fb2, (MENU_WIDTH - 320 * scale) / 2, 0, 320 * scale, 240 * scale, 0, 0, 256, 224);
                } else {
                    g.drawScaledImage(fb2, 0, 0, 240 * scale, 224 * scale, 8, 0, 240, 224);
                }
            }
            if ((menuBGcolor_ % 3) == 0) { // 0, 3
                g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x44, 0xCF));
            }else if ((menuBGcolor_ % 3) == 1) { // 1, 4
                g.setColor(Graphics.getColorOfRGB(0x22, 0x22, 0x22, 0xCF));
            }else { // 2, 5
                g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
            }
        }else{
            if ((menuBGcolor_ % 3) == 0) { // 0, 3
                g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
            }else if ((menuBGcolor_ % 3) == 1) { // 1, 4
                g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
            }else { // 2, 5
                g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
            }
        }
        if (menuBGcolor_ >= 3) {
            g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT);

            //ShoelaceEBhE
            int shoeX = 5 * scale;
            int shoeY = 5 * scale;
            if (isReverse())
                shoeX += (MENU_WIDTH - 320 * scale) / 2;
            drawChs(g, menu, shoeX, shoeY, windowWidth);
            drawcTriangle(g, shoeX + 5 * scale, HEIGHT_LINE * (select + 1) - 5 * scale);

        } else {
            g.fillRect(0, HEIGHT_LINE, MENU_WIDTH, MENU_HEIGHT - HEIGHT_LINE - 16 * scale);

            if (menuBGcolor_ == 0) {
                g.setColor(Graphics.getColorOfRGB(0x55, 0x55, 0xAA));
            } else if (menuBGcolor_ == 1) {
                g.setColor(Graphics.getColorOfRGB(0x88, 0x88, 0x88));
            } else {
                g.setColor(Graphics.getColorOfRGB(0xA, 0x0F, 0x41));
            }
            g.fillRect(0, 0, MENU_WIDTH, HEIGHT_LINE);
            g.setColor(Graphics.getColorOfName(Graphics.BLACK));
            g.drawString(title, 2 * scale, BASE_LINE);
            g.drawString(title, 3 * scale, BASE_LINE - 1 * scale);
            g.drawString(title, 4 * scale, BASE_LINE);
            g.drawString(title, 3 * scale, BASE_LINE + 1 * scale);
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            g.drawString(title, 3 * scale, BASE_LINE);

            for (int i = 0; i < menu.length; i++) {
                // Is̔wi
                if (i == select) {
                    if (menuBGcolor_ == 0) {
                        g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xff));
                    } else if (menuBGcolor_ == 1) {
                        g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xdd));
                    } else if (menuBGcolor_ == 2) {
                        g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0xC0));
                    }
                    g.fillRect(0, HEIGHT_LINE * (i + 1), MENU_WIDTH, HEIGHT_LINE);
                    if (menuBGcolor_ == 0) {
                        g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x88));
                    } else if (menuBGcolor_ == 1) {
                        g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
                    } else if (menuBGcolor_ == 2) {
                        g.setColor(Graphics.getColorOfRGB(0xff, 0xff, 0xff));
                    }
                } else {
                    g.setColor(Graphics.getColorOfName(Graphics.WHITE));
                }
                // j[
                String num;
                if (i < 10) {
                    num = "[" + (i + 1) % 10 + "] ";
                } else {
                    switch (i){
                        case 10 :
                            num = "[*] ";
                            break;
                        case 11 :
                            num = "[#] ";
                            break;
                        default :
                            num = "[-] ";
                            break;
                    }
                }
                String romno = "";
                if (mode_ == MODE_MENU_ROM){
                    romno = formatNumber((page_ - 1) * NUM_SDROM + i + 1, 3) + " ";
                }
                g.drawString(num + romno + menu[i], 4 * scale, HEIGHT_LINE * (i + 1) + BASE_LINE);
            }
        }
    }

    private void keyConfigWindow(final Graphics g) {
        // ݒ
        if ((menuBGcolor_ % 3) == 0) { // wi
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
        }else if ((menuBGcolor_ % 3) == 1){
            g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
        }else{
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
        }
        g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT - 16 * scale);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.drawString(MENU_KEYCON[selectSubMenuNo_] + " Ɋ蓖ĂL[", 10 * scale, 50 * scale);
        g.drawString("ĂB", 10 * scale, 50 * scale + HEIGHT_LINE);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.fillRect(6 * scale, 50 * scale + HEIGHT_LINE * 2 - BASE_LINE, MENU_WIDTH, HEIGHT_LINE);
        g.setColor(Graphics.getColorOfName(Graphics.BLACK));
        g.drawString("ݒl:" + keyStr2Desc(keyconStr_[selectSubMenuNo_]), 10 * scale, 50 * scale + HEIGHT_LINE * 2);

        if (MY_KEY_SOFT1 != Display.KEY_SOFT1) {
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            g.setPictoColorEnabled(true);
            g.drawString("MENU ɂ " + keyStr2Desc(MY_KEY_SOFT1) + "  Ŗ߂Ă", 10 * scale, 50 * scale + HEIGHT_LINE * 4);
        }
    }

    private void keyConfigWindow2(final Graphics g) {
        if (selectSubMenuNo_ == 0) {
            mode_ = MODE_MENU_MICKEY_SET;
            micKeyConfigWindow(g);
            return;
        }
        if ((menuBGcolor_ % 3) == 0) { // wi
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
        }else if ((menuBGcolor_ % 3) == 1){
            g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
        }else{
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
        }
        g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT - 16 * scale);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.drawString(MENU_KEYCON2[selectSubMenuNo_] + " Ɋ蓖ĂL[", 10 * scale, 50 * scale);
        g.drawString("ĂB", 10 * scale, 50 * scale + HEIGHT_LINE);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.fillRect(6 * scale, 50 * scale + HEIGHT_LINE * 2 - BASE_LINE, MENU_WIDTH, HEIGHT_LINE);
        g.setColor(Graphics.getColorOfName(Graphics.BLACK));
        g.drawString("ݒl:" + keyStr2Desc((int)keycon2_[selectSubMenuNo_]), 10 * scale, 50 * scale + HEIGHT_LINE * 2);

        if (MY_KEY_SOFT1 != Display.KEY_SOFT1) {
            g.setPictoColorEnabled(true);
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            g.drawString("MENU ɂ " + keyStr2Desc(MY_KEY_SOFT1) + "  Ŗ߂Ă", 10 * scale, 50 * scale + HEIGHT_LINE * 4);
        }
    }

    private void micKeyConfigWindow(final Graphics g) {
        // ϲݒ
        if ((menuBGcolor_ % 3) == 0) { // wi
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
        }else if ((menuBGcolor_ % 3) == 1){
            g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
        }else{
            g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
        }
        g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT - 16 * scale);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.drawString("}CN@\Ɋ蓖ĂL[", 10 * scale, 50 * scale);
        g.drawString("ĂB", 10 * scale, 50 * scale + HEIGHT_LINE);

        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.fillRect(6 * scale, 50 * scale + HEIGHT_LINE * 2 - BASE_LINE, MENU_WIDTH, HEIGHT_LINE);
        g.setColor(Graphics.getColorOfName(Graphics.BLACK));
        g.drawString("ݒl:" + keyStr2Desc(mickey_),10 * scale, 50 * scale + HEIGHT_LINE * 2);
    }

    private void selectMenuRoot() {
        boolean rYes = true;
        switch (selectMenuNo_ + 1) {
            case 1 : // ROMI
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
                page_ = sdNo_ / NUM_SDROM + 1;
                selectSubMenuNo_ = sdNo_ % NUM_SDROM;
                readSdromNameSP(page_);
                mode_ = MODE_MENU_ROM;
                break;

            case 2 : // LOAD
                selectSubMenuNo_ = svSubMenuLoadNo;
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
                mode_ = MODE_MENU_LOAD;
                break;

            case 3 : // SAVE
                selectSubMenuNo_ = svSubMenuSaveNo;
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SAVE_STR);
                mode_ = MODE_MENU_SAVE;
                break;

            case 4 : // RESET
                if ((confirmMsg_ & 4) != 0) rYes = confirm("Zbg܂H");
                if (rYes) {
                    core.request(NESCore.REQUEST_RESET, 0);
                    setRightSoftkeyLabel();
                    mode_ = MODE_GAME;
                    refreshDisplay();
                }
                break;

            case 5 : // ݒ
                selectSubMenuNo_ = svSubMenuSettingNo;
                frameSkip_ = svframeSkip_;
                //setSoftLabel(Frame.SOFT_KEY_2, null);
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
                mode_ = MODE_MENU_SETTING;
                break;

            case 6 : // KeyConfig
                selectSubMenuNo_ = svSubMenuKeyConfNo;
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_KEYSET_STR);
                if (svSubMenuKeyConfPage == 2) {
                    mode_ = MODE_MENU_KEYCON2;
                } else {
                    mode_ = MODE_MENU_KEYCON;
                }
                break;

            case 7 : // {^@\ݒ
                selectSubMenuNo_ = svSubMenuPadNo;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_BUTTON_SET;
                break;

            case 8 : // fBXN
                setSoftLabel(Frame.SOFT_KEY_2, null);
                byte current_disk = core.get_disk_side();
                selectSubMenuNo_ = (current_disk > 0 && current_disk <= 4) ? (current_disk - 1) : (0);
                mode_ = MODE_MENU_DISKSIDE;
                break;

            case 9 : // ȈՃ`[g
                selectSubMenuNo_ = svSubMenuCheatNo;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_CHEAT_SET;
                break;

            case 10 : // c[
                selectSubMenuNo_ = svSubMenuToolNo;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_TOOLS;
                break;

            case 11 : // o[W
                infomsg(VERSION_STR);
                break;

            case 12 : // COREI
                //selectSubMenuNo_ = svSubMenuSelectCoreNo;
                selectSubMenuNo_ = core_;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_SELECT_CORE;
                break;

            default :
                break;
        }
        repaint();
    }

    private void selectMenuSetting(final int i) {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 : // ](gO)
                switch (i) {
                    case SELECT :
               	    case RIGHT :
               	   	    if (++fpsDisp_ > 3) fpsDisp_ = 0;
                        break;
               	    case LEFT :
               	   	    if (--fpsDisp_ < 0) fpsDisp_ = 3;
               	   	    break;
                }
                if (fpsDisp_ == 3) fpsOff_ = true;
                else fpsOff_ = false;
                writeSP();
                break;
            case 2 : // fs
                switch (i) {
                    case SELECT :
               	    case RIGHT :
               	    	frameSkip_++;
                        if (frameSkip_ > 30) frameSkip_ = 1;
                    	break;
                    case LEFT :
                    	frameSkip_--;
                    	if (frameSkip_ < 1) frameSkip_ = 30;
                    	break;
                }
                svframeSkip_ = frameSkip_;
                writeSP();
                break;

            case 3 : // x(60FPS)
                switch (i) {
                    case SELECT :
               	    case RIGHT :
               	    	sleep_++;
                    	if (sleep_ == 3) sleep_ = 0;
                    	break;
                    case LEFT :
                    	sleep_--;
                    	if (sleep_ < 0) sleep_ = 2;
                    	break;
                }
                writeSP();
                break;

            case 4 : // NɑOROMǂݍނ
                startAndLoad_ = !startAndLoad_;
                writeSP();
                break;

            case 5 : // ʂ̉]
                switch (i) {
                    case SELECT :
                    case RIGHT :
                    	flipMode_++;
                    	if (flipMode_ == 4) flipMode_ = 0;
                    	break;
                    case LEFT :
                    	flipMode_--;
                    	if (flipMode_ < 0) flipMode_ = 3;
                    	break;
                }
                setFlipModeKey();
                writeSP();
                break;

            case 6 : // TEho
                soundEnable = (soundEnable + 1) & 1;
                core.setApuVolume(soundEnable, soundVolume);
                writeSP();
                break;

            case 7 : // Eķ@\
                switch (i) {
                    case SELECT :
                    	selectSubMenuNo_ = rSoftkey_;
                    	mode_ = MODE_MENU_SOFTKEY;
                    	setSoftLabel(Frame.SOFT_KEY_2, null);
                    	break;
                }
                break;
            case 8 : // j[̓
                alpha_ = !alpha_;
                writeSP();
                break;

            case 9 : // I[fBIݒ
                switch (i) {
                    case SELECT :
                        if(soundMode == 3) {
                    	    selectSubMenuNo_ = svSubMenuAudioSetting1No;
                            mode_ = MODE_MENU_AUDIO1_SET;
                            setSoftLabel(Frame.SOFT_KEY_2, null);
                        } else if (soundMode < 3) {
                    	    selectSubMenuNo_ = svSubMenuAudioSetting2No;
                            mode_ = MODE_MENU_AUDIO2_SET;
                            setSoftLabel(Frame.SOFT_KEY_2, null);
                        } else {
                    	    selectSubMenuNo_ = svSubMenuAudioSetting3No;
                            mode_ = MODE_MENU_AUDIO3_SET;
                            setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_INIT_STR);
                        }
                        break;
                }
                break;

            case 10 : // ROMt@Cݒ
                switch (i) {
                    case SELECT :
                    	selectSubMenuNo_ = svSubMenuRomFileNo;
                    	mode_ = MODE_MENU_ROMFILE;
                    	setSoftLabel(Frame.SOFT_KEY_2, null);
                    	break;
                }
                break;
            case 11 : // mFbZ[W
                switch (i) {
                    case SELECT :
                    	selectSubMenuNo_ = svSubMenuConfirmNo;
                    	mode_ = MODE_MENU_CONFIRM;
                    	setSoftLabel(Frame.SOFT_KEY_2, null);
                    	break;
                }
                break;
            case 12 : // ̑ݒ
                switch (i) {
                    case SELECT :
                    	selectSubMenuNo_ = svSubMenuOtherNo;
                    	mode_ = MODE_MENU_OTHER_SET;
                    	setSoftLabel(Frame.SOFT_KEY_2, null);
                    	break;
                }
                break;
            default :
                break;
        }
        repaint();
    }

    private void selectMenuTools() {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 : // Z[uEXPORT
                svSubMenuToolNo = selectSubMenuNo_;
                selectSubMenuNo_ = svSubMenuExportNo;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_EXPORT;
                break;

            case 2 : // Z[uIMPORT
                svSubMenuToolNo = selectSubMenuNo_;
                selectSubMenuNo_ = svSubMenuImportNo;
                setSoftLabel(Frame.SOFT_KEY_2, null);
                mode_ = MODE_MENU_IMPORT;
                break;

            case 3 : // XN[Vbg
                svSubMenuToolNo = selectSubMenuNo_;
                messageStr = "ʕۑ";
                repaint();
                saveScreenShot();
                messageStr = "";
                break;

            case 4 : // ݒEXPORT
                exportGIF();
                break;

            case 5 : // ݒIMPORT
                importGIF();
                break;

            case 6 : // QVGA
            case 7 : // QVGAt
            case 8 : // VGA
            case 9 : // VGAt
            case 10 : // cQVGA
            case 11 : // cQVGAt
            case 13 : // cVGA
            case 12 : // cVGAt
                if (!confirm("gp̋@ŖȃTCYIƁANłȂȂꍇ܂B܂H")) {
                    break;
                }
                svSubMenuToolNo = selectSubMenuNo_;
                String size = "";
                switch (select) {
                    case 6 :
                        size = "320x240";
                        break;
                    case 7 :
                        size = "426x240";
                        break;
                    case 8 :
                        size = "640x480";
                        break;
                    case 9 :
                        size = "854x480";
                        break;
                    case 10 :
                        size = "240x320";
                        break;
                    case 11 :
                        size = "240x426";
                        break;
                    case 13 :
                        size = "480x640";
                        break;
                    case 12 :
                        size = "480x854";
                        break;
                }
                //jamt@C DrawArea  LastModified  cgi Ăяo
                String url = IApplication.getCurrentApp().getSourceURL() + "NemulatorPlus.cgi?" + size;
                HttpConnection http = null;
                int responseCode = 0;
                try {
                    http = (HttpConnection)Connector.open(url,Connector.READ,true);
                    http.setRequestMethod(HttpConnection.GET);
                    http.connect();
                    responseCode = http.getResponseCode();
                } catch (ConnectionException ce) {
                    alert(ce.toString() + "\n" + ce.getStatus());
                } catch (Exception e) {
                    alert(e.toString());
                } finally {
                    try{
                        if (http!=null) http.close();
                        http = null;
                    }catch(Exception e){
                        http = null;
                    }
                }
                if (responseCode == HttpConnection.HTTP_OK) {
                    if (!noRomCache_ && core.exist) {
                        romcache.onSaving = true;
                        core.request(NESCore.REQUEST_SAVE, 0);
                        while (romcache.onSaving);
                    }
                    IApplication.getCurrentApp().launch(IApplication.LAUNCH_VERSIONUP, null);
                } else {
                    alert("NG: " + size + "/" + responseCode);
                }
                break;

            default :
                break;
        }
        repaint();
    }

    private void selectMenuSoftkey() {
        // E\tgL[@\
        rSoftkey_ = selectSubMenuNo_;
        if (rSoftkey_ == 4) {
            skeyMask_ = 0xFFFFFFFF;
        } else {
            skeyMask_ = 0xFFBFFFFF;
        }
        writeSP();
        selectSubMenuNo_ = 6;
        mode_ = MODE_MENU_SETTING;
        repaint();
    }

    private void selectMenuRomFile(final int key) {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 : // SDt@C쐬
                switch (key) {
                    case SELECT :
                        if (sdPage_ < MAX_SDROM_PAGE) {
                            if (confirm("SDJ[hɃt@C쐬܂H")) {
                                sdPage_++;
                                messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬";
                                repaint();
                                createSdfiles(sdPage_);
                                if(sdPage_ == 1) createDisksysfiles();
                                writeSP();
                                messageStr = "";
                            }
                        } else {
                            infomsg("őy[WɒB܂B");
                        }
                        break;
                }
                break;

            case 2 : // SDt@C폜
                switch (key) {
                    case SELECT :
                        if (sdPage_ > 1) {
                            if (confirm("SDJ[h̃t@C폜܂H\n납1y[W" + NUM_SDROM + "t@C폜")) {
                                messageStr = "SDt@C(y[W" + sdPage_ + ")폜";
                                repaint();
                                deleteSdfiles(sdPage_);
                                sdPage_--;
                                if (sdNo_ > sdPage_ * NUM_SDROM) sdNo_ = 0;
                                writeSP();
                                messageStr = "";
                            }
                        } else {
                            infomsg("ŏy[WɒB܂B");
                        }
                        break;
                }
                break;

            case 3 : // ROMGNX|[g
                switch (key) {
                    case SELECT :
                        String eXstr = "";
                        messageStr = "ROM̃GNX|[g";
                        repaint();
                        for(int i=0; i<sdPage_; i++){
                            readSdromNameSP(i + 1);
                            for(int j=0; j<NUM_SDROM; j++) eXstr = eXstr + sdRomnm_[j].trim() + "\n";
                        }
                        imeOn(eXstr, TextBox.DISPLAY_ANY, TextBox.KANA);
                        messageStr = "";
                        break;
                }
                break;

            case 4 : // ROMC|[g
                switch (key) {
                    case SELECT :
                        if (confirm("ROM̂C|[g܂H")) {
                            imeOn("", TextBox.DISPLAY_ANY, TextBox.KANA);
                        }
                        break;
                }
                break;

            case 5 : // 󂫗eʂ̊mF
                switch (key) {
                    case SELECT :
                        SDbinding sd = new SDbinding();
                        long fs = sd.sdGetFreeSize() / 1024;
                        infomsg("SDJ[h󂫗eʁF" + fs + "KB");
                        break;
                }
                break;

            case 7 : // ROMLbV
                switch (key) {
                    case SELECT :
                        boolean svNoRomCache = noRomCache_;
                        noRomCache_ = romcache.enableRomCache(noRomCache_);
                        core.set_spmode(!noRomCache_);
                        if (noRomCache_) {
                            if (svNoRomCache == noRomCache_) {
                                alert("ROMLbV͖Ԃ̂߁AONɕύX邱Ƃ͂ł܂B");
                            }
                            dialogNotReady = true;
                            if (confirm("SP̾ްSD\n߰܂H\n"
                                + "(SP̾ް͍폜܂)")) {
                                //messageStr = "SP(XNb`pbh)ɕۑĂZ[uf[^SDɃRs[Ă܂B";
                                romcache.onMoving = true;
                                boolean ret = romcache.cache2sd(0);
                                while(romcache.onMoving);
                                infomsg("SPSDւ\n߰܂B"
                                    + (ret ? "()" : "(s)"));
                            }
                        } else if (!noRomCache_ && (svNoRomCache != noRomCache_)) {
                            dialogNotReady = true;
                            if (confirm("SD̾ްSP\n߰܂H")) {
                                //messageStr = "SDɕۑĂZ[uf[^SP(XNb`pbh)ɃRs[Ă܂B";
                                romcache.onMoving = true;
                                boolean ret = romcache.sd2cache(0);
                                while(romcache.onMoving);
                                infomsg("SDSPւ\n߰܂B"
                                    + (ret ? "()" : "(s)"));
                            }
                        }
                        writeSP();
                        break;
				}
				break;

            case 8 : // ROMLbVk[h
				switch (key) {
					case SELECT :
					case RIGHT :
                        compressMode_++;
                        if (compressMode_ > 1) compressMode_ = -1;
                        break;
					case LEFT :
						compressMode_--;
						if (compressMode_ < -1) compressMode_ = 1;
						break;
				}
                compressMode_ = romcache.setCompressMode(compressMode_);
                writeSP();
                break;

            case 9 : // ROMLbVk
                noCompress_ = romcache.disableCompress(!noCompress_);
                writeSP();
                break;

            case 10 : // ROMLbVœK
                switch (key) {
                    case SELECT :
                        romcache.compact();
                        break;
                }
                break;

            case 11 : // ROMLbV
                switch (key) {
                    case SELECT :
                        if (confirm("Nɏ܂B\nSPɕۑZ[uf[^Ȃǂׂ͂ď܂B\n낵łH"))
                        romcache.reset();
                        break;
                }
                break;

            case 12 : // ROMLbV󂫗eʂ̊mF
                switch (key) {
                    case SELECT :
                        romcache.status();
                        break;
                }
                break;

            default :
                break;
        }
        repaint();
    }

    private void selectMenuConfirm(final int i) {
        // mFbZ[Wݒ
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                confirmMsg_ ^= 1;
                break;
            case 2 :
                confirmMsg_ ^= 2;
                break;
            case 3 :
                confirmMsg_ ^= 4;
                break;
            case 4 :
                confirmMsg_ ^= 8;
                break;
            case 5 :
                confirmMsg_ ^= 16;
                break;
            case 6 :
                confirmMsg_ ^= 32;
                break;
            default :
                switch (i) {
                    case SELECT :
                        if ((confirmMsg_ & 0xFF) == 0xC0) {
                            confirmMsg_ = 0xFF;
                        } else {
                            confirmMsg_ = 0xC0;
                        }
                        break;
                }
                break;
        }
        writeSP();
        repaint();
    }

    private void selectMenuButtonSetting(final int i) {
        // pbh@\ݒ
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if(++aRen_ > 5) aRen_ = 0;
                        break;
                    case LEFT :
                        if(--aRen_ < 0) aRen_ = 5;
                        break;
                }
                break;

            case 2 :
                aHold_ = (aHold_ + 1) & 1;
                break;

            case 3 :
                switch (i) {
                    case SELECT :
                        if (aRen_ != 0 && aHold_ != 0) {
                            aRen_ = 0;
                            aHold_ = 0;
                        } else {
                            aRen_ = 1;
                            aHold_ = 1;
                        }
                        break;
                }
                break;

            case 4 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if(++bRen_ > 5) bRen_ = 0;
                        break;
                    case LEFT :
                        if(--bRen_ < 0) bRen_ = 5;
                        break;
                }
                break;

            case 5 :
                bHold_ = (bHold_ + 1) & 1;
                break;

            case 6 :
                switch (i) {
                    case SELECT :
                        if (bRen_ != 0 && bHold_ != 0) {
                            bRen_ = 0;
                            bHold_ = 0;
                        } else {
                            bRen_ = 1;
                            bHold_ = 1;
                        }
                        break;
                }
                break;

            case 7 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        con2p_ += 1;
                        if (con2p_ > 2) con2p_ = 0;
                        break;
                    case LEFT :
                        con2p_ -= 1;
                        if (con2p_ < 0) con2p_ = 2;
                        break;
                }
                break;

            case 8 :
                try {
                    PointingDevice.isAvailable();
                    PointingDevice.setMode(PointingDevice.MODE_JOYSTICK);
                    switch (i) {
                        case SELECT :
                            if (pointerSense_ < 128) {
                                pointerSense_ += 1;
                                PointingDevice.setEnabled(true);
                            }
                            if (pointerSense_ == 128) {
                                pointerSense_ = 0;
                                PointingDevice.setEnabled(false);
                            }
                            break;
                        case RIGHT :
                            if (pointerSense_ < 118) {
                                pointerSense_ += 10;
                                PointingDevice.setEnabled(true);
                            } else if (pointerSense_ >= 118) {
                                pointerSense_ = 127;
                            }
                            break;
                        case LEFT :
                            if (pointerSense_ > 10) {
                                pointerSense_ -= 10;
                                PointingDevice.setEnabled(true);
                            } else if (pointerSense_ <= 10) {
                                pointerSense_ = 0;
                                PointingDevice.setEnabled(false);
                            }
                            break;
                    }
				} catch (Exception ex) {
                    alert("̋@\ƭ߲\n ڋ@ł̂ݗLłB");
				}
				break;

            case 9 : // ƭە
                try {
                    PointingDevice.isAvailable();
                    pointerType_ = !pointerType_;
                } catch (Exception ex) {
                      alert("̋@\ƭ߲\nڋ@ł̂ݗLłB");
                }
                break;

            default :
                break;
        }
        repaint();
    }

    private void selectDiskSideSetting() {
        int select = selectSubMenuNo_ + 1;
        boolean ret = true;

        if (core.get_disk_side() != select && core.num_DISK_banks >= select) {
            ret = confirm("fBXN܂H");
            if (ret) {
                messageStr = "fBXN";
                setMessage(messageStr);
                core.request(NESCore.REQUEST_CHDISK, select);
                setRightSoftkeyLabel();
                messageStr = "";
                mode_ = MODE_GAME;
            }
        /*
        } else if(select == 5) {
            overwritetDiskImage();
        */
        } else {
            core.request(NESCore.REQUEST_START, 0);
            setRightSoftkeyLabel();
            mode_ = MODE_GAME;
        }
    }

    private void selectRomSetting() {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
        case 1:
        case 2:
            break;
        case 3:
            sdRomadj_[sdNo_] = (sdRomadj_[sdNo_] < 5)?(sdRomadj_[sdNo_] + 1):(-5);
            adjust_dozencycle = sdRomadj_[sdNo_] * 6;
            writeSPadjusts();
            break;
        case 4:
        	if(change_method == NESCore_NP2.UNKNOWN_RENDER)
        	    change_method = NESCore_NP2.POST_ALL_RENDER;
        	else if(change_method == NESCore_NP2.POST_ALL_RENDER)
        	    change_method = NESCore_NP2.TILE_RENDER;
        	else if(change_method == NESCore_NP2.TILE_RENDER)
        	    change_method = NESCore_NP2.UNKNOWN_RENDER;
        	else
        	    change_method = NESCore_NP2.UNKNOWN_RENDER;
            break;
        }
        repaint();
    }
    
    /*
    private void overwritetDiskImage() {
        boolean ret = true;

        ret = confirm("fBXN㏑܂H");
        if (ret) {
            messageStr = "f[^Z[u";
            setMessage(messageStr);
            core.request(NESCore.REQUEST_WRDISK, sdNo_);
        } else {
            core.request(NESCore.REQUEST_START, 0);
        }
        setRightSoftkeyLabel();
        messageStr = "";
        mode_ = MODE_GAME;
    }
    */

    private void selectMenuCheatSetting() {
        // ȈՃ`[g
        boolean rYes = true;
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                imeOn(cheat_, TextBox.DISPLAY_ANY, TextBox.NUMBER);
                break;

            case 2 :
                if (chtK_[0] > 0) chtSwitch_[0] = !chtSwitch_[0];
                break;

            case 3 :
                imeOn(chtStr_[0], TextBox.DISPLAY_ANY, TextBox.NUMBER);
                break;

            case 4 :
                if (chtK_[1] > 0) chtSwitch_[1] = !chtSwitch_[1];
                break;

            case 5 :
                imeOn(chtStr_[1], TextBox.DISPLAY_ANY, TextBox.NUMBER);
                break;

            case 6 :
                if (chtK_[2] > 0) chtSwitch_[2] = !chtSwitch_[2];
                break;

            case 7 :
                imeOn(chtStr_[2], TextBox.DISPLAY_ANY, TextBox.NUMBER);
                break;

            case 8 :
                if (chtK_[3] > 0) chtSwitch_[3] = !chtSwitch_[3];
                break;

            case 9 :
                imeOn(chtStr_[3], TextBox.DISPLAY_ANY, TextBox.NUMBER);
                break;

            case 10 :
                if (core.mapper == null) break;
                if ((confirmMsg_ & 16) != 0) rYes = confirm("`[gR[hǍ݂܂H");
                if (rYes) {
                    messageStr = "`[gR[hǍ";
                    setMessage(messageStr);
                    SDbinding sd = null;
                    DataInputStream is = null;
                    try {
                        sd = new SDbinding();
                        is = sd.openDataInputStream("C" + formatNumber(sdNo_, 3) + ".CHT");
                        if (is == null) {
                            alert("`[gR[hۑĂ܂B");
                        } else {
                            int len = is.readInt();
                            byte[] buf = new byte[len];
                            is.read(buf);
                            cheat_ = new String(buf);
                            for (int i = 0; i < NUM_CHEAT; i++) {
                                chtSwitch_[i] = is.readBoolean();
                                len = is.readInt();
                                buf = new byte[len];
                                is.read(buf);
                                chtStr_[i] = new String(buf);
                                chtS_[i] = is.readInt();
                                chtAdr_[i] = is.readInt();
                                chtK_[i] = is.readInt();
                                is.read(chtDat_[i]);
                            }
                        }
                    }catch(Exception e){
                        alert("err CheatLoad: " + e);
                    } finally {
                        try{
                            is.close();
                        }catch(Exception e){}
                        is = null;
                        if(sd!=null) sd.close();
                        sd = null;
                    }
                    messageStr = "";
                }
                break;

            case 11 :
                if (core.mapper == null) break;
                if ((confirmMsg_ & 32) != 0) rYes = confirm("`[gR[hۑ܂H");
                if (rYes) {
                    messageStr = "`[gR[hۑ";
                    setMessage(messageStr);
                    SDbinding sd = null;
                    DataOutputStream os = null;
                    try {
                        sd = new SDbinding();
                        os = sd.openDataOutputStream("C" + formatNumber(sdNo_, 3) + ".CHT");
                        if (os == null) {
                            alert("`[gR[hۑɎs܂B");
                        } else {
                            byte[] buf = cheat_.getBytes();
                            os.writeInt(buf.length);
                            os.write(buf);
                            for (int i = 0; i < NUM_CHEAT; i++) {
                                os.writeBoolean(chtSwitch_[i]);
                                buf = chtStr_[i].getBytes();
                                os.writeInt(buf.length);
                                os.write(buf);
                                os.writeInt(chtS_[i]);
                                os.writeInt(chtAdr_[i]);
                                os.writeInt(chtK_[i]);
                                os.write(chtDat_[i]);
                            }
                            os.flush();
                        }
                    }catch(Exception e){
                        alert("err CheatSave: " + e);
                    } finally {
                        try{
                            os.close();
                        } catch(Exception e) {}
                        os = null;
                        if(sd!=null) sd.close();
                        sd = null;
                    }
                    messageStr = "";
                }
                break;

            default :
                break;
        }
        repaint();
    }

    private void selectAudioSetting1(final int i) {
        // I[fBIڍאݒ
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if(++soundMode > 4) soundMode = 0;
                        break;
                    case LEFT :
                        if(--soundMode < 0) soundMode = 4;
                        break;
                }
                if(soundMode < 3) {
                    mode_ = MODE_MENU_AUDIO2_SET;
                    repaint();
                } else if(soundMode == 4) {
                    mode_ = MODE_MENU_AUDIO3_SET;
                    setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_INIT_STR);
                    repaint();
                } else {
                    core.setApuMode(soundMode);
                }
                break;
            case 2 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        soundVolume += 10;
                        if (soundVolume > 100) soundVolume = 0;
                        break;
                    case LEFT :
                        soundVolume -= 10;
                        if (soundVolume < 0) soundVolume = 100;
                        break;
                }
                break;
            case 3 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        sound_++;
                        if (sound_ > 3) sound_ = 0;
                        break;
                    case LEFT :
                        sound_--;
                        if (sound_ < 0) sound_ = 3;
                        break;
                }
                break;
            case 4 :
            case 5 :
            case 6 :
            case 7 :
                switch (i) {
                    case SELECT :
                        if (instNum_[select - 4] < 128) instNum_[select - 4]++;
                            else instNum_[select - 4] = 1;
                        break;
                }
                break;
            case 8 :
            case 9 :
            case 10 :
            case 11 :
                channelOff_[select - 8] = !channelOff_[select - 8];
                break;
            default :
                initApu();
                break;
        }
        repaint();
    }

    private void selectAudioSetting2(final int i) {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if(++soundMode > 4) soundMode = 0;
                        break;
                    case LEFT :
                        if(--soundMode < 0) soundMode = 4;
                        break;
                }
                if(soundMode == 3) {
                    mode_ = MODE_MENU_AUDIO1_SET;
                    repaint();
                } else if(soundMode == 4) {
                    mode_ = MODE_MENU_AUDIO3_SET;
                    setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_INIT_STR);
                    repaint();
                } else {
                    core.setApuMode(soundMode);
                }
                break;
            case 2 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        soundVolume += 10;
                        if (soundVolume > 100) soundVolume = 0;
                        break;
                    case LEFT :
                        soundVolume -= 10;
                        if (soundVolume < 0) soundVolume = 100;
                        break;
                }
                break;
            case 3 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        soundSampleRate++;
                        if (soundSampleRate > 2) soundSampleRate = 0;
                        break;
                    case LEFT :
                        soundSampleRate--;
                        if (soundSampleRate < 0) soundSampleRate = 2;
                        break;
                }
                break;
            case 4 :
                switch (i) {
                    case SELECT :
                        if(soundBufCount < 60)
                            soundBufCount++;
                        else
                            soundBufCount = 15;
                    break;
                }
                break;
            case 5 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        soundApuFilter++;
                        if (soundApuFilter > 2) soundApuFilter = 0;
                        break;
                    case LEFT :
                        soundApuFilter--;
                        if (soundApuFilter < 0) soundApuFilter = 2;
                        break;
                }
                break;
            case 6 :
            case 7 :
            case 8 :
            case 9 :
            case 10 :
            case 11 :
                pcm_channelOff_[select - 6] = !pcm_channelOff_[select - 6];
                break;
            default :
                initPcm();
                break;
        }
        repaint();
    }

    private void selectAudioSetting3(final int i) {
        // I[fBIڍאݒ
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if(++soundMode > 4) soundMode = 0;
                        break;
                    case LEFT :
                        if(--soundMode < 0) soundMode = 4;
                        break;
                }
                if(soundMode == 3) {
                    mode_ = MODE_MENU_AUDIO1_SET;
                    setSoftLabel(Frame.SOFT_KEY_2, null);
                    repaint();
                } else if(soundMode < 3) {
                    mode_ = MODE_MENU_AUDIO2_SET;
                    setSoftLabel(Frame.SOFT_KEY_2, null);
                    repaint();
                } else {
                    core.setApuMode(soundMode);
                }
                break;
            case 2 :
                if (np2_sound_ < PSGi.MODE_ROHM) {
                    np2_sound_++;
                } else {
                    np2_sound_ = PSGi.MODE_PRESET;
                }
                break;
            case 3 :
                switch (i) {
                    case SELECT :
                        if (np2_instNum_[0] < 128) np2_instNum_[0]++;
                            else np2_instNum_[0] = 1;
                        break;
                }
                break;
            case 4 :
                switch (i) {
                    case SELECT :
                        if (np2_instNum_[1] < 128) np2_instNum_[1]++;
                            else np2_instNum_[1] = 1;
                        break;
                }
                break;
            case 5 :
                switch (i) {
                    case SELECT :
                        if (np2_instNum_[2] < 128) np2_instNum_[2]++;
                            else np2_instNum_[2] = 1;
                        break;
                }
                break;
            case 6 :
                switch (i) {
                    case SELECT :
                        if (np2_instNum_[3] < 128) np2_instNum_[3]++;
                            else np2_instNum_[3] = 1;
                        break;
                }
                break;
            case 7 :
                switch (i) {
                    case SELECT :
                        if (np2_instNum_[4] < 128) np2_instNum_[4]++;
                            else np2_instNum_[4] = 1;
                        break;
                }
                break;
            case 8 :
                sCh1Off_ = !sCh1Off_;
                break;
            case 9 :
                sCh2Off_ = !sCh2Off_;
                break;
            case 10 :
                sCh3Off_ = !sCh3Off_;
                break;
            case 11 :
                sCh4Off_ = !sCh4Off_;
                break;
            case 12 :
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if (++sbuf_ > 60) sbuf_ = 0;
                        break;
                    case LEFT :
                        if (--sbuf_ < 0) sbuf_ = 60;
                        break;
                }
                break;
            default :
                //Ă΂Ȃ
                initApu_np2();
                break;
        }
        repaint();
    }

    private void selectMenuOtherSetting(final int i) {
        int select = selectSubMenuNo_ + 1;
        switch (select) {
            case 1 : // ްђ̷ٕ\
                showSoftLabel_ = !showSoftLabel_;
                writeSP();
                break;

            case 2 : // ްђ̿ķ
                switch (i) {
                    case SELECT :
                        wt_on_game_ += 100;
                        if (wt_on_game_ > 10000) wt_on_game_ = 0;
                        break;
                }
                writeSP();
                break;

            case 3 : // `گ̳
                switch (i) {
                    case SELECT :
                        wt_on_refresh_ += 100;
                        if (wt_on_refresh_ > 10000) wt_on_refresh_ = 0;
                        break;
                }
                writeSP();
                break;

            case 4 : // QVGAʂłVGAtHgkĎg
                use_vgafont_ = !use_vgafont_;
                infomsg("ċNKvł");
                writeSP();
                break;

            case 5 : // ʃ[h
                reverseEnable_ = !reverseEnable_;
                setFlipModeKey();
                refreshDisplay();
                writeSP();
                break;

            case 6 : // ƭ
                pointerEnable_ = !pointerEnable_;
                if (pointerEnable_) {
                    try {
                        if (PointingDevice.isAvailable() && pointerSense_ != 0) {
                            PointingDevice.setMode(PointingDevice.MODE_JOYSTICK);
                            PointingDevice.setEnabled(true);
                        }
                    } catch (Exception ex) {
                        alert("̋@\ƭ߲\nڋ@ł̂ݗLłB");
                    }
                } else {
                    if (svSubMenuPadNo > 6) svSubMenuPadNo = 0;
                    try {
                        if (PointingDevice.isAvailable()) {
                            PointingDevice.setEnabled(false);
                        }
                    } catch (Exception ex) {
                    }
                }
                writeSP();
                break;

            case 7 : // F̹
                rotateEnable_ = !rotateEnable_;
                setFlipModeKey();
                refreshDisplay();
                writeSP();
                break;

            case 8 : // V_CAO
                switch (i) {
                    case SELECT :
                    case RIGHT :
                        if (++dialogType_ > 2) dialogType_ = 0;
                        break;
                    case LEFT :
                        if (--dialogType_ < 0) dialogType_ = 2;
                        break;
                }
                writeSP();
                break;
            default :
                break;
        }
        repaint();
    }

    private void keyConfigSet(final int button) {
        // ݒ
        final int rbutton;
        // ㉺E̎̂ݍ׍HKvȂ{
        if (button != MY_KEY_SOFT1) {
            if (selectSubMenuNo_ >= 4 && selectSubMenuNo_ <= 7 && isReverse()) {
                if (button == MY_KEY_LEFT) {
                    rbutton = Display.KEY_LEFT;
                } else if (button == MY_KEY_UP) {
                    rbutton = Display.KEY_UP;
                } else if (button == MY_KEY_RIGHT) {
                    rbutton = Display.KEY_RIGHT;
                } else if (button == MY_KEY_DOWN) {
                    rbutton = Display.KEY_DOWN;
                } else {
                    rbutton = button;
                }
            } else {
                rbutton = button;
            }

            if (!keyconStr_[selectSubMenuNo_].startsWith(rbutton + ",")
                && (keyconStr_[selectSubMenuNo_].indexOf("," + rbutton + ",")
                    < 0)) {

                keyconStr_[selectSubMenuNo_] += rbutton + ",";
                keyStr2Vector(selectSubMenuNo_);
                writeSPkeys();

            } else {
                // o^ς݂̃L[ꂽo^
                if (keyconStr_[selectSubMenuNo_].startsWith(rbutton + ",")) {
                    // ŏ "," ȑÔĂ
                    int p = keyconStr_[selectSubMenuNo_].indexOf(",");
                    keyconStr_[selectSubMenuNo_] = keyconStr_[selectSubMenuNo_].substring(p + 1);
                } else {
                    // ^񒆂 ",rbutton" ̂Ă
                    int cp = keyconStr_[selectSubMenuNo_].indexOf("," + rbutton + ",");
                    if (cp < 0) {
                        alert("unknown error");
                        keyconStr_[selectSubMenuNo_] = "";
                    } else {
                        int pp = keyconStr_[selectSubMenuNo_].indexOf(",", cp + 1);
                        keyconStr_[selectSubMenuNo_] = keyconStr_[selectSubMenuNo_].substring(0, cp)
                            + keyconStr_[selectSubMenuNo_].substring(pp);
                    }
                }
                keyStr2Vector(selectSubMenuNo_);
                writeSPkeys();
            }
        }
        mode_ = MODE_MENU_KEYCON;
        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_KEYSET_STR);
        if (menuBGcolor_ >= 3) {
            messageStr = "(PAGE 1/2)";
        }
        repaint();
    }

    private void keyConfigSet2(final int button) {
        boolean input_ok = false;
        if (button != MY_KEY_SOFT1) {
            if (button != mickey_)
                input_ok = true;

            if (input_ok) {
                for (int i = 0; i < keyconStr_.length; i++) {
                    int idx = 0;
                    int pre = 0;
                    int ln = 0;
                    while ((idx = keyconStr_[i].indexOf(",", pre)) != -1) {
                        ln++;
                        if (ln > 5) break;
                        String key = keyconStr_[i].substring(pre, idx);
                        if (button == Integer.parseInt(key)) {
                            input_ok = false;
                            break;
                        }
                        pre = idx + 1;
                    }
                    if (!input_ok) break;
                }
            }

            if (input_ok) {
                if (selectSubMenuNo_ == 1) {
                    MY_KEY_SOFT1 = button;
                    keycon2_[1] = (byte)button;
                    //MY_KEY_SOFT1Ŕ悤ɂ̂ŕsvɂȂ
                    //    infomsg("Ƃ \"\" ɐݒ߂\n\"ݒر\" Ă");
                    //    bannerActive = false; // oi[\{_CAO\ɕKv
                } else if (selectSubMenuNo_ == 2) {
                    MY_KEY_SOFT2 = button;
                    keycon2_[2] = (byte)button;
                } else {
                    keycon2_[selectSubMenuNo_] = (byte)button;
                    keycon2_set = true;
                }
                writeSP();
            } else {
                alert("łɓo^ς݂̃L[ł");
            }
        }
        mode_ = MODE_MENU_KEYCON2;
        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_KEYSET_STR);
        if (menuBGcolor_ >= 3) {
            messageStr = "(PAGE 2/2)";
        }
        repaint();
    }

    private void setRightSoftkeyLabel() {
        switch (rSoftkey_) {
            case 0 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
                break;
            case 1 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_CHEAT_STR);
                break;
            case 2 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RESET_STR);
                break;
            case 3 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SOUND_STR[soundEnable]);
                break;
            case 5 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_DISK_STR);
                break;
            case 6 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROMSET_STR);
                break;
            case 7 :
                setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ZOOM_STR);
                break;
            case 8 :
                String dat = "";
                if(sdRomadj_[sdNo_] >= 0) dat = "+";
                dat += Float.toString((float)sdRomadj_[sdNo_] / 2);
                setSoftLabel(Frame.SOFT_KEY_2, dat);
                break;
            default :
                setSoftLabel(Frame.SOFT_KEY_2, null);
        }
        //Q[̃x\Ȃ
        //ŕ\ݒ肵΂肾EEE
        try {
            setSoftLabelVisible(showSoftLabel_);
        } catch (Exception ex) {}
    }

    private void createSdfiles(final int page) {
        //_~[SDt@C쐬
        int j = (page - 1) * NUM_SDROM + 1;
        SDbinding sd = new SDbinding();
        for(int i = j; i < j + NUM_SDROM; i++){
            sd.createFile(formatNumber(i, 3) + ".NES");
        }
    }

    private void createDisksysfiles() {
        //_~[BIOS쐬
        SDbinding sd = new SDbinding();
        sd.createFile("DISKSYS.ROM");
    }

    private void deleteSdfiles(final int page) {
        //_~[SDt@C폜
        int j = (page - 1) * NUM_SDROM + 1;
        SDbinding sd = new SDbinding();
        for(int i = j; i < j + NUM_SDROM; i++){
            sd.deleteFile(formatNumber(i, 3) + ".NES");
            sd.deleteFile("C" + formatNumber(i - 1, 3) + ".CHT");
            sd.deleteFile(formatNumber(i, 3) + ".DAT");
            writeSdromNameSP(i - 1, "");
            sdRomadj_[i - 1] = 0;
        }
        writeSPadjusts();
    }

    private void cheatReset() {
        // `[gf[^Zbg
        cheat_ = "";
        for (int i = 0; i < NUM_CHEAT; i++){
            chtSwitch_[i] = false;
            chtStr_[i] = "";
            chtS_[i] = 0;
            chtAdr_[i] = 0;
            chtK_[i] = 0;
            for (int j = 0; j < 4; j++) chtDat_[i][j] = 0x00;
        }
    }

    private void saveScreenShot() {
        //XN[Vbg
        Image ig = Image.createImage(256, 224);
        (ig.getGraphics()).setRGBPixels(0, 0, 256, 224, core.fb, 0);
        try{
            ImageEncoder ie = ImageEncoder.getEncoder("JPEG");
            ie.setAttribute(0, 0);
            EncodedImage ei = ie.encode(ig, 8, 0, 240, 224);
            MediaImage mi = ei.getImage();
            mi.use();
            ImageStore.addEntry(mi);
            mi.unuse();
            mi.dispose();
        }catch(Exception e){
            alert("err screenshot: " + e);
        }
    }

    private void save() {
        boolean rYes = true;
        if ((confirmMsg_ & 2) != 0)
            rYes = confirm("No." + (selectSubMenuNo_ + 1)
                + "\n"
                + saveStr_[selectSubMenuNo_]
                + "\nɃZ[u܂H");
        if (rYes) {
            messageStr = "f[^Z[u";
            setMessage(messageStr);
            writeSaveDate();
            core.request(NESCore.REQUEST_SAVE, selectSubMenuNo_ + 1);
            setRightSoftkeyLabel();
            svSubMenuSaveNo = selectSubMenuNo_;
            svSubMenuLoadNo = selectSubMenuNo_;
            messageStr = "";
            mode_ = MODE_GAME;
            //repaint();
        }
    }

    private void writeSaveDate() {
        // SaveAGameSPۑ
        Calendar cal = Calendar.getInstance();
        saveStr_[selectSubMenuNo_] = formatSpace(
            formatNumber(cal.get(Calendar.MONTH) + 1, 2)
                + "/"
                + formatNumber(cal.get(Calendar.DATE), 2)
                + " "
                + formatNumber(cal.get(Calendar.HOUR_OF_DAY), 2)
                + ":"
                + formatNumber(cal.get(Calendar.MINUTE), 2)
                + " "
                + curRom_, SIZE_SAVE_NAME);
        writeSPsaves(selectSubMenuNo_);
    }

    private int loadRom(boolean from_sp, int stop_mode) {
        int c = -1;
        setMessage("ROMt@Cǂݍݒ");
        SDbinding sd = null;
        InputStream is = null;
        cheatReset();
        resetFrame();
        frameSkip_ = svframeSkip_;
        aRen_ = 0;
        aHold_ = 0;
        bRen_ = 0;
        bHold_ = 0;
        con2p_ = 0;
        change_method = NESCore_NP2.UNKNOWN_RENDER;

        // NESCore̍ċN
        core.request(NESCore.REQUEST_STOP, stop_mode);
        core.init_apu(); //NP2
        while(core.exist);
        bootCore(core_);
        setSoundParms(); //NP2

        String fnm = formatNumber((page_ - 1) * NUM_SDROM + selectSubMenuNo_ + 1, 3) + ".NES";
        saveFile_ = formatNumber((page_ - 1) * NUM_SDROM + selectSubMenuNo_ + 1, 3) + ".DAT";
        adjust_cycle = (float)sdRomadj_[(page_ - 1) * NUM_SDROM + selectSubMenuNo_] / 2;
        adjust_dozencycle = sdRomadj_[(page_ - 1) * NUM_SDROM + selectSubMenuNo_] * 6;

        if(!from_sp) {
            sd = new SDbinding();
            is = sd.openInputStream(fnm);
        } else {
            is = openSPROMInputStream();
        }
        if (is != null){
            try {
                c = core.load_rom(is, from_sp);
            } catch (Exception e) {
                alert("err loadRom: " + e);
            } catch (Error err) {
                alert("err loadRomError: " + err);
                throw err;
            } finally {
                try{
                    is.close();
                } catch(Exception e){}
                is = null;
                if(sd!=null) sd.close();
                sd = null;
            }
        } else {
            if (confirm("ROMt@Cǂݍ߂܂B\n_~[t@Cč쐬܂H\n("
                    + sdPage_ + "y[W" + (sdPage_ * NUM_SDROM) + "t@C)")) {
                for (int i = 1; i <= sdPage_; i++) {
                    messageStr = "_~[t@C(y[W" + i + ")쐬";
                    repaint();
                    createSdfiles(i);
                    if(i == 1) createDisksysfiles();
                }
            }
            messageStr = "";
            repaint();
        }
        if (c == 0) {
            sdNo_ = (page_ - 1) * NUM_SDROM + selectSubMenuNo_;
            curRom_ = sdRomnm_[selectSubMenuNo_]; // JgROMۑ
            writeSP();
            System.gc();
            messageStr = "";
            setRightSoftkeyLabel();
            mode_ = MODE_GAME;
            c = core.reset();
            if(c == -1) {
                alert("DISKSYS.ROM ܂B");
            } else {
                core.start();
                core.request(NESCore.REQUEST_START, 0);
            }
            //repaint();
        } else {
            if (c == -1)
                alert("NESt@Cł͂܂B");
            else if (c == -2)
                alert("ROM̓T|[gĂ܂B");
            else if (c == -3)
                alert("}bp[T|[gĂ܂B");
            else if (c == -4)
                alert("DISKSYS.ROMt@Cǂݍ߂܂B");
        }
        return c;
    }

    private void exportGIF() {
        final byte[] GIF_FOOTER = { 0x00, 0x3B };

        SDbinding sd = null;
        DataInputStream in = null;
        try {
            // ScratchPadbyteǂݍ
            byte[] inData = new byte[SIZE_SAVE];
            if (mode_ == MODE_MENU_TOOLS) {
                // ݒf[^export
                in = openSPInputStream(0,
                        (SIZE_SP_SETTING
                         + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM));
            } else if(noRomCache_) {
                sd = new SDbinding();
                in = sd.openDataInputStream(getSaveFile(selectSubMenuNo_ + 1));
            } else {
                in = openSPSaveInputStream(selectSubMenuNo_ + 1);
            }
            if (in == null) {
                alert("t@CǍ݂Ɏs܂B");
                return;
            }
            in.read(inData);

            // ubN쐬
            int blocksSize = inData.length / EXPORT_BLOCK_SIZE;
            int lastBlockLength = inData.length % EXPORT_BLOCK_SIZE;
            boolean lastBlockExists = false;

            if (lastBlockLength != 0) {
                lastBlockExists = true;
            }
            int lastCnt = 0;
            if (lastBlockExists) {
                lastCnt = 1;
            }

            // o̓f[^
            byte[] outData =
                new byte[GIF_HEADER.length
                    + inData.length
                    + blocksSize
                    + lastCnt
                    + GIF_FOOTER.length];

            // GIFwb_
            System.arraycopy(GIF_HEADER, 0, outData, 0, GIF_HEADER.length);
            int outCnt = GIF_HEADER.length;

            // RgubNDataۑ
            int inCnt = 0;
            for (int i = 0; i < blocksSize; i++) {
                // ubNTCY
                outData[outCnt] = EXPORT_BLOCK_SIZE - 0x100;
                outCnt++;

                System.arraycopy(
                    inData,
                    inCnt,
                    outData,
                    outCnt,
                    EXPORT_BLOCK_SIZE);
                outCnt += EXPORT_BLOCK_SIZE;
                inCnt += EXPORT_BLOCK_SIZE;
            }

            // Ō̃ubN
            if (lastBlockExists) {
                outData[outCnt] = (byte) lastBlockLength;
                outCnt++;

                System.arraycopy(
                    inData,
                    inCnt,
                    outData,
                    outCnt,
                    lastBlockLength);
                outCnt += lastBlockLength;
                inCnt += lastBlockLength;
            }

            // GIFtb^
            System.arraycopy(GIF_FOOTER, 0, outData, outCnt, GIF_FOOTER.length);

            // GIFo
            //System.out.println("size:" + outData.length);
            //for (int i = 0; i < 100; i++) {
            //    System.out.print(Integer.toHexString(outData[i])  + ", ");
            //}
            //System.out.println("footer:");
            //for (int i = outData.length - 100; i < outData.length; i++) {
            //    System.out.print(Integer.toHexString(outData[i]) + ", ");
            //}

            MediaImage mediaImage = MediaManager.getImage(outData);
            mediaImage.use();
            ImageStore.addEntry(mediaImage);
            mediaImage.unuse();
            mediaImage.dispose();
        } catch (Exception e) {
            alert("err exportGIF: " + e);
        } finally {
            try{
                in.close();
            }catch(Exception e){}
            in = null;
            if(sd!=null) sd.close();
            sd = null;
        }
        //mode_ = MODE_MENU_ROOT;
        messageStr = "";
        repaint();
    }

    private void importGIF() {
        byte[] importData = new byte[SIZE_SAVE];
        int importedSize = 0;

        InputStream is = null;
        try {
            ImageStore istore = ImageStore.selectEntry();
            if (istore == null) {
                return;
            }
            is = istore.getInputStream();

            byte[] header = new byte[6];
            is.read(header);

            // GIF̂
            if (new String(header).equals("GIF89a")) {
                // RgubN܂skip
                is.skip(GIF_HEADER.length - 6);

                int length = is.available();
                //System.out.println("length:" + length);

                boolean last = false;
                while (!last) {
                    int size = is.read();
                    //System.out.println("size:" + size);
                    if (size != EXPORT_BLOCK_SIZE) {
                        last = true;
                    }

                    byte[] block = new byte[size];
                    is.read(block);
                    if (importedSize + size > importData.length) {
                        alert("length is over:" + length);
                        return;
                    }
                    System.arraycopy(block, 0, importData, importedSize, size);
                    importedSize += size;
                }
                // tb^͖B
            } else {
                alert("not GIF");
                return;
            }
        } catch (Exception e) {
            alert("err importGIF: " + e);
            return;
        } finally {
            try {
                is.close();
                is = null;
            } catch (Exception ex) {
                is = null;
            }
        }
        
        SDbinding sd = null;
        DataOutputStream out = null;
        try{
            if (mode_ == MODE_MENU_TOOLS) {
                // ݒf[^import
                out = openSPOutputStream(0,
                        (SIZE_SP_SETTING
                         + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM));
                out.write(importData, 0, SIZE_SP_SETTING
                        + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
                out.flush();
                // ݒf[^import͋u[g
                infomsg("ċN܂B");
                reboot();
            }

            if(noRomCache_) {
                sd = new SDbinding();
                out = sd.openDataOutputStream(getSaveFile(selectSubMenuNo_ + 1));
            } else {
                out = openSPSaveOutputStream(selectSubMenuNo_ + 1);
            }
            if (out == null) {
                alert("t@C݂Ɏs܂B");
            }
            out.write(importData, 0, importData.length);
            out.flush();

            writeSaveDate();
        } catch (Exception e) {
            alert("err importGIF: " + e);
        } finally {
            try{
                out.close();
            } catch(Exception e) {}
            out = null;
            if(sd!=null) sd.close();
            sd = null;
            closeSPSaveOutputStream(selectSubMenuNo_ + 1);
        }
        //mode_ = MODE_MENU_ROOT;
        messageStr = "";
        repaint();
    }

    public int getApuNum() {
        if(soundMode == 3)
            return 1;
        else if (soundMode < 3)
            return 2;
        else
            return 3;
    }

    private void initPcm() {

        soundVolume = 100;
        soundSampleRate = 0;
        soundBufCount = 15;
        soundApuFilter = 0;
        pcm_channelOff_[0] = false;
        pcm_channelOff_[1] = false;
        pcm_channelOff_[2] = false;
        pcm_channelOff_[3] = false;
        pcm_channelOff_[4] = false;
        pcm_channelOff_[5] = false;

        //soundEnable = 1;
    }

    private void initApu() {

        soundVolume = 100;
        sound_ = 0;
        instNum_[0] = 24;
        instNum_[1] = 24;
        instNum_[2] = 24;
        instNum_[3] = 48;
        channelOff_[0] = false;
        channelOff_[1] = false;
        channelOff_[2] = false;
        channelOff_[3] = false;

        //soundEnable = 1;
    }

    private void initApu_np2() {
        np2_sound_ = PSGi.MODE_PRESET;
        np2_instNum_[0] = 80;
        np2_instNum_[1] = 80;
        np2_instNum_[2] = 80;
        np2_instNum_[3] = 80;
        np2_instNum_[4] = 127;
        sCh1Off_ = false;
        sCh2Off_ = false;
        sCh3Off_ = false;
        sCh4Off_ = false;
        //soundVolume = 100;
        sbuf_ = 16;
    }

    // NP2I[fBI
    private void setSoundParms() {
        if (soundEnable > 0)
            psgi.setSoundEnable(true);
        else
            psgi.setSoundEnable(false);
        psgi.setMode(np2_sound_);
        psgi.setMasterVolume(soundVolume);
        psgi.setFrameBufCount(sbuf_);
        psgi.setChEnable(0, !sCh1Off_);
        psgi.setChEnable(1, !sCh2Off_);
        psgi.setChEnable(2, !sCh3Off_);
        psgi.setChEnable(3, !sCh4Off_);

        if(np2_sound_ == PSGi.MODE_PRESET)
            for(int i=0; i<5 ; i++)
                psgi.setToneBank(i, this.np2_instNum_[i]);
        else 
            for(int i=0; i<5 ; i++) 
                psgi.setToneBank(i, i);
    }

    private void readSP() {
        DataInputStream in = null;
        DataOutputStream out = null;
        try {
            in = openSPInputStream(0, SIZE_SP_OTHERS);

            // VERSION擾
            int version = in.readInt();
            //NtO
            firstExec_ = in.readBoolean();

            boolean moveOld = false;
            //o[WAbvmF
            String eXstr = "";
            if (version == 500) {
                in.close();
                in = null;

                infomsg("o[WAbvFۑݒf[^(ꕔ)ڍs܂B");

                //SP̃f[^ǂݍ
                readSP_500();
                readSPkeys_500();
                readSPsaves_500();
                readSPadjusts_500();

                //ROM̓ǂݍ
                for (int i=0; i<sdPage_; i++){
                    readSdromNameSP_500(i + 1);
                    for(int j=0; j<NUM_SDROM; j++)
                        eXstr = eXstr + sdRomnm_[j].trim() + "\n";
                }
                moveOld = true;
            } else if (version == 501) {
                in.close();
                in = null;

                infomsg("o[WAbvFۑݒf[^(ꕔ)ڍs܂B");

                //SP̃f[^ǂݍ
                readSP_501();
                readSPkeys_501();
                readSPsaves_501();
                readSPadjusts_501();

                //ROM̓ǂݍ
                for (int i=0; i<sdPage_; i++){
                    readSdromNameSP_501(i + 1);
                    for(int j=0; j<NUM_SDROM; j++)
                        eXstr = eXstr + sdRomnm_[j].trim() + "\n";
                }
                moveOld = true;
            } else if (version != VERSION) {
                //m̃o[W
                in.close();
                in = null;

                out = openSPOutputStream(0, SIZE_SP_SETTING);

                byte[] noData = new byte[SIZE_SP_SETTING];
                for (int i = 0; i < noData.length; i++) {
                    noData[i] = 0;
                }
                out.write(noData);
                out.flush();
                out.close();

                out = openSPOutputStream(0, 5);
                out.writeInt(VERSION);
                out.writeBoolean(firstExec_);
                out.flush();
                out.close();

                in = openSPInputStream(0, SIZE_SP_OTHERS);
                version = in.readInt();
                firstExec_ = in.readBoolean();
            }

            if (moveOld) {
                //SP
                out = openSPOutputStream(0, SIZE_SP_SETTING);

                byte[] noData = new byte[SIZE_SP_SETTING];
                for (int i = 0; i < noData.length; i++) {
                    noData[i] = 0;
                }
                out.write(noData);
                out.flush();
                out.close();

                //ď
                writeSP();
                writeSPkeys();
                // Ō1SP̃Z[uf[^BjĂ܂ߖOcȂ
                for (int i = 0; i < NUM_SAVE - 1; i++)
                    writeSPsaves(i);
                writeSPadjusts();

                //ROM̏
                String[] romnm = split(eXstr, '\n', MAX_SDROM_PAGE * NUM_SDROM);
                out = openSPOutputStream(
                        SIZE_SP_SETTING,
                        SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
                for (int i=0; i<romnm.length; i++) {
                    if (i > NUM_SDROM * sdPage_ - 1) break;
                    out.write(formatSpace(romnm[i], SIZE_ROM_NAME).getBytes());
                }
                out.flush();
                out.close();

                in = openSPInputStream(0, SIZE_SP_OTHERS);
                version = in.readInt();
                firstExec_ = in.readBoolean();
            }
            // FSAFPS\
            frameSkip_ = in.readInt();
            fpsOff_ = in.readBoolean();
            // NROMǂݍ
            startAndLoad_ = in.readBoolean();
            // ʉ]
            flipMode_ = in.readInt();
            // mFbZ[W
            confirmMsg_ = in.readInt();
            if ((confirmMsg_ & 0xC0) == 0) confirmMsg_ = 0xFE;
            // OSDROMԍ
            sdNo_ = in.readInt();
            // SDt@Cy[W
            sdPage_ = in.readInt();
            // j[
            alpha_ = in.readBoolean();
            // }CNL[ݒ
            mickey_ = in.readInt();
            if (mickey_ == 0) {
                // lʂ̂߁{PŕۑĂBݒȂO
                mickey_ = 11;
            }else{
                --mickey_;
            }
            // x(60FPS)
            sleep_ = in.readInt();
            // Eķ@\
            rSoftkey_ = in.readInt();
            if(rSoftkey_ > 8) rSoftkey_ = 8;
            if (rSoftkey_ == 4) {
                skeyMask_ = 0xFFFFFFFF;
            } else {
                skeyMask_ = 0xFFBFFFFF;
            }
            // j[wiF
            menuBGcolor_ = in.readInt();
            // TEho
            soundEnable = in.readInt();
            if (soundEnable > 1) soundEnable = 1;
            // TEhF
            sound_ = in.readInt();
            // TEhʒl
            soundVolume = in.readInt();
            if (soundVolume < 10) soundVolume = 100;
            // TEhChIt
            channelOff_[0] = in.readBoolean();
            channelOff_[1] = in.readBoolean();
            channelOff_[2] = in.readBoolean();
            channelOff_[3] = in.readBoolean();

            pcm_channelOff_[0] = in.readBoolean();
            pcm_channelOff_[1] = in.readBoolean();
            pcm_channelOff_[2] = in.readBoolean();
            pcm_channelOff_[3] = in.readBoolean();
            pcm_channelOff_[4] = in.readBoolean();
            pcm_channelOff_[5] = in.readBoolean();
            // TEhJX^Fԍ
            instNum_[0] = in.readInt();
            if (instNum_[0] == 0) instNum_[0] = 24;
            instNum_[1] = in.readInt();
            if (instNum_[1] == 0) instNum_[1] = 24;
            instNum_[2] = in.readInt();
            if (instNum_[2] == 0) instNum_[2] = 24;
            instNum_[3] = in.readInt();
            if (instNum_[3] == 0) instNum_[3] = 48;
            
            soundMode = in.readInt();
            soundSampleRate = in.readInt();
            soundBufCount = in.readInt();
                if (soundBufCount == 0) soundBufCount = 15;
            soundApuFilter = in.readInt();
            
            // ȉNP2I[fBI
            // TEhF
            np2_sound_ = in.readInt();
            if(np2_sound_ < PSGi.MODE_PRESET || np2_sound_ > PSGi.MODE_ROHM)
                np2_sound_ = PSGi.MODE_PRESET;
            // TEhChIt
            sCh1Off_ = in.readBoolean();
            sCh2Off_ = in.readBoolean();
            sCh3Off_ = in.readBoolean();
            sCh4Off_ = in.readBoolean();
            // TEhJX^Fԍ
            np2_instNum_[0] = in.readInt();
            if (np2_instNum_[0] == 0) np2_instNum_[0] = 80;
            np2_instNum_[1] = in.readInt();
            if (np2_instNum_[1] == 0) np2_instNum_[1] = 80;
            np2_instNum_[2] = in.readInt();
            if (np2_instNum_[2] == 0) np2_instNum_[2] = 80;
            np2_instNum_[3] = in.readInt();
            if (np2_instNum_[3] == 0) np2_instNum_[3] = 80;
            np2_instNum_[4] = in.readInt();
            if (np2_instNum_[4] == 0) np2_instNum_[4] = 127;
            sbuf_ = in.readInt();
            if (sbuf_ < 1 || sbuf_ > 60) sbuf_ = 16;

            // RAI
            core_ = in.readInt();

            // `惂[h
            zoom_ = in.readInt();
            svZoom_ = in.readInt();
            fpsDisp_ = in.readInt();
            if (fpsDisp_ == 3) fpsOff_ = true;
            else fpsOff_ = false;
            pos_x[0] = in.readInt();
            pos_y[0] = in.readInt();

            // ROMSP
            noRomCache_ = in.readBoolean();
            compressMode_ = in.readInt();
            noCompress_ = in.readBoolean();

            // ̑
            showSoftLabel_ = in.readBoolean();
            wt_on_game_ = in.readInt();
            if (wt_on_game_ < 0) wt_on_game_ = 0;
            else if (wt_on_game_ > 10000) wt_on_game_ = 10000;
            wt_on_refresh_ = in.readInt();
            if (wt_on_refresh_ < 0) wt_on_refresh_ = 0;
            else if (wt_on_refresh_ > 10000) wt_on_refresh_ = 10000;
            use_vgafont_ = in.readBoolean();
            reverseEnable_ = in.readBoolean();
            rotateEnable_ = in.readBoolean();

            // ƭۗp
            pointerEnable_ = in.readBoolean();
            pointerSense_ = in.readByte();
            pointerType_ = in.readBoolean();

            // L[ݒ2ʖ
            keycon2_[1] = in.readByte();
            keycon2_[2] = in.readByte();
            keycon2_[3] = in.readByte();
            keycon2_[4] = in.readByte();
            keycon2_[5] = in.readByte();
            keycon2_[6] = in.readByte();
            keycon2_[7] = in.readByte();
            keycon2_[8] = in.readByte();
            keycon2_[9] = in.readByte();
            keycon2_[10] = in.readByte();
            byte dummy = in.readByte(); // keycon2_[11]Ɋgp

            // ̑(̂Q)
            // V_CAO
            dialogType_ = in.readInt() + 1;

            /////////////////////////////
            // ftHglݒ
            /////////////////////////////

            // 0ɂȂ̂ŃftHgl5ɂB
            if (frameSkip_ == 0) {
                frameSkip_ = 5;
            }
            svframeSkip_ = frameSkip_;

            // 1ZĎgpB-1 疢ݒ
            for (int i = 3; i < keycon2_.length; i++) {
                keycon2_[i]--;
                if (keycon2_[i] >= 0) keycon2_set = true;
            }
            keycon2_[1]--;
            if (keycon2_[1] < 0) {
                MY_KEY_SOFT1 = Display.KEY_SOFT1;
                keycon2_[1] = (byte)Display.KEY_SOFT1;
            } else {
                MY_KEY_SOFT1 = (int)keycon2_[1];
            }
            keycon2_[2]--;
            if (keycon2_[2] < 0) {
                MY_KEY_SOFT2 = Display.KEY_SOFT2;
                keycon2_[2] = (byte)Display.KEY_SOFT2;
            } else {
                MY_KEY_SOFT2 = (int)keycon2_[2];
            }

            // t[̏TCY
            if (pos_x[0] < 0) pos_x[0] = 100;
            if (pos_y[0] < 0) pos_y[0] = 100;
            pos_x[1] = (pos_x[0] >> 16) & 0xFFFF;
            pos_y[1] = (pos_y[0] >> 16) & 0xFFFF;
            pos_x[0] &= 0xFFFF;
            pos_y[0] &= 0xFFFF;


        } catch (Exception e) {
            alert("err readSP: " + e);
        } finally {
            try {
                in.close();
                in = null;
                out.close();
                out = null;
            } catch (Exception ex) {
                in = null;
                out = null;
            }
        }

    }

    private void readSPkeys() {
        // keyconfig
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    SIZE_SP_OTHERS,
                    SIZE_SP_KEYS);

            byte[] key = new byte[20];
            for (int i = 0; i < keyconStr_.length; i++) {
                in.read(key);
                if (key[0] == 0) {
                    keyconStr_[i] = "";
                } else {
                    keyconStr_[i] = new String(key).trim();
                }
                keyStr2Vector(i);
            }
            // ͋œĂ̂ŏ
            if (keyconStr_[0].equals("")) {
                keyconStr_ =
                    new String[] {
                        Display.KEY_3 + "," + Display.KEY_SELECT + ",",
                        Display.KEY_2 + "," + Display.KEY_SOFT2 + ",",
                        Display.KEY_5 + ",",
                        Display.KEY_6 + ",",
                        Display.KEY_UP + ",",
                        Display.KEY_DOWN + ",",
                        Display.KEY_LEFT + ",",
                        Display.KEY_RIGHT + ",",
                        Display.KEY_0 + ",",
                        Display.KEY_8 + ",",
                        Display.KEY_1 + ",",
                        Display.KEY_4 + ",",
                        };

                for (int i = 0; i < keyConfig_.length; i++) {
                    keyStr2Vector(i);
                }
                in.close();
                writeSPkeys();
            }
        } catch (Exception e) {
            alert("err readSPkeys: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPsaves() {
        // Z[u
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS + SIZE_SP_KEYS),
                    SIZE_SP_SAVES);
            byte[] save = new byte[SIZE_SAVE_NAME];
            for (int i = 0; i < NUM_SAVE; i++) {
                in.read(save);
                if (save[0] == 0) {
                    saveStr_[i] = "";
                } else {
                    saveStr_[i] = new String(save);
                }
            }
        } catch (Exception e) {
            alert("err readSPsaves: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPadjusts() {
        // Z[u
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SP_SAVES),
                    SIZE_SP_ADJUST);
            byte[] data = new byte[SIZE_SP_ADJUST];
            in.read(data);
            for(int i = 0, pos = 0; i < (NUM_SDROM * MAX_SDROM_PAGE); i++, pos++) {
                if((pos % 2) == 0) {
                    sdRomadj_[i] = (int)((data[pos >> 1] >> 4) & 0xF) - 8;
                } else {
                    sdRomadj_[i] = (int)((data[pos >> 1]) & 0xF) - 8;
                }
                if(sdRomadj_[i] < -5 || sdRomadj_[i] > 5) sdRomadj_[i] = 0;
            }
        } catch (Exception e) {
            alert("err readSPsaves: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }

    private void readSdromNameSP(final int page) {
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_SETTING + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1)),
                    SIZE_ROM_NAME * NUM_SDROM);
            byte[] name = new byte[SIZE_ROM_NAME];
            for (int i = 0; i < NUM_SDROM; i++) {
                in.read(name);
                if (name[0] == 0) {
                    sdRomnm_[i] = "";
                } else {
                    sdRomnm_[i] = new String(name);
                }
            }
        } catch (Exception e) {
            alert("err readSdromNameSP: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }

    private void writeSP() {
        DataOutputStream out = null;
        try {
            out = openSPOutputStream(0, SIZE_SP_OTHERS);
            // VERSIONF4byte
            out.writeInt(VERSION);
            // NtO
            out.writeBoolean(firstExec_);
            // FSF4byte
            out.writeInt(svframeSkip_);
            // FPS\F1byte
            out.writeBoolean(fpsOff_);
            // NROMǂݍ
            out.writeBoolean(startAndLoad_);
            // ʉ]
            out.writeInt(flipMode_);
            // mFbZ[W
            out.writeInt(confirmMsg_);
            // OSDROMԍ
            out.writeInt(sdNo_);
            // SDt@Cy[W
            out.writeInt(sdPage_);
            // j[
            out.writeBoolean(alpha_);
            // }CNL[ݒ
            out.writeInt(mickey_ + 1);
            // x(60FPS)F4byte
            out.writeInt(sleep_);
            // Eķ@\F4byte
            out.writeInt(rSoftkey_);
            // j[wiF
            out.writeInt(menuBGcolor_);
            // TEho
            out.writeInt(soundEnable);
            // TEhF
            out.writeInt(sound_);
            // TEhʒl
            out.writeInt(soundVolume);
            // TEhChIt
            out.writeBoolean(channelOff_[0]);
            out.writeBoolean(channelOff_[1]);
            out.writeBoolean(channelOff_[2]);
            out.writeBoolean(channelOff_[3]);

            out.writeBoolean(pcm_channelOff_[0]);
            out.writeBoolean(pcm_channelOff_[1]);
            out.writeBoolean(pcm_channelOff_[2]);
            out.writeBoolean(pcm_channelOff_[3]);
            out.writeBoolean(pcm_channelOff_[4]);
            out.writeBoolean(pcm_channelOff_[5]);
            // TEhJX^Fԍ
            out.writeInt(instNum_[0]);
            out.writeInt(instNum_[1]);
            out.writeInt(instNum_[2]);
            out.writeInt(instNum_[3]);
            
            out.writeInt(soundMode);
            out.writeInt(soundSampleRate);
            out.writeInt(soundBufCount);
            out.writeInt(soundApuFilter);

            // ȉNP2I[fBI
            // TEhF
            out.writeInt(np2_sound_);
            // TEhChIt
            out.writeBoolean(sCh1Off_);
            out.writeBoolean(sCh2Off_);
            out.writeBoolean(sCh3Off_);
            out.writeBoolean(sCh4Off_);
            // TEhJX^Fԍ
            out.writeInt(np2_instNum_[0]);
            out.writeInt(np2_instNum_[1]);
            out.writeInt(np2_instNum_[2]);
            out.writeInt(np2_instNum_[3]);
            out.writeInt(np2_instNum_[4]);
            // TEhobt@
            out.writeInt(sbuf_);

            // RAI
            out.writeInt(core_); 

            // `̈
            out.writeInt(zoom_);
            out.writeInt(svZoom_);

            out.writeInt(fpsDisp_);
            int pos_x3, pos_y3;
            if (svPos_x4 != 0)
                pos_x3 = (svPos_x4 << 16) | (pos_x[0] & 0xFFFF);
            else
                pos_x3 = (pos_x[1] << 16) | (pos_x[0] & 0xFFFF);
            if (svPos_y4 != 0)
                pos_y3 = (svPos_y4 << 16) | (pos_y[0] & 0xFFFF);
            else
                pos_y3 = (pos_y[1] << 16) | (pos_y[0] & 0xFFFF);
            if (pos_x3 == 100) out.writeInt(-1);
            else out.writeInt(pos_x3);
            if (pos_y3 == 100) out.writeInt(-1);
            else out.writeInt(pos_y3);

            // ROMSP
            out.writeBoolean(noRomCache_);
            out.writeInt(compressMode_);
            out.writeBoolean(noCompress_);

            // ̑
            out.writeBoolean(showSoftLabel_);
            out.writeInt(wt_on_game_);
            out.writeInt(wt_on_refresh_);
            out.writeBoolean(use_vgafont_);
            out.writeBoolean(reverseEnable_);
            out.writeBoolean(rotateEnable_);

            // ƭۗp
            out.writeBoolean(pointerEnable_);
            out.writeByte(pointerSense_);
            out.writeBoolean(pointerType_);

            // L[ݒ2ʖ(1Zۑ)
            out.writeByte(keycon2_[1] + 1);
            out.writeByte(keycon2_[2] + 1);
            out.writeByte(keycon2_[3] + 1);
            out.writeByte(keycon2_[4] + 1);
            out.writeByte(keycon2_[5] + 1);
            out.writeByte(keycon2_[6] + 1);
            out.writeByte(keycon2_[7] + 1);
            out.writeByte(keycon2_[8] + 1);
            out.writeByte(keycon2_[9] + 1);
            out.writeByte(keycon2_[10] + 1);
            out.writeByte(0); // keycon2_[11]Ɋgp

            // ̑(̂Q) - tH[}bgύXɈړ
            // V_CAO(1Zۑ
            out.writeInt(dialogType_ - 1);

            out.flush();

            /*
             * [Wv]
             *  int x 44     = 176(byte)
             *  boolean x 22 =  22(byte)
             *  byte x 12    =  12(byte)
             *              v 210(byte)
             */
        } catch (Exception e) {
            alert("err writeSP: " + e);
        } finally {
            try {
                out.close();
                out = null;
            } catch (Exception ex) {
                out = null;
            }
        }
    }

    private void writeSPkeys() {
        // keyconfigF20byte ~ 12 = 240
        DataOutputStream out = null;
        try {
            out = openSPOutputStream(
                    SIZE_SP_OTHERS,
                    SIZE_SP_KEYS);
            for (int i = 0; i < keyconStr_.length; i++) {
                out.write(formatSpace(keyconStr_[i], 20).getBytes());
            }
            out.flush();
        } catch (Exception e) {
            alert("err writeSPkeys: " + e);
        } finally {
            try {
                out.close();
                out = null;
            } catch (Exception ex) {
                out = null;
            }
        }
    }

    private void writeSPsaves(final int sno) {
        // Z[u
        DataOutputStream out = null;
        try {
            out = openSPOutputStream(
                    (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SAVE_NAME * sno),
                    SIZE_SAVE_NAME);
            byte[] data = formatSpace(saveStr_[sno], SIZE_SAVE_NAME).getBytes();
            out.write(data);
            out.flush();
        } catch (Exception e) {
            alert("err writeSPsaves: " + e);
        } finally {
            try {
                out.close();
                out = null;
            } catch (Exception ex) {
                out = null;
            }
        }
    }

    private void writeSPadjusts() {
        // Z[u
        DataOutputStream out = null;
        try {
            out = openSPOutputStream(
                    (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SP_SAVES),
                    SIZE_SP_ADJUST);
            byte[] data = new byte[SIZE_SP_ADJUST];
            for(int i = 0, pos = 0; i < SIZE_SP_ADJUST; i++) {
                data[i] = (byte)((((sdRomadj_[pos++] + 8) & 0xF) << 4) | ((sdRomadj_[pos++] + 8) & 0xF));
            }
            out.write(data);
            out.flush();
        } catch (Exception e) {
            alert("err writeSPsaves: " + e);
        } finally {
            try {
                out.close();
                out = null;
            } catch (Exception ex) {
                out = null;
            }
        }
    }

    private void writeSdromNameSP(final int sdno, final String romnm) {
        // SDRomF30
        DataOutputStream out = null;
        try {
            out = openSPOutputStream(
                    (SIZE_SP_SETTING + SIZE_ROM_NAME * sdno),
                    SIZE_ROM_NAME);
            out.write(formatSpace(romnm, SIZE_ROM_NAME).getBytes());
            out.flush();
        } catch (Exception e) {
            alert("err writeSdromNameSP: " + e);
        } finally {
            try {
                out.close();
                out = null;
            } catch (Exception ex) {
                out = null;
            }
        }
    }

    private void selectMenuSelectCore() {
        int select = selectSubMenuNo_ + 1;
        String s = "";
        switch (select) {
            case 1 : // IWi
                svSubMenuSettingNo = selectSubMenuNo_;
                mode_ = MODE_MENU_ROOT;
                core_ = CORE_ORIGINAL;
                s = "IWiRA";
                break;

            case 2 : // \tgoNRA
                svSubMenuSettingNo = selectSubMenuNo_;
                mode_ = MODE_MENU_ROOT;
                core_ = CORE_SOFTBANK;
                s = "\tgoNRA";
                break;

            case 3 : // NemulatorPlus2RA
                svSubMenuSettingNo = selectSubMenuNo_;
                mode_ = MODE_MENU_ROOT;
                core_ = CORE_NEMUPLUS2;
                s = "NemulatorPlus2RA(Beta)";
                break;

            default :
                break;
        }
        while (getKeypadState() != 0){
            try {
                Thread.sleep(10L);
            } catch (Exception ex) {}
        }
        writeSP();
        infomsg(s + "ɐݒ肵܂BROMēǂݍ݂ĂB");
        //Dialog dialog = new Dialog(Dialog.DIALOG_INFO, "mF");
        //dialog.setText(s + "ɐݒ肵܂BROMēǂݍ݂ĂB");
        //dialog.show();
        setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
        repaint();
    }

    /////////////////////////////////
    // SP
    /////////////////////////////////
    public final DataInputStream openSPInputStream(final int pos, final int length)
            throws ConnectionException, IOException{
        DataInputStream in = null;
        boolean ok = false;
        while (!ok) {
            try {
                in = Connector.openDataInputStream(
                    "scratchpad:///0;pos=" + pos + ",length=" + length);
                ok = true;
            } catch (ConnectionException e) {
                // SPĂ0.5b҂ăgC
                if (e.getStatus() == ConnectionException.BUSY_RESOURCE) {
                    try {
                        Thread.sleep(500L);
                    } catch (Exception ex) {}
                } else {
                    throw e;
                }
            } catch (IOException e) {
                throw e;
            }
        }
        return in;
    }

    public final DataOutputStream openSPOutputStream(final int pos, final int length)
            throws ConnectionException, IOException{
        DataOutputStream out = null;
        boolean ok = false;
        while (!ok) {
            try {
                out = Connector.openDataOutputStream(
                    "scratchpad:///0;pos=" + pos + ",length=" + length);
                ok = true;
            } catch (ConnectionException e) {
                // SPĂ0.5b҂ăgC
                if (e.getStatus() == ConnectionException.BUSY_RESOURCE) {
                    try {
                        Thread.sleep(500L);
                    } catch (Exception ex) {}
                } else {
                    throw e;
                }
            } catch (IOException e) {
                throw e;
            }
        }
        return out;
    }

    /////////////////////////////////
    // ROMLbV
    /////////////////////////////////
    public int writeSPBIOS(final byte[] bios) {
        int ret = romcache.writeSPBIOS(bios);
        if (!noRomCache_) romcacheCheck();
        return ret;
    }

    public int writeSPSRAM(final byte[] sram) {
        int ret = romcache.writeSPSRAM(sram);
        if (!noRomCache_) romcacheCheck();
        return ret;
    }

    public int writeSPROM(int rom_size, int vrom_size, int b6, int b7, byte[][] rom, byte[][] vrom) {
        int ret = romcache.writeSPROM(rom_size, vrom_size, b6, b7, rom, vrom);
        if (!noRomCache_) romcacheCheck();
        return ret;
    }

    public int writeSPFD(int disk_banks, byte[][] disk) {
        int ret = romcache.writeSPFD(disk_banks, disk);
        if (!noRomCache_) romcacheCheck();
        return ret;
    }

    public DataInputStream openSPBIOSInputStream() {
        return romcache.openSPBIOSInputStream();
    }

    public DataInputStream openSPSRAMInputStream() {
        return romcache.openSPSRAMInputStream();
    }

    public DataInputStream openSPROMInputStream() {
        return romcache.openSPROMInputStream();
    }

    public DataInputStream openSPSaveInputStream(int slot) {
        return romcache.openSPSaveInputStream(slot);
    }
    
    public DataOutputStream openSPSaveOutputStream(int slot) {
        return romcache.openSPSaveOutputStream(slot, sdNo_);
    }
    
    public void closeSPSaveOutputStream(int slot) {
        romcache.closeSPSaveOutputStream(slot);
        noRomCache_ = romcache.enableRomCache(!noRomCache_);
        if (noRomCache_) {
            core.set_spmode(!noRomCache_);
            writeSP();
            alert("G[SP̓ǏUƂȂ܂B\n"
                + "(eʕs̏ꍇ́AU NemulatorPlus ċNĂA"
                + "œKsȂǂċ󂫗eʂ邩Ă݂ĂB)");
            dialogNotReady = true;
            if (confirm("SP̾ްSD\n߰܂H\n"
                    + "(SP̾ް͍폜܂)")) {
                messageStr = "SP(XNb`pbh)ɕۑĂZ[uf[^SDɃRs[Ă܂B";
                romcache.onMoving = true;
                boolean ret = romcache.cache2sd(0);
                while(romcache.onMoving);
                infomsg("SPSDւ\n߰܂B"
                    + (ret ? "()" : "(s)"));
            }
        }
    }

    private void romcacheCheck() {
        noRomCache_ = romcache.enableRomCache(!noRomCache_);
        if (noRomCache_) {
            core.set_spmode(!noRomCache_);
            writeSP();
            alert("G[ROMUƂȂ܂B\n"
                + "(eʕs̏ꍇ́AU NemulatorPlus ċNĂA"
                + "œKsȂǂċ󂫗eʂ邩Ă݂ĂB)");
        }
    
    }

    /////////////////////////////////
    // Utility Method
    /////////////////////////////////
    // _CAOp̃{^
    private void dialogButton(String s, int x, int y, boolean select, boolean press) {
        Graphics g = menuG;
        int rx = 6*scale;
        int ry = 7*scale;
        int w = 40*scale;
        rx = 3*scale;
        ry = 6*scale;

        //Og
        int d=2*scale;
        if (select) {
            g.setColor(g.getColorOfRGB(180,60,60));
        } else if (press) {
            if (dialogType_ == 2) {
                g.setColor(g.getColorOfRGB(60,60,60));
            } else {
                g.setColor(g.getColorOfRGB(180,180,180));
            }
        } else {
            g.setColor(g.getColorOfRGB(120,120,120));
        }
        g.fillArc(x-d, y-d, (rx+d)*2, (ry+d)*2, 90, 180);
        g.fillRect(x + rx, y-d, w, (ry+d)*2);
        g.fillArc(x-d + w, y-d, (rx+d)*2, (ry+d)*2, 270, 180);
    
        //g㔼
        if (dialogType_ == 2) {
            if (press) {
                g.setColor(g.getColorOfRGB(60,60,60));
            } else {
                g.setColor(g.getColorOfRGB(90,90,90));
            }
        } else {
            if (press) {
                g.setColor(g.getColorOfRGB(180,180,180));
            } else {
                g.setColor(g.getColorOfRGB(210,210,210));
            }
        }
        g.fillArc(x, y, rx*2, ry*2, 90, 90);
        g.fillRect(x + rx, y, w, ry);
        g.fillArc(x + w, y, rx*2, ry*2, 0, 90);
    
        //g
        if (dialogType_ == 2) {
            if (press) {
                g.setColor(g.getColorOfRGB(90,90,90));
            } else {
                g.setColor(g.getColorOfRGB(60,60,60));
            }
        } else {
            if (press) {
                g.setColor(g.getColorOfRGB(210,210,210));
            } else {
                g.setColor(g.getColorOfRGB(180,180,180));
            }
        }
        g.fillArc(x, y, rx*2, ry*2, 180, 90);
        g.fillRect(x + rx, y+ry, w, ry);
        g.fillArc(x + w, y, rx*2, ry*2, 270, 90);
    
        //
        if (dialogType_ == 2) {
            //炵ĉet
            g.setColor(g.getColorOfRGB(60,60,60));
            g.drawString(s,
                    x + rx + (w - MENU_DEFAULT_FONT.stringWidth(s))/2 + 1*scale,
                    y + DIALOG_BASE_LINE - 1*scale);
            g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        } else {
            g.setColor(g.getColorOfRGB(60,60,60));
        }
        g.drawString(s,
                x + rx + (w - MENU_DEFAULT_FONT.stringWidth(s))/2,
                y + DIALOG_BASE_LINE - 1*scale);
    }

    private void myDialog(String msg, String title, int titlecolor, String button1, String button2, int maxWidth) {
        Graphics g = menuG;
        int i;

        // EBhEŏ
        int mw;
        if (button2 != "") {
            mw = 150*scale;
        } else {
            mw = 120*scale;
        }
        // {^
        int bw = 46*scale;
        
        // EBhE
        int w = maxWidth - 8*scale*2;
        
        //1sPʂɕbZ[W
        String[] ns = splitString(msg, "\n", w - 8*scale*2);
        // ߂
        int dm = 0;
        w = 0;
        for (i = 0; i < ns.length; i++) {
            int tmp = MENU_DEFAULT_FONT.stringWidth(ns[i]) + 2*8*scale;
            if (w < tmp) w = tmp;
        }
        if (w < mw) {
            dm = (mw - w) / 2;
            w = mw;
        }
        
        // EBhEAʒu
        int h = DIALOG_HEIGHT_LINE * (1 + ns.length + 2) + 8*scale;
        int x = (maxWidth - w) / 2;
        int y = (MENU_HEIGHT - h) / 2;

        
        // Og̃hbgʒu(CRp)
        int[] x1={x,x+2,x+w-2,x+w,x+w,x+w-2,x+2,x,x};
        int[] y1={y+2,y,y,y+2,y+h-2,y+h,y+h,y+h-2,y+2};
        int[] x2={x-1,x+2,x+w-2,x+w+1,x+w+1,x+w-2,x+2,x-1,x-1};
        int[] y2={y+2,y-1,y-1,y+2,y+h-2,y+h+1,y+h+1,y+h-2,y+2};

        // ߐF΍Ń{^ȊO͂Px`悵Ȃ
        if (!dialogShowed) {
            //lp
            g.setColor(titlecolor);
            g.fillRect(x, y, w, DIALOG_HEIGHT_LINE + 2*scale);
            if (dialogType_ == 2) {
                //ÂFœhԂ
                g.setColor(Graphics.getColorOfRGB(0,0,0,0x80));
                g.fillRect(x + 1*scale, y + 1*scale, w - 2*scale, DIALOG_HEIGHT_LINE + 1*scale);
            }

            //^Cg
            if (dialogType_ == 2) {
                //炵ĉet
                g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                g.drawString(title,
                        x + (w - MENU_DEFAULT_FONT.stringWidth(title))/2 + 1*scale,
                        y + DIALOG_BASE_LINE + 1*scale);
                g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            } else {
                g.setColor(Graphics.getColorOfName(Graphics.BLACK));
            }
            g.drawString(title,
                    x + (w - MENU_DEFAULT_FONT.stringWidth(title))/2,
                    y + DIALOG_BASE_LINE + 1*scale);

            //lp
            g.setColor(g.getColorOfRGB(255,255,255,0xE8));
            g.fillRect(x, y + DIALOG_HEIGHT_LINE + 2*scale, w, h - DIALOG_HEIGHT_LINE - 2*scale);
            if (dialogType_ == 2) {
                //ÂFœhԂ
                g.setColor(g.getColorOfRGB(0x20,0x20,0x40,0xD0));
                g.fillRect(x + 1*scale,
                        y + DIALOG_HEIGHT_LINE + 3*scale,
                        w - 2*scale,
                        h - DIALOG_HEIGHT_LINE - 4*scale);
            }

            //g1
            g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
            g.drawPolyline(x1, y1, 9);

            //g2
            g.setColor(g.getColorOfRGB(0,0,0));
            g.drawPolyline(x2, y2, 9);

            //{
            if (dialogType_ == 2) {
                //炵ĉet
                g.setColor(Graphics.getColorOfName(Graphics.BLACK));
                for (i = 0; i < ns.length; i++) {
                    g.drawString(ns[i],
                            x + 8*scale + dm + 1*scale,
                            y + DIALOG_HEIGHT_LINE*(i+1) + DIALOG_BASE_LINE + 5*scale);
                }
                g.setColor(Graphics.getColorOfName(Graphics.WHITE));
            } else {
                g.setColor(Graphics.getColorOfName(Graphics.BLACK));
            }
            for (i = 0; i < ns.length; i++) {
                g.drawString(ns[i],
                        x + 8*scale + dm,
                        y + DIALOG_HEIGHT_LINE*(i+1) + DIALOG_BASE_LINE + 5*scale);
            }
        }

        //{^\
        if (button2 != "") {
            // Q{^
            dialogButton(button1,
                    x + (w-(bw+10*scale+bw))/2,
                    y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
                    dialogYes,
                    dialogYes && dialogPressed);
            dialogButton(button2,
                    x + (w-(bw+10*scale+bw))/2 + 10*scale + bw,
                    y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
                    !dialogYes,
                    !dialogYes && dialogPressed);
        } else {
            // P{^
            dialogButton(button1,
                    x + (w-bw)/2,
                    y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
                    false,
                    dialogPressed);
        }
    }

    public void alert(final String s) {
        while (getKeypadState() != 0){
            try {
                Thread.sleep(10L);
            } catch (Exception ex) {}
        }
        if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
            Dialog dialog = new Dialog(Dialog.DIALOG_ERROR, "G[I");
            dialog.setText(s);
            dialog.show();
            messageStr = "";
            refreshDisplay();
        } else {
            if (!dialogReleased) {
                svMode = mode_;
                mode_ = MODE_DIALOG;
                dialogMode = Dialog.DIALOG_ERROR;
                dialogMessage = s;
                repaint();
            } else {
                // ɂ͓BȂ͂
                dialogReleased = false;
                dialogShowed = false;
                messageStr = "";
                refreshDisplay();
            }
        }
    }

    public void infomsg(final String s) {
        while (getKeypadState() != 0){
            try {
                Thread.sleep(10L);
            } catch (Exception ex) {}
        }
        if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
            Dialog dialog = new Dialog(Dialog.DIALOG_INFO , "");
            dialog.setText(s);
            dialog.show();
            refreshDisplay();
        } else {
            if (!dialogReleased) {
                svMode = mode_;
                mode_ = MODE_DIALOG;
                dialogMode = Dialog.DIALOG_INFO;
                dialogMessage = s;
                repaint();
            } else {
                // ɂ͓BȂ͂
                dialogReleased = false;
                dialogShowed = false;
                refreshDisplay();
            }
        }
    }

    public boolean confirm(final String s) {
        while (getKeypadState() != 0){
            try {
                Thread.sleep(10L);
            } catch (Exception ex) {}
        }
        boolean ret;
        if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
            Dialog dialog = new Dialog(Dialog.DIALOG_YESNO, "mF");
            dialog.setText(s);
            ret = (dialog.show() == Dialog.BUTTON_YES);
            refreshDisplay();
        } else {
            if (!dialogReleased) {
                svMode = mode_;
                mode_ = MODE_DIALOG;
                dialogMode = Dialog.DIALOG_YESNO;
                dialogYes = true;
                dialogMessage = s;
                repaint();
                ret = false;
            } else {
                dialogReleased = false;
                dialogShowed = false;
                ret = dialogYes;
                refreshDisplay();
            }
        }
        return ret;
    }

    private int incNo(int no, final int add, final int max) {
        no += add;
        if (no < 0) {
            no += max;
        }
        no %= max;
        return no;
    }

    private String formatNumber(final int num, final int size) {
        String str = String.valueOf(num);
        while (str.length() < size) {
            str = "0" + str;
        }
        return str;
    }

    private String formatSpace(final String str, final int size) {
        String ret;
        byte[] inbyte = str.getBytes();
        if (inbyte.length > size) {
            ret = new String(inbyte, 0, size);
        } else {
            ret = str;
        }
        while (ret.getBytes().length < size) {
            ret = ret.concat(" ");
        }
        return ret;
    }

    private String[] split(String fromstr, char sptc, int max_size){
        int idx1 = 0 , idx2 = 0, i;
        String[] splt = new String[max_size];
        for(i=0; idx2<fromstr.length() - 1; i++){
            if (i > max_size) break;
            idx2 = fromstr.indexOf(sptc, idx1);
            if(idx2 == -1) idx2 = fromstr.length() - 1;
            splt[i] = fromstr.substring(idx1, idx2);
            idx1 = idx2+1;
        }
        String[] re = new String[i];
        for(int j=0; j<re.length; j++) re[j] = splt[j];
        return re;
    }

    //  s  c ؂Ƃ w Ɏ܂Pʂɕĕԋp
    // tHgTCY MENU_DEFAULT_FONT gp
    //  []s ̐擪 c ̎͐@\Ȃ
    private String[] splitString(String s, String c, int w) {
        int start = 0;
        int end = 1;
        int length = s.length();
        int line = 0;
        while (end <= length) {
            if (c != "" && s.startsWith(c, end - 1)) {
                start = end;
                end = start + 1;
                line++;
            } else if (w > 0 && MENU_DEFAULT_FONT.stringWidth(s.substring(start, end)) > w) {
                start = end - 1;
                end = start + 1;
                line++;
            } else {
                end++;
            }
        }
        if (s.substring(start, end - 1).length() > 0) {
            line++;
        }

        String[] ss = new String[line];
        start = 0;
        end = 1;
        line = 0;
        while (end <= length) {
            if (c != "" && s.startsWith(c, end - 1)) {
                ss[line] = s.substring(start, end - 1);
                start = end;
                end = start + 1;
                line++;
            } else if (w > 0 && MENU_DEFAULT_FONT.stringWidth(s.substring(start, end)) > w) {
                ss[line] = s.substring(start, end - 1);
                start = end - 1;
                end = start + 1;
                line++;
            } else {
                end++;
            }
        }
        if (s.substring(start, end - 1).length() > 0) {
            ss[line] = s.substring(start, end - 1);
        }
        return ss;
    }

    private void keyStr2Vector(final int num) {
        int idx = 0;
        int pre = 0;
        Vector vec = new Vector();
        int ln = 0;
        while ((idx = keyconStr_[num].indexOf(",", pre)) != -1) {
            ln++;
            if (ln > 5) break;
            String key = keyconStr_[num].substring(pre, idx);
            vec.addElement(Integer.valueOf(key));
            pre = idx + 1;
        }
        keyConfig_[num] = new int[vec.size()];
        for (int i = 0; i < vec.size(); i++) {
            keyConfig_[num][i] = ((Integer) vec.elementAt(i)).intValue();
        }
    }

    private String keyStr2Desc(String keyStr) {
        int idx = 0;
        int pre = 0;
        int ln = 0;
        int n = 0;
        String keyDesc = "";
        while ((idx = keyStr.indexOf(",", pre)) != -1) {
            ln++;
            if (ln > 5) break;
            String key = keyStr.substring(pre, idx);
            n = Integer.parseInt(key);
            if (n > KEY_DESC.length) n = KEY_DESC.length;
            if (keyDesc.length() == 0) {
                keyDesc = KEY_DESC[n];
            } else {
                keyDesc += ", " + KEY_DESC[n];
            }
            pre = idx + 1;
        }
        return keyDesc;
    }

    private String keyStr2Desc(int key) {
        if (key < 0) return "";
        String keyDesc = "";
        if (key > KEY_DESC.length)
            keyDesc = KEY_DESC[KEY_DESC.length];
        else
            keyDesc = KEY_DESC[key];
        return keyDesc;
    }

    private boolean isReverse() {
        boolean rt;
        if (reverseEnable_) {
            try {
                switch(PhoneSystem.getAttribute(PhoneSystem2.DEV_DISPLAY_STYLE)){
                    case PhoneSystem2.ATTR_DISPLAY_STYLE_REVERSE :
                        //P905J
                        rt = true;
                        break;
                    default :
                        rt = false;
                }
            } catch (Exception ex) {
                rt = false;
            }
        } else {
            rt = false;
        }
        return rt;
    }

    private int isRotate() {
        int rt = -1;
        if (rotateEnable_) {
            try {
                switch(PhoneSystem.getAttribute(PhoneSystem2.DEV_DISPLAY_STYLE)){
                    case PhoneSystem2.ATTR_DISPLAY_STYLE_HORIZONTAL_LEFT :
                        //Fxxx|
                        rt = 1;
                        break;
                    case PhoneSystem2.ATTR_DISPLAY_STYLE_HORIZONTAL_RIGHT :
                        //FxxxE|
                        rt = 2;
                        break;
                    default :
                        rt = 0;
                }
            } catch (Exception ex) {
                rt = -1;
            }
        } else {
            rt = -1;
        }
        return rt;
    }

    private void setFlipModeKey() {
        boolean rev = false;
        int tmp;
        if (rotateEnable_) {
            if (widedisplay_) {
                switch (flipMode_) {
                    case 0 : //ʏ
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 2;
                                break;
                            case 1 : //
                            //    flipModeKey_ = 3;
                            //    break;
                            case 2 : //E
                                flipModeKey_ = 1;
                                break;
                            default :
                                flipModeKey_ = 0;
                                break;
                        }
                        break;
                    case 1 : //E
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 3;
                                break;
                            case 1 : //
                            //    flipModeKey_ = 0;
                            //    break;
                            case 2 : //E
                                flipModeKey_ = 2;
                                break;
                            default :
                                flipModeKey_ = 1;
                                break;
                        }
                        break;
                    case 2 : //180
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 0;
                                break;
                            case 1 : //
                            //    flipModeKey_ = 1;
                            //    break;
                            case 2 : //E
                                flipModeKey_ = 3;
                                break;
                            default :
                                flipModeKey_ = 2;
                                break;
                        }
                        break;
                    case 3 : //
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 1;
                                break;
                            case 1 : //
                            //    flipModeKey_ = 2;
                            //    break;
                            case 2 : //E
                                flipModeKey_ = 0;
                                break;
                            default :
                                flipModeKey_ = 3;
                                break;
                        }
                        break;
                    default :
                        flipModeKey_ = 0;
                        break;
                }
            } else {
                switch (flipMode_) {
                    case 0 : //ʏ
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 0;
                                break;
                            case 1 : //
                                flipModeKey_ = 1;
                                break;
                            case 2 : //E
                                flipModeKey_ = 3;
                                break;
                        }
                        break;
                    case 1 : //E
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 1;
                                break;
                            case 1 : //
                                flipModeKey_ = 2;
                                break;
                            case 2 : //E
                                flipModeKey_ = 0;
                                break;
                        }
                        break;
                    case 2 : //180
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 2;
                                break;
                            case 1 : //
                                flipModeKey_ = 3;
                                break;
                            case 2 : //E
                                flipModeKey_ = 1;
                                break;
                        }
                        break;
                    case 3 : //
                        switch (isRotate()) {
                            case 0 : //ʏ
                                flipModeKey_ = 3;
                                break;
                            case 1 : //
                                flipModeKey_ = 0;
                                break;
                            case 2 : //E
                                flipModeKey_ = 2;
                                break;
                        }
                        break;
                    default :
                        flipModeKey_ = 0;
                        break;
                }
            }
        } else {
            rev = isReverse();
            switch (flipMode_) {
                case 0 : //ʏ
                    flipModeKey_ = rev ? 1 : 0;
                    break;
                case 1 : //E
                    flipModeKey_ = rev ? 2 : 1;
                    break;
                case 2 : //180
                    flipModeKey_ = rev ? 3 : 2;
                    break;
                case 3 : //
                    flipModeKey_ = rev ? 0 : 3;
                    break;
                default :
                    flipModeKey_ = 0;
                    break;
            }
        }
        switch (flipModeKey_) {
			//ʎ
			case 1 :
			case 3 :
				if (widedisplay_) {
                    width = getWidth();
                    height = getHeight();
				} else {
                    width = getHeight();
                    height = getWidth();
				}
				break;
			case 0 :
			case 2 :
				if (widedisplay_) {
                    width = getHeight();
                    height = getWidth();
				} else {
                    width = getWidth();
                    height = getHeight();
				}
				break;
        }
    }

    private void refreshDisplay() {
        try {
            Thread.sleep((long)wt_on_refresh_);
        } catch (Exception ex) {}
        setBackground(Graphics.getColorOfName(Graphics.BLACK));
        int modesave = mode_;
        mode_ = MODE_NONE;
        g.setFlipMode(Graphics.FLIP_NONE);
        g.clearRect(0, 0, getWidth(), getHeight());
        repaint();
        mode_ = modesave;
    }

    private void reboot() {
        core.request(NESCore.REQUEST_STOP, 0);
        while(core.exist);

        String url[] = new String[1];
        url[0] = IApplication.getCurrentApp().getSourceURL() + "NPLoader.jam";
        try {
            IApplication.getCurrentApp().launch(IApplication.LAUNCH_IAPPLI, url);
        } catch (Exception e) {
            alert("NPLoaderNłȂߏI܂");
            IApplication.getCurrentApp().terminate();
        }
    }

    private void reboot(String param, String value) {
        core.request(NESCore.REQUEST_STOP, 0);
        while(core.exist);

        String args[] = new String[3];
        args[0] = IApplication.getCurrentApp().getSourceURL() + "NPLoader.jam";
        args[1] = param;
        args[2] = value;
        try {
            IApplication.getCurrentApp().launch(IApplication.LAUNCH_IAPPLI, args);
        } catch (Exception e) {
            alert("NPLoaderNłȂߏI܂");
            IApplication.getCurrentApp().terminate();
        }
    }

    private void bootCore(final int core_) {
        switch (core_) {
            case CORE_ORIGINAL :
                core = new NESCore_NP(this, psgi);
                break;

            case CORE_SOFTBANK :
                core = new NESCore_SB(this, psgi);
                break;

            case CORE_NEMUPLUS2 :
                core = new NESCore_NP2(this, psgi);
                break;

            default :
                break;
        }
        core.init();
        core.set_spmode(!noRomCache_);
    }


    /* ----------------------------------------------------- */

    //
    private void readSP_500() {
        DataInputStream in = null;
        DataOutputStream out = null;
        try {
            in = openSPInputStream(0, SIZE_SP_OTHERS_500);

            // VERSION擾
            int version = in.readInt();
            //NtO
            firstExec_ = in.readBoolean();
            if (version != 500) {
                in.close();
                in = null;
                return;
            }
            // FSAFPS\
            frameSkip_ = in.readInt();
            fpsOff_ = in.readBoolean();
            // NROMǂݍ
            startAndLoad_ = in.readBoolean();
            // ʉ]
            flipMode_ = in.readInt();
            // mFbZ[W
            confirmMsg_ = in.readInt();
            if ((confirmMsg_ & 0xC0) == 0) confirmMsg_ = 0xFE;
            // OSDROMԍ
            sdNo_ = in.readInt();
            // SDt@Cy[W
            sdPage_ = in.readInt();
            // j[
            alpha_ = in.readBoolean();
            // }CNL[ݒ
            mickey_ = in.readInt();
            if (mickey_ == 0) {
                // lʂ̂߁{PŕۑĂBݒȂO
                mickey_ = 11;
            }else{
                --mickey_;
            }
            // x(60FPS)
            sleep_ = in.readInt();
            // Eķ@\
            rSoftkey_ = in.readInt();
            if (rSoftkey_ == 4) {
                skeyMask_ = 0xFFFFFFFF;
            } else {
                skeyMask_ = 0xFFBFFFFF;
            }
            // j[wiF
            menuBGcolor_ = in.readInt();
            // TEho
            soundEnable = in.readInt();
            if (soundEnable > 1) soundEnable = 1;
            // TEhF
            sound_ = in.readInt();
            // TEhʒl
            soundVolume = in.readInt();
            if (soundVolume < 10) soundVolume = 100;
            // TEhChIt
            channelOff_[0] = in.readBoolean();
            channelOff_[1] = in.readBoolean();
            channelOff_[2] = in.readBoolean();
            channelOff_[3] = in.readBoolean();

            pcm_channelOff_[0] = in.readBoolean();
            pcm_channelOff_[1] = in.readBoolean();
            pcm_channelOff_[2] = in.readBoolean();
            pcm_channelOff_[3] = in.readBoolean();
            pcm_channelOff_[4] = in.readBoolean();
            pcm_channelOff_[5] = in.readBoolean();
            // TEhJX^Fԍ
            instNum_[0] = in.readInt();
            if (instNum_[0] == 0) instNum_[0] = 24;
            instNum_[1] = in.readInt();
            if (instNum_[1] == 0) instNum_[1] = 24;
            instNum_[2] = in.readInt();
            if (instNum_[2] == 0) instNum_[2] = 24;
            instNum_[3] = in.readInt();
            if (instNum_[3] == 0) instNum_[3] = 48;
            
            soundMode = in.readInt();
            soundSampleRate = in.readInt();
            soundBufCount = in.readInt();
                if (soundBufCount == 0) soundBufCount = 15;
            soundApuFilter = in.readInt();
            /////////////////////////////
            // ftHglݒ
            /////////////////////////////

            // 0ɂȂ̂ŃftHgl5ɂB
            if (frameSkip_ == 0) {
                frameSkip_ = 5;
            }
            svframeSkip_ = frameSkip_;
        } catch (Exception e) {
            alert("err readSP_500: " + e);
        } finally {
            try {
                in.close();
                in = null;
                out.close();
                out = null;
            } catch (Exception ex) {
                in = null;
                out = null;
            }
        }

    }

    private void readSPkeys_500() {
        // keyconfig
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    SIZE_SP_OTHERS_500,
                    SIZE_SP_KEYS_500);

            byte[] key = new byte[20];
            for (int i = 0; i < keyconStr_.length; i++) {
                in.read(key);
                if (key[0] == 0) {
                    keyconStr_[i] = "";
                } else {
                    keyconStr_[i] = new String(key).trim();
                }
                keyStr2Vector(i);
            }
            // ͋œĂ̂ŏ
            if (keyconStr_[0].equals("")) {
                keyconStr_ =
                    new String[] {
                        Display.KEY_3 + "," + Display.KEY_SELECT + ",",
                        Display.KEY_2 + "," + Display.KEY_SOFT2 + ",",
                        Display.KEY_5 + ",",
                        Display.KEY_6 + ",",
                        MY_KEY_UP + ",",
                        MY_KEY_DOWN + ",",
                        MY_KEY_LEFT + ",",
                        MY_KEY_RIGHT + ",",
                        Display.KEY_0 + ",",
                        Display.KEY_8 + ",",
                        Display.KEY_1 + ",",
                        Display.KEY_4 + ",",
                        };

                for (int i = 0; i < keyConfig_.length; i++) {
                    keyStr2Vector(i);
                }
                in.close();
            }
        } catch (Exception e) {
            alert("err readSPkeys_500: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPsaves_500() {
        // Z[u
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS_500 + SIZE_SP_KEYS_500),
                    SIZE_SP_SAVES_500);
            byte[] save = new byte[SIZE_SAVE_NAME];
            for (int i = 0; i < NUM_SAVE; i++) {
                in.read(save);
                if (save[0] == 0) {
                    saveStr_[i] = "";
                } else {
                    saveStr_[i] = new String(save);
                }
            }
        } catch (Exception e) {
            alert("err readSPsaves_500: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPadjusts_500() {
        // Z[u
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS_500 + SIZE_SP_KEYS_500 + SIZE_SP_SAVES_500),
                    SIZE_SP_ADJUST_500);
            byte[] data = new byte[SIZE_SP_ADJUST_500];
            in.read(data);
            for(int i = 0, pos = 0; i < (NUM_SDROM * MAX_SDROM_PAGE); i++, pos++) {
                if((pos % 2) == 0) {
                    sdRomadj_[i] = (int)((data[pos >> 1] >> 4) & 0xF) - 8;
                } else {
                    sdRomadj_[i] = (int)((data[pos >> 1]) & 0xF) - 8;
                }
                if(sdRomadj_[i] < -5 || sdRomadj_[i] > 5) sdRomadj_[i] = 0;
            }
        } catch (Exception e) {
            alert("err readSPadjusts_500: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }

    private void readSdromNameSP_500(final int page) {
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_SETTING_500 + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1)),
                    SIZE_ROM_NAME * NUM_SDROM);
            byte[] name = new byte[SIZE_ROM_NAME];
            for (int i = 0; i < NUM_SDROM; i++) {
                in.read(name);
                if (name[0] == 0) {
                    sdRomnm_[i] = "";
                } else {
                    sdRomnm_[i] = new String(name);
                }
            }
        } catch (Exception e) {
            alert("err readSdromNameSP_500: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }




    private void readSP_501() {
        DataInputStream in = null;
        DataOutputStream out = null;
        try {
            in = openSPInputStream(0, SIZE_SP_OTHERS_501);

            // VERSION擾
            int version = in.readInt();
            //NtO
            firstExec_ = in.readBoolean();
            if (version != 501) {
                in.close();
                in = null;
                return;
            }
            // FSAFPS\
            frameSkip_ = in.readInt();
            fpsOff_ = in.readBoolean();
            // NROMǂݍ
            startAndLoad_ = in.readBoolean();
            // ʉ]
            flipMode_ = in.readInt();
            // mFbZ[W
            confirmMsg_ = in.readInt();
            if ((confirmMsg_ & 0xC0) == 0) confirmMsg_ = 0xFE;
            // OSDROMԍ
            sdNo_ = in.readInt();
            // SDt@Cy[W
            sdPage_ = in.readInt();
            // j[
            alpha_ = in.readBoolean();
            // }CNL[ݒ
            mickey_ = in.readInt();
            if (mickey_ == 0) {
                // lʂ̂߁{PŕۑĂBݒȂO
                mickey_ = 11;
            }else{
                --mickey_;
            }
            // x(60FPS)
            sleep_ = in.readInt();
            // Eķ@\
            rSoftkey_ = in.readInt();
            if(rSoftkey_ > 8) rSoftkey_ = 8;
            if (rSoftkey_ == 4) {
                skeyMask_ = 0xFFFFFFFF;
            } else {
                skeyMask_ = 0xFFBFFFFF;
            }
            // j[wiF
            menuBGcolor_ = in.readInt();
            // TEho
            soundEnable = in.readInt();
            if (soundEnable > 1) soundEnable = 1;
            // TEhF
            sound_ = in.readInt();
            // TEhʒl
            soundVolume = in.readInt();
            if (soundVolume < 10) soundVolume = 100;
            // TEhChIt
            channelOff_[0] = in.readBoolean();
            channelOff_[1] = in.readBoolean();
            channelOff_[2] = in.readBoolean();
            channelOff_[3] = in.readBoolean();

            pcm_channelOff_[0] = in.readBoolean();
            pcm_channelOff_[1] = in.readBoolean();
            pcm_channelOff_[2] = in.readBoolean();
            pcm_channelOff_[3] = in.readBoolean();
            pcm_channelOff_[4] = in.readBoolean();
            pcm_channelOff_[5] = in.readBoolean();
            // TEhJX^Fԍ
            instNum_[0] = in.readInt();
            if (instNum_[0] == 0) instNum_[0] = 24;
            instNum_[1] = in.readInt();
            if (instNum_[1] == 0) instNum_[1] = 24;
            instNum_[2] = in.readInt();
            if (instNum_[2] == 0) instNum_[2] = 24;
            instNum_[3] = in.readInt();
            if (instNum_[3] == 0) instNum_[3] = 48;
            
            soundMode = in.readInt();
            soundSampleRate = in.readInt();
            soundBufCount = in.readInt();
                if (soundBufCount == 0) soundBufCount = 15;
            soundApuFilter = in.readInt();
            
            // ȉNP2I[fBI
            // TEhF
            np2_sound_ = in.readInt();
            if(np2_sound_ < PSGi.MODE_PRESET || np2_sound_ > PSGi.MODE_ROHM)
                np2_sound_ = PSGi.MODE_PRESET;
            // TEhChIt
            sCh1Off_ = in.readBoolean();
            sCh2Off_ = in.readBoolean();
            sCh3Off_ = in.readBoolean();
            sCh4Off_ = in.readBoolean();
            // TEhJX^Fԍ
            np2_instNum_[0] = in.readInt();
            if (np2_instNum_[0] == 0) np2_instNum_[0] = 80;
            np2_instNum_[1] = in.readInt();
            if (np2_instNum_[1] == 0) np2_instNum_[1] = 80;
            np2_instNum_[2] = in.readInt();
            if (np2_instNum_[2] == 0) np2_instNum_[2] = 80;
            np2_instNum_[3] = in.readInt();
            if (np2_instNum_[3] == 0) np2_instNum_[3] = 80;
            np2_instNum_[4] = in.readInt();
            if (np2_instNum_[4] == 0) np2_instNum_[4] = 127;
            sbuf_ = in.readInt();
            if (sbuf_ < 1 || sbuf_ > 60) sbuf_ = 16;

            // RAI
            core_ = in.readInt();

            // `惂[h
            zoom_ = in.readInt();
            svZoom_ = in.readInt();
            fpsDisp_ = in.readInt();
            if (fpsDisp_ == 3) fpsOff_ = true;
            else fpsOff_ = false;

            // ̑
            showSoftLabel_ = in.readBoolean();
            reverseEnable_ = in.readBoolean();
            wt_on_game_ = in.readInt();
            if (wt_on_game_ < 0) wt_on_game_ = 0;
            else if (wt_on_game_ > 10000) wt_on_game_ = 10000;
            wt_on_refresh_ = in.readInt();
            if (wt_on_refresh_ < 0) wt_on_refresh_ = 0;
            else if (wt_on_refresh_ > 10000) wt_on_refresh_ = 10000;

            // ƭۗp
            pointerEnable_ = in.readBoolean();
            pointerSense_ = in.readByte();
            pointerType_ = in.readBoolean();

            // L[ݒ2ʖ
            keycon2_[1] = in.readByte();
            keycon2_[2] = in.readByte();
            keycon2_[3] = in.readByte();
            keycon2_[4] = in.readByte();
            keycon2_[5] = in.readByte();
            keycon2_[6] = in.readByte();
            keycon2_[7] = in.readByte();
            keycon2_[8] = in.readByte();
            keycon2_[9] = in.readByte();

            // ̑(̂Q)
            use_vgafont_ = in.readBoolean();
            pos_x[0] = in.readInt();
            pos_y[0] = in.readInt();
            rotateEnable_ = in.readBoolean();
            /////////////////////////////
            // ftHglݒ
            /////////////////////////////

            // 0ɂȂ̂ŃftHgl5ɂB
            if (frameSkip_ == 0) {
                frameSkip_ = 5;
            }
            svframeSkip_ = frameSkip_;

            // 1ZĎgpB-1 疢ݒ
            for (int i = 3; i <= 9; i++) {
                keycon2_[i]--;
                if (keycon2_[i] >= 0) keycon2_set = true;
            }
            keycon2_[1]--;
            if (keycon2_[1] < 0) {
                MY_KEY_SOFT1 = Display.KEY_SOFT1;
                keycon2_[1] = (byte)Display.KEY_SOFT1;
            } else {
                MY_KEY_SOFT1 = (int)keycon2_[1];
            }
            keycon2_[2]--;
            if (keycon2_[2] < 0) {
                MY_KEY_SOFT2 = Display.KEY_SOFT2;
                keycon2_[2] = (byte)Display.KEY_SOFT2;
            } else {
                MY_KEY_SOFT2 = (int)keycon2_[2];
            }

            // t[̏TCY
            if (pos_x[0] < 0) pos_x[0] = 100;
            if (pos_y[0] < 0) pos_y[0] = 100;
            pos_x[1] = (pos_x[0] >> 16) & 0xFFFF;
            pos_y[1] = (pos_y[0] >> 16) & 0xFFFF;
            pos_x[0] &= 0xFFFF;
            pos_y[0] &= 0xFFFF;

        } catch (Exception e) {
            alert("err readSP: " + e);
        } finally {
            try {
                in.close();
                in = null;
                out.close();
                out = null;
            } catch (Exception ex) {
                in = null;
                out = null;
            }
        }

    }

    private void readSPkeys_501() {
        // keyconfig
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    SIZE_SP_OTHERS_501,
                    SIZE_SP_KEYS_501);

            byte[] key = new byte[20];
            for (int i = 0; i < keyconStr_.length; i++) {
                in.read(key);
                if (key[0] == 0) {
                    keyconStr_[i] = "";
                } else {
                    keyconStr_[i] = new String(key).trim();
                }
                keyStr2Vector(i);
            }
            // ͋œĂ̂ŏ
            if (keyconStr_[0].equals("")) {
                keyconStr_ =
                    new String[] {
                        Display.KEY_3 + "," + Display.KEY_SELECT + ",",
                        Display.KEY_2 + "," + Display.KEY_SOFT2 + ",",
                        Display.KEY_5 + ",",
                        Display.KEY_6 + ",",
                        Display.KEY_UP + ",",
                        Display.KEY_DOWN + ",",
                        Display.KEY_LEFT + ",",
                        Display.KEY_RIGHT + ",",
                        Display.KEY_0 + ",",
                        Display.KEY_8 + ",",
                        Display.KEY_1 + ",",
                        Display.KEY_4 + ",",
                        };

                for (int i = 0; i < keyConfig_.length; i++) {
                    keyStr2Vector(i);
                }
                in.close();
                writeSPkeys();
            }
        } catch (Exception e) {
            alert("err readSPkeys: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPsaves_501() {
        // Z[u
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS_501 + SIZE_SP_KEYS_501),
                    SIZE_SP_SAVES_501);
            byte[] save = new byte[SIZE_SAVE_NAME];
            for (int i = 0; i < NUM_SAVE; i++) {
                in.read(save);
                if (save[0] == 0) {
                    saveStr_[i] = "";
                } else {
                    saveStr_[i] = new String(save);
                }
            }
        } catch (Exception e) {
            alert("err readSPsaves: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }

    }

    private void readSPadjusts_501() {
        // Z[u
        DataInputStream in = null;
        try {
            in = openSPInputStream(
                    (SIZE_SP_OTHERS_501 + SIZE_SP_KEYS_501 + SIZE_SP_SAVES_501),
                    SIZE_SP_ADJUST_501);
            byte[] data = new byte[SIZE_SP_ADJUST_501];
            in.read(data);
            for(int i = 0, pos = 0; i < (NUM_SDROM * MAX_SDROM_PAGE); i++, pos++) {
                if((pos % 2) == 0) {
                    sdRomadj_[i] = (int)((data[pos >> 1] >> 4) & 0xF) - 8;
                } else {
                    sdRomadj_[i] = (int)((data[pos >> 1]) & 0xF) - 8;
                }
                if(sdRomadj_[i] < -5 || sdRomadj_[i] > 5) sdRomadj_[i] = 0;
            }
        } catch (Exception e) {
            alert("err readSPsaves: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }

    private void readSdromNameSP_501(final int page) {
        DataInputStream in = null;

        try {
            in = openSPInputStream(
                    (SIZE_SP_SETTING_501 + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1)),
                    SIZE_ROM_NAME * NUM_SDROM);
            byte[] name = new byte[SIZE_ROM_NAME];
            for (int i = 0; i < NUM_SDROM; i++) {
                in.read(name);
                if (name[0] == 0) {
                    sdRomnm_[i] = "";
                } else {
                    sdRomnm_[i] = new String(name);
                }
            }
        } catch (Exception e) {
            alert("err readSdromNameSP: " + e);
        } finally {
            try {
                in.close();
                in = null;
            } catch (Exception ex) {
                in = null;
            }
        }
    }




}
